{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.LrDleSolver
       (
         LrDleSolver,
         LrDleSolverClass(..),
         lrDleSolver__0,
         lrDleSolver__1,
         lrDleSolver__2,
         lrDleSolver_clone,
         lrDleSolver_doc,
         lrDleSolver_getSparsity__0,
         lrDleSolver_getSparsity__1,
         lrDleSolver_hasPlugin,
         lrDleSolver_loadPlugin,
         lrDleSolver_printStats,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__CONSTRUCTOR__0" c_casadi__LrDleSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr LrDleSolver')
casadi__LrDleSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO LrDleSolver
casadi__LrDleSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver__0 :: String -> String -> M.Map String Sparsity -> IO LrDleSolver
lrDleSolver__0 = casadi__LrDleSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__CONSTRUCTOR__1" c_casadi__LrDleSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr LrDleSolver')
casadi__LrDleSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO LrDleSolver
casadi__LrDleSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO LrDleSolver
lrDleSolver__1 = casadi__LrDleSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__CONSTRUCTOR__2" c_casadi__LrDleSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr LrDleSolver')
casadi__LrDleSolver__CONSTRUCTOR__2
  :: IO LrDleSolver
casadi__LrDleSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver__2 :: IO LrDleSolver
lrDleSolver__2 = casadi__LrDleSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__clone" c_casadi__LrDleSolver__clone
  :: Ptr (Ptr StdString) -> Ptr LrDleSolver' -> IO (Ptr LrDleSolver')
casadi__LrDleSolver__clone
  :: LrDleSolver -> IO LrDleSolver
casadi__LrDleSolver__clone x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__clone errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_clone :: LrDleSolverClass a => a -> IO LrDleSolver
lrDleSolver_clone x = casadi__LrDleSolver__clone (castLrDleSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__doc" c_casadi__LrDleSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__LrDleSolver__doc
  :: String -> IO String
casadi__LrDleSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_doc :: String -> IO String
lrDleSolver_doc = casadi__LrDleSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__getSparsity__0" c_casadi__LrDleSolver__getSparsity__0
  :: Ptr (Ptr StdString) -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr Sparsity')
casadi__LrDleSolver__getSparsity__0
  :: M.Map String Sparsity -> IO Sparsity
casadi__LrDleSolver__getSparsity__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__getSparsity__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_getSparsity__0 :: M.Map String Sparsity -> IO Sparsity
lrDleSolver_getSparsity__0 = casadi__LrDleSolver__getSparsity__0


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__getSparsity__1" c_casadi__LrDleSolver__getSparsity__1
  :: Ptr (Ptr StdString) -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdVec CInt) -> IO (Ptr Sparsity')
casadi__LrDleSolver__getSparsity__1
  :: M.Map String Sparsity -> Vector Int -> IO Sparsity
casadi__LrDleSolver__getSparsity__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__getSparsity__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_getSparsity__1 :: M.Map String Sparsity -> Vector Int -> IO Sparsity
lrDleSolver_getSparsity__1 = casadi__LrDleSolver__getSparsity__1


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__hasPlugin" c_casadi__LrDleSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__LrDleSolver__hasPlugin
  :: String -> IO Bool
casadi__LrDleSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_hasPlugin :: String -> IO Bool
lrDleSolver_hasPlugin = casadi__LrDleSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__loadPlugin" c_casadi__LrDleSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__LrDleSolver__loadPlugin
  :: String -> IO ()
casadi__LrDleSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_loadPlugin :: String -> IO ()
lrDleSolver_loadPlugin = casadi__LrDleSolver__loadPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LrDleSolver__printStats" c_casadi__LrDleSolver__printStats
  :: Ptr (Ptr StdString) -> Ptr LrDleSolver' -> IO ()
casadi__LrDleSolver__printStats
  :: LrDleSolver -> IO ()
casadi__LrDleSolver__printStats x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDleSolver__printStats errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDleSolver_printStats :: LrDleSolverClass a => a -> IO ()
lrDleSolver_printStats x = casadi__LrDleSolver__printStats (castLrDleSolver x)

