{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.SdpSolver
       (
         SdpSolver,
         SdpSolverClass(..),
         sdpSolver__0,
         sdpSolver__1,
         sdpSolver__2,
         sdpSolver_doc,
         sdpSolver_hasPlugin,
         sdpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__CONSTRUCTOR__0" c_casadi__SdpSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr SdpSolver')
casadi__SdpSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO SdpSolver
casadi__SdpSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver__0 :: String -> String -> M.Map String Sparsity -> IO SdpSolver
sdpSolver__0 = casadi__SdpSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__CONSTRUCTOR__1" c_casadi__SdpSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr SdpSolver')
casadi__SdpSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SdpSolver
casadi__SdpSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SdpSolver
sdpSolver__1 = casadi__SdpSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__CONSTRUCTOR__2" c_casadi__SdpSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr SdpSolver')
casadi__SdpSolver__CONSTRUCTOR__2
  :: IO SdpSolver
casadi__SdpSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver__2 :: IO SdpSolver
sdpSolver__2 = casadi__SdpSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__doc" c_casadi__SdpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__SdpSolver__doc
  :: String -> IO String
casadi__SdpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver_doc :: String -> IO String
sdpSolver_doc = casadi__SdpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__hasPlugin" c_casadi__SdpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__SdpSolver__hasPlugin
  :: String -> IO Bool
casadi__SdpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver_hasPlugin :: String -> IO Bool
sdpSolver_hasPlugin = casadi__SdpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__SdpSolver__loadPlugin" c_casadi__SdpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__SdpSolver__loadPlugin
  :: String -> IO ()
casadi__SdpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdpSolver_loadPlugin :: String -> IO ()
sdpSolver_loadPlugin = casadi__SdpSolver__loadPlugin

