#include <casadi/casadi.hpp>
#include <casadi/core/casadi_interrupt.hpp>
#include <cmath>
#include <stdexcept>
#include "../marshal.hpp"

// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__0"
// protoArgs: "(std::string ** err_msg, std::string* x0)"
// params: [Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__0(std::string ** err_msg, std::string* x0)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_)"
extern "C"
std::vector< std::string* >*
    IOScheme__0(std::string ** err_msg, std::string* x0);
std::vector< std::string* >*
    IOScheme__0(std::string ** err_msg, std::string* x0){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);

        std::vector< std::string > ret = casadi::IOScheme(x0_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1)"
// params: [Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__1(std::string ** err_msg, std::string* x0, std::string* x1)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_)"
extern "C"
std::vector< std::string* >*
    IOScheme__1(std::string ** err_msg, std::string* x0, std::string* x1);
std::vector< std::string* >*
    IOScheme__1(std::string ** err_msg, std::string* x0, std::string* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__2(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_)"
extern "C"
std::vector< std::string* >*
    IOScheme__2(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2);
std::vector< std::string* >*
    IOScheme__2(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__3(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< std::string* >*
    IOScheme__3(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< std::string* >*
    IOScheme__3(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__4(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< std::string* >*
    IOScheme__4(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< std::string* >*
    IOScheme__4(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__5(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< std::string* >*
    IOScheme__5(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< std::string* >*
    IOScheme__5(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__6(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< std::string* >*
    IOScheme__6(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< std::string* >*
    IOScheme__6(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__7(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< std::string* >*
    IOScheme__7(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< std::string* >*
    IOScheme__7(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__8(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< std::string* >*
    IOScheme__8(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< std::string* >*
    IOScheme__8(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__9(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< std::string* >*
    IOScheme__9(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< std::string* >*
    IOScheme__9(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__10(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< std::string* >*
    IOScheme__10(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< std::string* >*
    IOScheme__10(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__11(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< std::string* >*
    IOScheme__11(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< std::string* >*
    IOScheme__11(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__12(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< std::string* >*
    IOScheme__12(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< std::string* >*
    IOScheme__12(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__13(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::vector< std::string* >*
    IOScheme__13(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13);
std::vector< std::string* >*
    IOScheme__13(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__14(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::vector< std::string* >*
    IOScheme__14(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14);
std::vector< std::string* >*
    IOScheme__14(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__15(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::vector< std::string* >*
    IOScheme__15(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15);
std::vector< std::string* >*
    IOScheme__15(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        std::string& x15_ = Marshaling<std::string&,std::string*>::marshal(x15);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__16(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::vector< std::string* >*
    IOScheme__16(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16);
std::vector< std::string* >*
    IOScheme__16(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        std::string& x15_ = Marshaling<std::string&,std::string*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__17(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::vector< std::string* >*
    IOScheme__17(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17);
std::vector< std::string* >*
    IOScheme__17(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        std::string& x15_ = Marshaling<std::string&,std::string*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        std::string& x17_ = Marshaling<std::string&,std::string*>::marshal(x17);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__18(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::vector< std::string* >*
    IOScheme__18(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18);
std::vector< std::string* >*
    IOScheme__18(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        std::string& x15_ = Marshaling<std::string&,std::string*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        std::string& x17_ = Marshaling<std::string&,std::string*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18, std::string* x19)"
// params: [Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec StdString
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__19(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18, std::string* x19)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::vector< std::string* >*
    IOScheme__19(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18, std::string* x19);
std::vector< std::string* >*
    IOScheme__19(std::string ** err_msg, std::string* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12, std::string* x13, std::string* x14, std::string* x15, std::string* x16, std::string* x17, std::string* x18, std::string* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        std::string& x7_ = Marshaling<std::string&,std::string*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        std::string& x9_ = Marshaling<std::string&,std::string*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        std::string& x11_ = Marshaling<std::string&,std::string*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        std::string& x13_ = Marshaling<std::string&,std::string*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        std::string& x15_ = Marshaling<std::string&,std::string*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        std::string& x17_ = Marshaling<std::string&,std::string*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        std::string& x19_ = Marshaling<std::string&,std::string*>::marshal(x19);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__20"
// protoArgs: "(std::string ** err_msg)"
// params: []
// retType: StdVec StdString
// args: "()"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__20(std::string ** err_msg)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme()"
extern "C"
std::vector< std::string* >*
    IOScheme__20(std::string ** err_msg);
std::vector< std::string* >*
    IOScheme__20(std::string ** err_msg){
    try {

        std::vector< std::string > ret = casadi::IOScheme();
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__21"
// protoArgs: "(std::string ** err_msg, std::vector< std::string* >* x0)"
// params: [Ref (Const (StdVec StdString))]
// retType: StdVec StdString
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__21(std::string ** err_msg, std::vector< std::string* >* x0)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_)"
extern "C"
std::vector< std::string* >*
    IOScheme__21(std::string ** err_msg, std::vector< std::string* >* x0);
std::vector< std::string* >*
    IOScheme__21(std::string ** err_msg, std::vector< std::string* >* x0){
    try {
        std::vector< std::string > x0_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x0);

        std::vector< std::string > ret = casadi::IOScheme(x0_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__22"
// protoArgs: "(std::string ** err_msg, std::vector< std::string* >* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (StdVec StdString)),Ref (Const (StdVec StdString))]
// retType: StdVec StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__22(std::string ** err_msg, std::vector< std::string* >* x0, std::vector< std::string* >* x1)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_, x1_)"
extern "C"
std::vector< std::string* >*
    IOScheme__22(std::string ** err_msg, std::vector< std::string* >* x0, std::vector< std::string* >* x1);
std::vector< std::string* >*
    IOScheme__22(std::string ** err_msg, std::vector< std::string* >* x0, std::vector< std::string* >* x1){
    try {
        std::vector< std::string > x0_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::vector< std::string > ret = casadi::IOScheme(x0_, x1_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::IOScheme" ===============
// cppName: "casadi::IOScheme"
// cWrapperName: "IOScheme__23"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: StdVec StdString
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::string* >*"
// proto: "std::vector< std::string* >*\n    IOScheme__23(std::string ** err_msg, int x0)"
// friendWrap: False
// fName: "IOScheme"
// call: "casadi::IOScheme(x0_)"
extern "C"
std::vector< std::string* >*
    IOScheme__23(std::string ** err_msg, int x0);
std::vector< std::string* >*
    IOScheme__23(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        std::vector< std::string > ret = casadi::IOScheme(x0_);
        return WrapReturn< std::vector< std::string* >*, std::vector< std::string > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_abs" ===============
// cppName: "casadi::casadi_abs"
// cWrapperName: "casadi_abs__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_abs__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_abs"
// call: "abs(x0_)"
extern "C"
casadi::SX*
    casadi_abs__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_abs__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = abs(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_abs" ===============
// cppName: "casadi::casadi_abs"
// cWrapperName: "casadi_abs__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_abs__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_abs"
// call: "abs(x0_)"
extern "C"
casadi::DMatrix*
    casadi_abs__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_abs__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = abs(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_abs" ===============
// cppName: "casadi::casadi_abs"
// cWrapperName: "casadi_abs__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_abs__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_abs"
// call: "abs(x0_)"
extern "C"
casadi::IMatrix*
    casadi_abs__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_abs__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = abs(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_abs" ===============
// cppName: "casadi::casadi_abs"
// cWrapperName: "casadi_abs__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_abs__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_abs"
// call: "abs(x0_)"
extern "C"
casadi::MX*
    casadi_abs__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_abs__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = abs(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acos" ===============
// cppName: "casadi::casadi_acos"
// cWrapperName: "casadi_acos__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_acos__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_acos"
// call: "acos(x0_)"
extern "C"
casadi::SX*
    casadi_acos__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_acos__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = acos(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acos" ===============
// cppName: "casadi::casadi_acos"
// cWrapperName: "casadi_acos__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_acos__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_acos"
// call: "acos(x0_)"
extern "C"
casadi::DMatrix*
    casadi_acos__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_acos__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = acos(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acos" ===============
// cppName: "casadi::casadi_acos"
// cWrapperName: "casadi_acos__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_acos__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_acos"
// call: "acos(x0_)"
extern "C"
casadi::IMatrix*
    casadi_acos__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_acos__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = acos(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acos" ===============
// cppName: "casadi::casadi_acos"
// cWrapperName: "casadi_acos__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_acos__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_acos"
// call: "acos(x0_)"
extern "C"
casadi::MX*
    casadi_acos__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_acos__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = acos(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acosh" ===============
// cppName: "casadi::casadi_acosh"
// cWrapperName: "casadi_acosh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_acosh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_acosh"
// call: "acosh(x0_)"
extern "C"
casadi::SX*
    casadi_acosh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_acosh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = acosh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acosh" ===============
// cppName: "casadi::casadi_acosh"
// cWrapperName: "casadi_acosh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_acosh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_acosh"
// call: "acosh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_acosh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_acosh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = acosh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acosh" ===============
// cppName: "casadi::casadi_acosh"
// cWrapperName: "casadi_acosh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_acosh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_acosh"
// call: "acosh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_acosh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_acosh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = acosh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_acosh" ===============
// cppName: "casadi::casadi_acosh"
// cWrapperName: "casadi_acosh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_acosh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_acosh"
// call: "acosh(x0_)"
extern "C"
casadi::MX*
    casadi_acosh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_acosh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = acosh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_adj" ===============
// cppName: "casadi::casadi_adj"
// cWrapperName: "casadi_adj__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_adj__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_adj"
// call: "adj(x0_)"
extern "C"
casadi::SX*
    casadi_adj__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_adj__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = adj(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_adj" ===============
// cppName: "casadi::casadi_adj"
// cWrapperName: "casadi_adj__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_adj__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_adj"
// call: "adj(x0_)"
extern "C"
casadi::DMatrix*
    casadi_adj__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_adj__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = adj(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_adj" ===============
// cppName: "casadi::casadi_adj"
// cWrapperName: "casadi_adj__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_adj__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_adj"
// call: "adj(x0_)"
extern "C"
casadi::IMatrix*
    casadi_adj__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_adj__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = adj(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_all" ===============
// cppName: "casadi::casadi_all"
// cWrapperName: "casadi_all__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_all__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_all"
// call: "all(x0_)"
extern "C"
casadi::SX*
    casadi_all__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_all__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = all(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_all" ===============
// cppName: "casadi::casadi_all"
// cWrapperName: "casadi_all__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_all__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_all"
// call: "all(x0_)"
extern "C"
casadi::DMatrix*
    casadi_all__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_all__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = all(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_all" ===============
// cppName: "casadi::casadi_all"
// cWrapperName: "casadi_all__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_all__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_all"
// call: "all(x0_)"
extern "C"
casadi::IMatrix*
    casadi_all__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_all__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = all(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_and" ===============
// cppName: "casadi::casadi_and"
// cWrapperName: "casadi_and__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_and__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_and"
// call: "x0_ && x1_"
extern "C"
casadi::SX*
    casadi_and__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_and__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ && x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_and" ===============
// cppName: "casadi::casadi_and"
// cWrapperName: "casadi_and__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_and__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_and"
// call: "x0_ && x1_"
extern "C"
casadi::DMatrix*
    casadi_and__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_and__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ && x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_and" ===============
// cppName: "casadi::casadi_and"
// cWrapperName: "casadi_and__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_and__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_and"
// call: "x0_ && x1_"
extern "C"
casadi::IMatrix*
    casadi_and__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_and__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ && x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_and" ===============
// cppName: "casadi::casadi_and"
// cWrapperName: "casadi_and__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_and__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_and"
// call: "x0_ && x1_"
extern "C"
casadi::MX*
    casadi_and__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_and__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ && x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_any" ===============
// cppName: "casadi::casadi_any"
// cWrapperName: "casadi_any__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_any__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_any"
// call: "any(x0_)"
extern "C"
casadi::SX*
    casadi_any__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_any__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = any(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_any" ===============
// cppName: "casadi::casadi_any"
// cWrapperName: "casadi_any__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_any__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_any"
// call: "any(x0_)"
extern "C"
casadi::DMatrix*
    casadi_any__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_any__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = any(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_any" ===============
// cppName: "casadi::casadi_any"
// cWrapperName: "casadi_any__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_any__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_any"
// call: "any(x0_)"
extern "C"
casadi::IMatrix*
    casadi_any__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_any__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = any(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asin" ===============
// cppName: "casadi::casadi_asin"
// cWrapperName: "casadi_asin__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_asin__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_asin"
// call: "asin(x0_)"
extern "C"
casadi::SX*
    casadi_asin__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_asin__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = asin(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asin" ===============
// cppName: "casadi::casadi_asin"
// cWrapperName: "casadi_asin__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_asin__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_asin"
// call: "asin(x0_)"
extern "C"
casadi::DMatrix*
    casadi_asin__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_asin__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = asin(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asin" ===============
// cppName: "casadi::casadi_asin"
// cWrapperName: "casadi_asin__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_asin__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_asin"
// call: "asin(x0_)"
extern "C"
casadi::IMatrix*
    casadi_asin__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_asin__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = asin(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asin" ===============
// cppName: "casadi::casadi_asin"
// cWrapperName: "casadi_asin__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_asin__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_asin"
// call: "asin(x0_)"
extern "C"
casadi::MX*
    casadi_asin__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_asin__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = asin(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asinh" ===============
// cppName: "casadi::casadi_asinh"
// cWrapperName: "casadi_asinh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_asinh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_asinh"
// call: "asinh(x0_)"
extern "C"
casadi::SX*
    casadi_asinh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_asinh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = asinh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asinh" ===============
// cppName: "casadi::casadi_asinh"
// cWrapperName: "casadi_asinh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_asinh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_asinh"
// call: "asinh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_asinh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_asinh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = asinh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asinh" ===============
// cppName: "casadi::casadi_asinh"
// cWrapperName: "casadi_asinh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_asinh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_asinh"
// call: "asinh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_asinh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_asinh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = asinh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_asinh" ===============
// cppName: "casadi::casadi_asinh"
// cWrapperName: "casadi_asinh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_asinh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_asinh"
// call: "asinh(x0_)"
extern "C"
casadi::MX*
    casadi_asinh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_asinh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = asinh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan" ===============
// cppName: "casadi::casadi_atan"
// cWrapperName: "casadi_atan__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_atan__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_atan"
// call: "atan(x0_)"
extern "C"
casadi::SX*
    casadi_atan__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_atan__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = atan(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan" ===============
// cppName: "casadi::casadi_atan"
// cWrapperName: "casadi_atan__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_atan__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_atan"
// call: "atan(x0_)"
extern "C"
casadi::DMatrix*
    casadi_atan__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_atan__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = atan(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan" ===============
// cppName: "casadi::casadi_atan"
// cWrapperName: "casadi_atan__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_atan__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_atan"
// call: "atan(x0_)"
extern "C"
casadi::IMatrix*
    casadi_atan__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_atan__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = atan(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan" ===============
// cppName: "casadi::casadi_atan"
// cWrapperName: "casadi_atan__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_atan__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_atan"
// call: "atan(x0_)"
extern "C"
casadi::MX*
    casadi_atan__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_atan__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = atan(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan2" ===============
// cppName: "casadi::casadi_atan2"
// cWrapperName: "casadi_atan2__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_atan2__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_atan2"
// call: "atan2(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_atan2__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_atan2__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = atan2(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan2" ===============
// cppName: "casadi::casadi_atan2"
// cWrapperName: "casadi_atan2__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_atan2__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_atan2"
// call: "atan2(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_atan2__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_atan2__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = atan2(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan2" ===============
// cppName: "casadi::casadi_atan2"
// cWrapperName: "casadi_atan2__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_atan2__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_atan2"
// call: "atan2(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_atan2__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_atan2__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = atan2(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atan2" ===============
// cppName: "casadi::casadi_atan2"
// cWrapperName: "casadi_atan2__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_atan2__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_atan2"
// call: "atan2(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_atan2__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_atan2__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = atan2(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atanh" ===============
// cppName: "casadi::casadi_atanh"
// cWrapperName: "casadi_atanh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_atanh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_atanh"
// call: "atanh(x0_)"
extern "C"
casadi::SX*
    casadi_atanh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_atanh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = atanh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atanh" ===============
// cppName: "casadi::casadi_atanh"
// cWrapperName: "casadi_atanh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_atanh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_atanh"
// call: "atanh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_atanh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_atanh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = atanh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atanh" ===============
// cppName: "casadi::casadi_atanh"
// cWrapperName: "casadi_atanh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_atanh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_atanh"
// call: "atanh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_atanh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_atanh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = atanh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_atanh" ===============
// cppName: "casadi::casadi_atanh"
// cWrapperName: "casadi_atanh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_atanh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_atanh"
// call: "atanh(x0_)"
extern "C"
casadi::MX*
    casadi_atanh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_atanh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = atanh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_blockcat__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_blockcat__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3);
casadi::SX*
    casadi_blockcat__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        casadi::SX ret = blockcat(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__1"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::SX* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_blockcat__1(std::string ** err_msg, std::vector< std::vector< casadi::SX* >* >* x0)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_)"
extern "C"
casadi::SX*
    casadi_blockcat__1(std::string ** err_msg, std::vector< std::vector< casadi::SX* >* >* x0);
casadi::SX*
    casadi_blockcat__1(std::string ** err_msg, std::vector< std::vector< casadi::SX* >* >* x0){
    try {
        std::vector< std::vector< casadi::SX > > x0_ = Marshaling<std::vector< std::vector< casadi::SX > >,std::vector< std::vector< casadi::SX* >* >*>::marshal(x0);

        casadi::SX ret = blockcat(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_blockcat__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_blockcat__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3);
casadi::DMatrix*
    casadi_blockcat__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        casadi::DMatrix ret = blockcat(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__3"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::DMatrix* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_blockcat__3(std::string ** err_msg, std::vector< std::vector< casadi::DMatrix* >* >* x0)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_)"
extern "C"
casadi::DMatrix*
    casadi_blockcat__3(std::string ** err_msg, std::vector< std::vector< casadi::DMatrix* >* >* x0);
casadi::DMatrix*
    casadi_blockcat__3(std::string ** err_msg, std::vector< std::vector< casadi::DMatrix* >* >* x0){
    try {
        std::vector< std::vector< casadi::DMatrix > > x0_ = Marshaling<std::vector< std::vector< casadi::DMatrix > >,std::vector< std::vector< casadi::DMatrix* >* >*>::marshal(x0);

        casadi::DMatrix ret = blockcat(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_blockcat__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_blockcat__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3);
casadi::IMatrix*
    casadi_blockcat__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        casadi::IMatrix& x3_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x3);

        casadi::IMatrix ret = blockcat(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__5"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::IMatrix* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_blockcat__5(std::string ** err_msg, std::vector< std::vector< casadi::IMatrix* >* >* x0)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_)"
extern "C"
casadi::IMatrix*
    casadi_blockcat__5(std::string ** err_msg, std::vector< std::vector< casadi::IMatrix* >* >* x0);
casadi::IMatrix*
    casadi_blockcat__5(std::string ** err_msg, std::vector< std::vector< casadi::IMatrix* >* >* x0){
    try {
        std::vector< std::vector< casadi::IMatrix > > x0_ = Marshaling<std::vector< std::vector< casadi::IMatrix > >,std::vector< std::vector< casadi::IMatrix* >* >*>::marshal(x0);

        casadi::IMatrix ret = blockcat(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, casadi::MX* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_blockcat__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, casadi::MX* x3)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_, x1_, x2_, x3_)"
extern "C"
casadi::MX*
    casadi_blockcat__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, casadi::MX* x3);
casadi::MX*
    casadi_blockcat__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, casadi::MX* x3){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        casadi::MX ret = blockcat(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__7"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::MX* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_blockcat__7(std::string ** err_msg, std::vector< std::vector< casadi::MX* >* >* x0)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_)"
extern "C"
casadi::MX*
    casadi_blockcat__7(std::string ** err_msg, std::vector< std::vector< casadi::MX* >* >* x0);
casadi::MX*
    casadi_blockcat__7(std::string ** err_msg, std::vector< std::vector< casadi::MX* >* >* x0){
    try {
        std::vector< std::vector< casadi::MX > > x0_ = Marshaling<std::vector< std::vector< casadi::MX > >,std::vector< std::vector< casadi::MX* >* >*>::marshal(x0);

        casadi::MX ret = blockcat(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__8"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2, casadi::Sparsity* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_blockcat__8(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2, casadi::Sparsity* x3)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_, x1_, x2_, x3_)"
extern "C"
casadi::Sparsity*
    casadi_blockcat__8(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2, casadi::Sparsity* x3);
casadi::Sparsity*
    casadi_blockcat__8(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2, casadi::Sparsity* x3){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        casadi::Sparsity& x2_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        casadi::Sparsity ret = blockcat(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blockcat" ===============
// cppName: "casadi::casadi_blockcat"
// cWrapperName: "casadi_blockcat__9"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_blockcat__9(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// friendWrap: True
// fName: "casadi_blockcat"
// call: "blockcat(x0_)"
extern "C"
casadi::Sparsity*
    casadi_blockcat__9(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0);
casadi::Sparsity*
    casadi_blockcat__9(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);

        casadi::Sparsity ret = blockcat(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::SX* >* >*"
// proto: "std::vector< std::vector< casadi::SX* >* >*\n    casadi_blocksplit__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_)"
extern "C"
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__0(std::string ** err_msg, casadi::SX* x0);
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        std::vector< std::vector< casadi::SX > > ret = blocksplit(x0_);
        return WrapReturn< std::vector< std::vector< casadi::SX* >* >*, std::vector< std::vector< casadi::SX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::SX* >* >*"
// proto: "std::vector< std::vector< casadi::SX* >* >*\n    casadi_blocksplit__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__1(std::string ** err_msg, casadi::SX* x0, int x1);
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< std::vector< casadi::SX > > ret = blocksplit(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::SX* >* >*, std::vector< std::vector< casadi::SX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::SX* >* >*"
// proto: "std::vector< std::vector< casadi::SX* >* >*\n    casadi_blocksplit__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< std::vector< casadi::SX > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::SX* >* >*, std::vector< std::vector< casadi::SX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__3"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::SX* >* >*"
// proto: "std::vector< std::vector< casadi::SX* >* >*\n    casadi_blocksplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< std::vector< casadi::SX* >* >*
    casadi_blocksplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< std::vector< casadi::SX > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::SX* >* >*, std::vector< std::vector< casadi::SX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::DMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::DMatrix* >* >*\n    casadi_blocksplit__4(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_)"
extern "C"
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__4(std::string ** err_msg, casadi::DMatrix* x0);
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__4(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        std::vector< std::vector< casadi::DMatrix > > ret = blocksplit(x0_);
        return WrapReturn< std::vector< std::vector< casadi::DMatrix* >* >*, std::vector< std::vector< casadi::DMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::DMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::DMatrix* >* >*\n    casadi_blocksplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1);
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< std::vector< casadi::DMatrix > > ret = blocksplit(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::DMatrix* >* >*, std::vector< std::vector< casadi::DMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__6"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::DMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::DMatrix* >* >*\n    casadi_blocksplit__6(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__6(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__6(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< std::vector< casadi::DMatrix > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::DMatrix* >* >*, std::vector< std::vector< casadi::DMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__7"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::DMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::DMatrix* >* >*\n    casadi_blocksplit__7(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__7(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< std::vector< casadi::DMatrix* >* >*
    casadi_blocksplit__7(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< std::vector< casadi::DMatrix > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::DMatrix* >* >*, std::vector< std::vector< casadi::DMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::IMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::IMatrix* >* >*\n    casadi_blocksplit__8(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_)"
extern "C"
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__8(std::string ** err_msg, casadi::IMatrix* x0);
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__8(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        std::vector< std::vector< casadi::IMatrix > > ret = blocksplit(x0_);
        return WrapReturn< std::vector< std::vector< casadi::IMatrix* >* >*, std::vector< std::vector< casadi::IMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__9"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::IMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::IMatrix* >* >*\n    casadi_blocksplit__9(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__9(std::string ** err_msg, casadi::IMatrix* x0, int x1);
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__9(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< std::vector< casadi::IMatrix > > ret = blocksplit(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::IMatrix* >* >*, std::vector< std::vector< casadi::IMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__10"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::IMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::IMatrix* >* >*\n    casadi_blocksplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< std::vector< casadi::IMatrix > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::IMatrix* >* >*, std::vector< std::vector< casadi::IMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__11"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::IMatrix* >* >*"
// proto: "std::vector< std::vector< casadi::IMatrix* >* >*\n    casadi_blocksplit__11(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__11(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< std::vector< casadi::IMatrix* >* >*
    casadi_blocksplit__11(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< std::vector< casadi::IMatrix > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::IMatrix* >* >*, std::vector< std::vector< casadi::IMatrix > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__12"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::MX* >* >*"
// proto: "std::vector< std::vector< casadi::MX* >* >*\n    casadi_blocksplit__12(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_)"
extern "C"
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__12(std::string ** err_msg, casadi::MX* x0);
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__12(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        std::vector< std::vector< casadi::MX > > ret = blocksplit(x0_);
        return WrapReturn< std::vector< std::vector< casadi::MX* >* >*, std::vector< std::vector< casadi::MX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__13"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::MX* >* >*"
// proto: "std::vector< std::vector< casadi::MX* >* >*\n    casadi_blocksplit__13(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__13(std::string ** err_msg, casadi::MX* x0, int x1);
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__13(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< std::vector< casadi::MX > > ret = blocksplit(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::MX* >* >*, std::vector< std::vector< casadi::MX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__14"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::MX* >* >*"
// proto: "std::vector< std::vector< casadi::MX* >* >*\n    casadi_blocksplit__14(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__14(std::string ** err_msg, casadi::MX* x0, int x1, int x2);
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__14(std::string ** err_msg, casadi::MX* x0, int x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< std::vector< casadi::MX > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::MX* >* >*, std::vector< std::vector< casadi::MX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__15"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::MX* >* >*"
// proto: "std::vector< std::vector< casadi::MX* >* >*\n    casadi_blocksplit__15(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__15(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< std::vector< casadi::MX* >* >*
    casadi_blocksplit__15(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< std::vector< casadi::MX > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::MX* >* >*, std::vector< std::vector< casadi::MX > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__16"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >*\n    casadi_blocksplit__16(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__16(std::string ** err_msg, casadi::Sparsity* x0);
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__16(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        std::vector< std::vector< casadi::Sparsity > > ret = blocksplit(x0_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__17"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >*\n    casadi_blocksplit__17(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__17(std::string ** err_msg, casadi::Sparsity* x0, int x1);
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__17(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< std::vector< casadi::Sparsity > > ret = blocksplit(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__18"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt,CInt]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >*\n    casadi_blocksplit__18(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__18(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2);
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__18(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< std::vector< casadi::Sparsity > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_blocksplit" ===============
// cppName: "casadi::casadi_blocksplit"
// cWrapperName: "casadi_blocksplit__19"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >*\n    casadi_blocksplit__19(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_blocksplit"
// call: "blocksplit(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__19(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< std::vector< casadi::Sparsity* >* >*
    casadi_blocksplit__19(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< std::vector< casadi::Sparsity > > ret = blocksplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ceil" ===============
// cppName: "casadi::casadi_ceil"
// cWrapperName: "casadi_ceil__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_ceil__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_ceil"
// call: "ceil(x0_)"
extern "C"
casadi::SX*
    casadi_ceil__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_ceil__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = ceil(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ceil" ===============
// cppName: "casadi::casadi_ceil"
// cWrapperName: "casadi_ceil__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_ceil__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_ceil"
// call: "ceil(x0_)"
extern "C"
casadi::DMatrix*
    casadi_ceil__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_ceil__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = ceil(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ceil" ===============
// cppName: "casadi::casadi_ceil"
// cWrapperName: "casadi_ceil__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_ceil__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_ceil"
// call: "ceil(x0_)"
extern "C"
casadi::IMatrix*
    casadi_ceil__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_ceil__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = ceil(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ceil" ===============
// cppName: "casadi::casadi_ceil"
// cWrapperName: "casadi_ceil__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_ceil__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_ceil"
// call: "ceil(x0_)"
extern "C"
casadi::MX*
    casadi_ceil__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_ceil__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = ceil(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_chol" ===============
// cppName: "casadi::casadi_chol"
// cWrapperName: "casadi_chol__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_chol__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_chol"
// call: "chol(x0_)"
extern "C"
casadi::SX*
    casadi_chol__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_chol__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = chol(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_chol" ===============
// cppName: "casadi::casadi_chol"
// cWrapperName: "casadi_chol__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_chol__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_chol"
// call: "chol(x0_)"
extern "C"
casadi::DMatrix*
    casadi_chol__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_chol__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = chol(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_chol" ===============
// cppName: "casadi::casadi_chol"
// cWrapperName: "casadi_chol__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_chol__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_chol"
// call: "chol(x0_)"
extern "C"
casadi::IMatrix*
    casadi_chol__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_chol__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = chol(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cofactor" ===============
// cppName: "casadi::casadi_cofactor"
// cWrapperName: "casadi_cofactor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_cofactor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_cofactor"
// call: "cofactor(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_cofactor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
casadi::SX*
    casadi_cofactor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = cofactor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cofactor" ===============
// cppName: "casadi::casadi_cofactor"
// cWrapperName: "casadi_cofactor__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_cofactor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_cofactor"
// call: "cofactor(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_cofactor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
casadi::DMatrix*
    casadi_cofactor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = cofactor(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cofactor" ===============
// cppName: "casadi::casadi_cofactor"
// cWrapperName: "casadi_cofactor__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_cofactor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_cofactor"
// call: "cofactor(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_cofactor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
casadi::IMatrix*
    casadi_cofactor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = cofactor(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_conditional__0(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_conditional__0(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2);
casadi::SX*
    casadi_conditional__0(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = conditional(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_conditional__1(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2, int x3)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_conditional__1(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2, int x3);
casadi::SX*
    casadi_conditional__1(std::string ** err_msg, casadi::SX* x0, std::vector< casadi::SX* >* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::SX ret = conditional(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_conditional__2(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_conditional__2(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_conditional__2(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = conditional(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_conditional__3(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_conditional__3(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2, int x3);
casadi::DMatrix*
    casadi_conditional__3(std::string ** err_msg, casadi::DMatrix* x0, std::vector< casadi::DMatrix* >* x1, casadi::DMatrix* x2, int x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::DMatrix ret = conditional(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_conditional__4(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_conditional__4(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_conditional__4(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = conditional(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_conditional__5(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_conditional__5(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2, int x3);
casadi::IMatrix*
    casadi_conditional__5(std::string ** err_msg, casadi::IMatrix* x0, std::vector< casadi::IMatrix* >* x1, casadi::IMatrix* x2, int x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::IMatrix ret = conditional(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_conditional__6(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_conditional__6(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2);
casadi::MX*
    casadi_conditional__6(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);

        casadi::MX ret = conditional(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_conditional" ===============
// cppName: "casadi::casadi_conditional"
// cWrapperName: "casadi_conditional__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_conditional__7(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2, int x3)"
// friendWrap: True
// fName: "casadi_conditional"
// call: "conditional(x0_, x1_, x2_, x3_)"
extern "C"
casadi::MX*
    casadi_conditional__7(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2, int x3);
casadi::MX*
    casadi_conditional__7(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, casadi::MX* x2, int x3){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::MX ret = conditional(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_constpow" ===============
// cppName: "casadi::casadi_constpow"
// cWrapperName: "casadi_constpow__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_constpow__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_constpow"
// call: "constpow(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_constpow__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_constpow__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = constpow(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_constpow" ===============
// cppName: "casadi::casadi_constpow"
// cWrapperName: "casadi_constpow__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_constpow__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_constpow"
// call: "constpow(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_constpow__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_constpow__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = constpow(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_constpow" ===============
// cppName: "casadi::casadi_constpow"
// cWrapperName: "casadi_constpow__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_constpow__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_constpow"
// call: "constpow(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_constpow__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_constpow__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = constpow(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_constpow" ===============
// cppName: "casadi::casadi_constpow"
// cWrapperName: "casadi_constpow__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_constpow__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_constpow"
// call: "constpow(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_constpow__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_constpow__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = constpow(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_copysign" ===============
// cppName: "casadi::casadi_copysign"
// cWrapperName: "casadi_copysign__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_copysign__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_copysign"
// call: "copysign(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_copysign__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_copysign__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = copysign(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_copysign" ===============
// cppName: "casadi::casadi_copysign"
// cWrapperName: "casadi_copysign__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_copysign__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_copysign"
// call: "copysign(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_copysign__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_copysign__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = copysign(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_copysign" ===============
// cppName: "casadi::casadi_copysign"
// cWrapperName: "casadi_copysign__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_copysign__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_copysign"
// call: "copysign(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_copysign__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_copysign__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = copysign(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_copysign" ===============
// cppName: "casadi::casadi_copysign"
// cWrapperName: "casadi_copysign__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_copysign__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_copysign"
// call: "copysign(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_copysign__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_copysign__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = copysign(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cos" ===============
// cppName: "casadi::casadi_cos"
// cWrapperName: "casadi_cos__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_cos__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_cos"
// call: "cos(x0_)"
extern "C"
casadi::SX*
    casadi_cos__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_cos__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = cos(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cos" ===============
// cppName: "casadi::casadi_cos"
// cWrapperName: "casadi_cos__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_cos__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_cos"
// call: "cos(x0_)"
extern "C"
casadi::DMatrix*
    casadi_cos__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_cos__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = cos(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cos" ===============
// cppName: "casadi::casadi_cos"
// cWrapperName: "casadi_cos__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_cos__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_cos"
// call: "cos(x0_)"
extern "C"
casadi::IMatrix*
    casadi_cos__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_cos__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = cos(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cos" ===============
// cppName: "casadi::casadi_cos"
// cWrapperName: "casadi_cos__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_cos__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_cos"
// call: "cos(x0_)"
extern "C"
casadi::MX*
    casadi_cos__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_cos__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = cos(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cosh" ===============
// cppName: "casadi::casadi_cosh"
// cWrapperName: "casadi_cosh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_cosh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_cosh"
// call: "cosh(x0_)"
extern "C"
casadi::SX*
    casadi_cosh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_cosh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = cosh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cosh" ===============
// cppName: "casadi::casadi_cosh"
// cWrapperName: "casadi_cosh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_cosh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_cosh"
// call: "cosh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_cosh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_cosh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = cosh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cosh" ===============
// cppName: "casadi::casadi_cosh"
// cWrapperName: "casadi_cosh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_cosh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_cosh"
// call: "cosh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_cosh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_cosh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = cosh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cosh" ===============
// cppName: "casadi::casadi_cosh"
// cWrapperName: "casadi_cosh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_cosh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_cosh"
// call: "cosh(x0_)"
extern "C"
casadi::MX*
    casadi_cosh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_cosh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = cosh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_countNodes" ===============
// cppName: "casadi::casadi_countNodes"
// cWrapperName: "casadi_countNodes__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_countNodes__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_countNodes"
// call: "countNodes(x0_)"
extern "C"
int
    casadi_countNodes__0(std::string ** err_msg, casadi::SX* x0);
int
    casadi_countNodes__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        int ret = countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_countNodes" ===============
// cppName: "casadi::casadi_countNodes"
// cWrapperName: "casadi_countNodes__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_countNodes__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_countNodes"
// call: "countNodes(x0_)"
extern "C"
int
    casadi_countNodes__1(std::string ** err_msg, casadi::DMatrix* x0);
int
    casadi_countNodes__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        int ret = countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_countNodes" ===============
// cppName: "casadi::casadi_countNodes"
// cWrapperName: "casadi_countNodes__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_countNodes__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_countNodes"
// call: "countNodes(x0_)"
extern "C"
int
    casadi_countNodes__2(std::string ** err_msg, casadi::IMatrix* x0);
int
    casadi_countNodes__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        int ret = countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_countNodes" ===============
// cppName: "casadi::casadi_countNodes"
// cWrapperName: "casadi_countNodes__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_countNodes__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_countNodes"
// call: "countNodes(x0_)"
extern "C"
int
    casadi_countNodes__3(std::string ** err_msg, casadi::MX* x0);
int
    casadi_countNodes__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        int ret = countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_cross__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_cross__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_cross__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = cross(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_cross__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_cross__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2);
casadi::SX*
    casadi_cross__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = cross(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_cross__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_cross__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_cross__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = cross(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_cross__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_cross__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2);
casadi::DMatrix*
    casadi_cross__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = cross(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_cross__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_cross__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_cross__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = cross(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_cross__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_cross__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2);
casadi::IMatrix*
    casadi_cross__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = cross(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_cross__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_cross__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_cross__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = cross(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_cross" ===============
// cppName: "casadi::casadi_cross"
// cWrapperName: "casadi_cross__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_cross__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// friendWrap: True
// fName: "casadi_cross"
// call: "cross(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_cross__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2);
casadi::MX*
    casadi_cross__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MX ret = cross(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_densify" ===============
// cppName: "casadi::casadi_densify"
// cWrapperName: "casadi_densify__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_densify__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_densify"
// call: "densify(x0_)"
extern "C"
casadi::SX*
    casadi_densify__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_densify__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = densify(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_densify" ===============
// cppName: "casadi::casadi_densify"
// cWrapperName: "casadi_densify__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_densify__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_densify"
// call: "densify(x0_)"
extern "C"
casadi::DMatrix*
    casadi_densify__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_densify__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = densify(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_densify" ===============
// cppName: "casadi::casadi_densify"
// cWrapperName: "casadi_densify__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_densify__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_densify"
// call: "densify(x0_)"
extern "C"
casadi::IMatrix*
    casadi_densify__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_densify__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = densify(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_densify" ===============
// cppName: "casadi::casadi_densify"
// cWrapperName: "casadi_densify__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_densify__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_densify"
// call: "densify(x0_)"
extern "C"
casadi::MX*
    casadi_densify__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_densify__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = densify(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_dependsOn" ===============
// cppName: "casadi::casadi_dependsOn"
// cWrapperName: "casadi_dependsOn__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_dependsOn__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_dependsOn"
// call: "dependsOn(x0_, x1_)"
extern "C"
int
    casadi_dependsOn__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
int
    casadi_dependsOn__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        bool ret = dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_dependsOn" ===============
// cppName: "casadi::casadi_dependsOn"
// cWrapperName: "casadi_dependsOn__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_dependsOn__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_dependsOn"
// call: "dependsOn(x0_, x1_)"
extern "C"
int
    casadi_dependsOn__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
int
    casadi_dependsOn__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        bool ret = dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_dependsOn" ===============
// cppName: "casadi::casadi_dependsOn"
// cWrapperName: "casadi_dependsOn__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_dependsOn__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_dependsOn"
// call: "dependsOn(x0_, x1_)"
extern "C"
int
    casadi_dependsOn__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
int
    casadi_dependsOn__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        bool ret = dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_dependsOn" ===============
// cppName: "casadi::casadi_dependsOn"
// cWrapperName: "casadi_dependsOn__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_dependsOn__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_dependsOn"
// call: "dependsOn(x0_, x1_)"
extern "C"
int
    casadi_dependsOn__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
int
    casadi_dependsOn__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        bool ret = dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_det" ===============
// cppName: "casadi::casadi_det"
// cWrapperName: "casadi_det__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_det__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_det"
// call: "det(x0_)"
extern "C"
casadi::SX*
    casadi_det__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_det__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = det(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_det" ===============
// cppName: "casadi::casadi_det"
// cWrapperName: "casadi_det__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_det__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_det"
// call: "det(x0_)"
extern "C"
casadi::DMatrix*
    casadi_det__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_det__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = det(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_det" ===============
// cppName: "casadi::casadi_det"
// cWrapperName: "casadi_det__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_det__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_det"
// call: "det(x0_)"
extern "C"
casadi::IMatrix*
    casadi_det__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_det__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = det(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_det" ===============
// cppName: "casadi::casadi_det"
// cWrapperName: "casadi_det__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_det__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_det"
// call: "det(x0_)"
extern "C"
casadi::MX*
    casadi_det__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_det__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = det(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diag" ===============
// cppName: "casadi::casadi_diag"
// cWrapperName: "casadi_diag__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_diag__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_diag"
// call: "diag(x0_)"
extern "C"
casadi::SX*
    casadi_diag__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_diag__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = diag(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diag" ===============
// cppName: "casadi::casadi_diag"
// cWrapperName: "casadi_diag__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_diag__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_diag"
// call: "diag(x0_)"
extern "C"
casadi::DMatrix*
    casadi_diag__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_diag__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = diag(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diag" ===============
// cppName: "casadi::casadi_diag"
// cWrapperName: "casadi_diag__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_diag__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_diag"
// call: "diag(x0_)"
extern "C"
casadi::IMatrix*
    casadi_diag__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_diag__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = diag(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diag" ===============
// cppName: "casadi::casadi_diag"
// cWrapperName: "casadi_diag__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_diag__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_diag"
// call: "diag(x0_)"
extern "C"
casadi::MX*
    casadi_diag__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_diag__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = diag(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagcat" ===============
// cppName: "casadi::casadi_diagcat"
// cWrapperName: "casadi_diagcat__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_diagcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_diagcat"
// call: "diagcat(x0_)"
extern "C"
casadi::SX*
    casadi_diagcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
casadi::SX*
    casadi_diagcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        casadi::SX ret = diagcat(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagcat" ===============
// cppName: "casadi::casadi_diagcat"
// cWrapperName: "casadi_diagcat__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_diagcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_diagcat"
// call: "diagcat(x0_)"
extern "C"
casadi::DMatrix*
    casadi_diagcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
casadi::DMatrix*
    casadi_diagcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        casadi::DMatrix ret = diagcat(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagcat" ===============
// cppName: "casadi::casadi_diagcat"
// cWrapperName: "casadi_diagcat__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_diagcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_diagcat"
// call: "diagcat(x0_)"
extern "C"
casadi::IMatrix*
    casadi_diagcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
casadi::IMatrix*
    casadi_diagcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        casadi::IMatrix ret = diagcat(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagcat" ===============
// cppName: "casadi::casadi_diagcat"
// cWrapperName: "casadi_diagcat__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_diagcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_diagcat"
// call: "diagcat(x0_)"
extern "C"
casadi::MX*
    casadi_diagcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX*
    casadi_diagcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = diagcat(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagcat" ===============
// cppName: "casadi::casadi_diagcat"
// cWrapperName: "casadi_diagcat__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_diagcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_diagcat"
// call: "diagcat(x0_)"
extern "C"
casadi::Sparsity*
    casadi_diagcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
casadi::Sparsity*
    casadi_diagcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        casadi::Sparsity ret = diagcat(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_diagsplit__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_diagsplit__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
std::vector< casadi::SX* >*
    casadi_diagsplit__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< casadi::SX > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_diagsplit__1(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_diagsplit__1(std::string ** err_msg, casadi::SX* x0);
std::vector< casadi::SX* >*
    casadi_diagsplit__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        std::vector< casadi::SX > ret = diagsplit(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_diagsplit__2(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_diagsplit__2(std::string ** err_msg, casadi::SX* x0, int x1);
std::vector< casadi::SX* >*
    casadi_diagsplit__2(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::SX > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__3"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_diagsplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_diagsplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1);
std::vector< casadi::SX* >*
    casadi_diagsplit__3(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::SX > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__4"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_diagsplit__4(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_diagsplit__4(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< casadi::SX* >*
    casadi_diagsplit__4(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< casadi::SX > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_diagsplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< casadi::DMatrix > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__6"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_diagsplit__6(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__6(std::string ** err_msg, casadi::DMatrix* x0);
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__6(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = diagsplit(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__7"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_diagsplit__7(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__7(std::string ** err_msg, casadi::DMatrix* x0, int x1);
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__7(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::DMatrix > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__8"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_diagsplit__8(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__8(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1);
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__8(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__9"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_diagsplit__9(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__9(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< casadi::DMatrix* >*
    casadi_diagsplit__9(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__10"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_diagsplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__10(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< casadi::IMatrix > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__11"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_diagsplit__11(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__11(std::string ** err_msg, casadi::IMatrix* x0);
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__11(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        std::vector< casadi::IMatrix > ret = diagsplit(x0_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__12"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_diagsplit__12(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__12(std::string ** err_msg, casadi::IMatrix* x0, int x1);
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__12(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::IMatrix > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__13"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_diagsplit__13(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__13(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1);
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__13(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::IMatrix > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__14"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_diagsplit__14(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__14(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< casadi::IMatrix* >*
    casadi_diagsplit__14(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< casadi::IMatrix > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__15"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_diagsplit__15(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_diagsplit__15(std::string ** err_msg, casadi::MX* x0, int x1, int x2);
std::vector< casadi::MX* >*
    casadi_diagsplit__15(std::string ** err_msg, casadi::MX* x0, int x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< casadi::MX > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__16"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_diagsplit__16(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_diagsplit__16(std::string ** err_msg, casadi::MX* x0);
std::vector< casadi::MX* >*
    casadi_diagsplit__16(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        std::vector< casadi::MX > ret = diagsplit(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__17"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_diagsplit__17(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_diagsplit__17(std::string ** err_msg, casadi::MX* x0, int x1);
std::vector< casadi::MX* >*
    casadi_diagsplit__17(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::MX > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__18"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_diagsplit__18(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_diagsplit__18(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1);
std::vector< casadi::MX* >*
    casadi_diagsplit__18(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::MX > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__19"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_diagsplit__19(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_diagsplit__19(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< casadi::MX* >*
    casadi_diagsplit__19(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< casadi::MX > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__20"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt,CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_diagsplit__20(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__20(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2);
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__20(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        std::vector< casadi::Sparsity > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__21"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_diagsplit__21(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__21(std::string ** err_msg, casadi::Sparsity* x0);
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__21(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = diagsplit(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__22"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_diagsplit__22(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__22(std::string ** err_msg, casadi::Sparsity* x0, int x1);
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__22(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::Sparsity > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__23"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_diagsplit__23(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__23(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1);
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__23(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = diagsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_diagsplit" ===============
// cppName: "casadi::casadi_diagsplit"
// cWrapperName: "casadi_diagsplit__24"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdVec CInt)),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_diagsplit__24(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2)"
// friendWrap: True
// fName: "casadi_diagsplit"
// call: "diagsplit(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__24(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2);
std::vector< casadi::Sparsity* >*
    casadi_diagsplit__24(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1, std::vector< int >* x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);
        std::vector< int > x2_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = diagsplit(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eig_symbolic" ===============
// cppName: "casadi::casadi_eig_symbolic"
// cWrapperName: "casadi_eig_symbolic__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_eig_symbolic__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_eig_symbolic"
// call: "eig_symbolic(x0_)"
extern "C"
casadi::SX*
    casadi_eig_symbolic__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_eig_symbolic__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = eig_symbolic(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eig_symbolic" ===============
// cppName: "casadi::casadi_eig_symbolic"
// cWrapperName: "casadi_eig_symbolic__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_eig_symbolic__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_eig_symbolic"
// call: "eig_symbolic(x0_)"
extern "C"
casadi::DMatrix*
    casadi_eig_symbolic__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_eig_symbolic__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = eig_symbolic(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eig_symbolic" ===============
// cppName: "casadi::casadi_eig_symbolic"
// cWrapperName: "casadi_eig_symbolic__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_eig_symbolic__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_eig_symbolic"
// call: "eig_symbolic(x0_)"
extern "C"
casadi::IMatrix*
    casadi_eig_symbolic__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_eig_symbolic__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = eig_symbolic(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eq" ===============
// cppName: "casadi::casadi_eq"
// cWrapperName: "casadi_eq__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_eq__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_eq"
// call: "x0_ == x1_"
extern "C"
casadi::SX*
    casadi_eq__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_eq__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ == x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eq" ===============
// cppName: "casadi::casadi_eq"
// cWrapperName: "casadi_eq__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_eq__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_eq"
// call: "x0_ == x1_"
extern "C"
casadi::DMatrix*
    casadi_eq__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_eq__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ == x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eq" ===============
// cppName: "casadi::casadi_eq"
// cWrapperName: "casadi_eq__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_eq__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_eq"
// call: "x0_ == x1_"
extern "C"
casadi::IMatrix*
    casadi_eq__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_eq__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ == x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_eq" ===============
// cppName: "casadi::casadi_eq"
// cWrapperName: "casadi_eq__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_eq__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_eq"
// call: "x0_ == x1_"
extern "C"
casadi::MX*
    casadi_eq__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_eq__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ == x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erf" ===============
// cppName: "casadi::casadi_erf"
// cWrapperName: "casadi_erf__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_erf__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_erf"
// call: "erf(x0_)"
extern "C"
casadi::SX*
    casadi_erf__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_erf__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = erf(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erf" ===============
// cppName: "casadi::casadi_erf"
// cWrapperName: "casadi_erf__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_erf__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_erf"
// call: "erf(x0_)"
extern "C"
casadi::DMatrix*
    casadi_erf__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_erf__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = erf(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erf" ===============
// cppName: "casadi::casadi_erf"
// cWrapperName: "casadi_erf__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_erf__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_erf"
// call: "erf(x0_)"
extern "C"
casadi::IMatrix*
    casadi_erf__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_erf__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = erf(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erf" ===============
// cppName: "casadi::casadi_erf"
// cWrapperName: "casadi_erf__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_erf__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_erf"
// call: "erf(x0_)"
extern "C"
casadi::MX*
    casadi_erf__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_erf__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = erf(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erfinv" ===============
// cppName: "casadi::casadi_erfinv"
// cWrapperName: "casadi_erfinv__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_erfinv__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_erfinv"
// call: "erfinv(x0_)"
extern "C"
casadi::SX*
    casadi_erfinv__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_erfinv__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = erfinv(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erfinv" ===============
// cppName: "casadi::casadi_erfinv"
// cWrapperName: "casadi_erfinv__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_erfinv__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_erfinv"
// call: "erfinv(x0_)"
extern "C"
casadi::DMatrix*
    casadi_erfinv__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_erfinv__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = erfinv(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erfinv" ===============
// cppName: "casadi::casadi_erfinv"
// cWrapperName: "casadi_erfinv__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_erfinv__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_erfinv"
// call: "erfinv(x0_)"
extern "C"
casadi::IMatrix*
    casadi_erfinv__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_erfinv__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = erfinv(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_erfinv" ===============
// cppName: "casadi::casadi_erfinv"
// cWrapperName: "casadi_erfinv__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_erfinv__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_erfinv"
// call: "erfinv(x0_)"
extern "C"
casadi::MX*
    casadi_erfinv__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_erfinv__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = erfinv(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_exp" ===============
// cppName: "casadi::casadi_exp"
// cWrapperName: "casadi_exp__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_exp__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_exp"
// call: "exp(x0_)"
extern "C"
casadi::SX*
    casadi_exp__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_exp__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = exp(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_exp" ===============
// cppName: "casadi::casadi_exp"
// cWrapperName: "casadi_exp__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_exp__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_exp"
// call: "exp(x0_)"
extern "C"
casadi::DMatrix*
    casadi_exp__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_exp__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = exp(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_exp" ===============
// cppName: "casadi::casadi_exp"
// cWrapperName: "casadi_exp__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_exp__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_exp"
// call: "exp(x0_)"
extern "C"
casadi::IMatrix*
    casadi_exp__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_exp__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = exp(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_exp" ===============
// cppName: "casadi::casadi_exp"
// cWrapperName: "casadi_exp__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_exp__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_exp"
// call: "exp(x0_)"
extern "C"
casadi::MX*
    casadi_exp__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_exp__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = exp(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_expand" ===============
// cppName: "casadi::casadi_expand"
// cWrapperName: "casadi_expand__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_expand__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_expand"
// call: "expand(x0_, x1_, x2_)"
extern "C"
void
    casadi_expand__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
void
    casadi_expand__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        expand(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_expand" ===============
// cppName: "casadi::casadi_expand"
// cWrapperName: "casadi_expand__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "DMatrix")),Ref (UserType (Namespace ["casadi"]) (Name "DMatrix"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_expand__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_expand"
// call: "expand(x0_, x1_, x2_)"
extern "C"
void
    casadi_expand__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
void
    casadi_expand__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        expand(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_expand" ===============
// cppName: "casadi::casadi_expand"
// cWrapperName: "casadi_expand__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "IMatrix")),Ref (UserType (Namespace ["casadi"]) (Name "IMatrix"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_expand__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_expand"
// call: "expand(x0_, x1_, x2_)"
extern "C"
void
    casadi_expand__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
void
    casadi_expand__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        expand(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_extractShared__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3);
void
    casadi_extractShared__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        std::vector< casadi::SX > x3_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x3);

        extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void
    casadi_extractShared__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4);
void
    casadi_extractShared__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        std::vector< casadi::SX > x3_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4, std::string* x5)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
void
    casadi_extractShared__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4, std::string* x5);
void
    casadi_extractShared__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::vector< casadi::SX* >* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        std::vector< casadi::SX > x3_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);

        extractShared(x0_, x1_, x2_, x3_, x4_, x5_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_extractShared__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3);
void
    casadi_extractShared__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);
        std::vector< casadi::DMatrix > x3_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x3);

        extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void
    casadi_extractShared__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4);
void
    casadi_extractShared__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);
        std::vector< casadi::DMatrix > x3_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4, std::string* x5)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
void
    casadi_extractShared__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4, std::string* x5);
void
    casadi_extractShared__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, std::vector< casadi::DMatrix* >* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);
        std::vector< casadi::DMatrix > x3_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);

        extractShared(x0_, x1_, x2_, x3_, x4_, x5_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__6(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_extractShared__6(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3);
void
    casadi_extractShared__6(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);
        std::vector< casadi::IMatrix > x3_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x3);

        extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__7(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void
    casadi_extractShared__7(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4);
void
    casadi_extractShared__7(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);
        std::vector< casadi::IMatrix > x3_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__8(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4, std::string* x5)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
void
    casadi_extractShared__8(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4, std::string* x5);
void
    casadi_extractShared__8(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, std::vector< casadi::IMatrix* >* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);
        std::vector< casadi::IMatrix > x3_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);

        extractShared(x0_, x1_, x2_, x3_, x4_, x5_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_extractShared__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3);
void
    casadi_extractShared__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        std::vector< casadi::MX > x3_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x3);

        extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void
    casadi_extractShared__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4);
void
    casadi_extractShared__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        std::vector< casadi::MX > x3_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_extractShared" ===============
// cppName: "casadi::casadi_extractShared"
// cWrapperName: "casadi_extractShared__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_extractShared__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4, std::string* x5)"
// friendWrap: True
// fName: "casadi_extractShared"
// call: "extractShared(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
void
    casadi_extractShared__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4, std::string* x5);
void
    casadi_extractShared__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::vector< casadi::MX* >* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        std::vector< casadi::MX > x3_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::string& x5_ = Marshaling<std::string&,std::string*>::marshal(x5);

        extractShared(x0_, x1_, x2_, x3_, x4_, x5_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_find" ===============
// cppName: "casadi::casadi_find"
// cWrapperName: "casadi_find"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_find(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_find"
// call: "find(x0_)"
extern "C"
casadi::MX*
    casadi_find(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_find(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = find(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_floor" ===============
// cppName: "casadi::casadi_floor"
// cWrapperName: "casadi_floor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_floor__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_floor"
// call: "floor(x0_)"
extern "C"
casadi::SX*
    casadi_floor__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_floor__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = floor(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_floor" ===============
// cppName: "casadi::casadi_floor"
// cWrapperName: "casadi_floor__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_floor__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_floor"
// call: "floor(x0_)"
extern "C"
casadi::DMatrix*
    casadi_floor__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_floor__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = floor(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_floor" ===============
// cppName: "casadi::casadi_floor"
// cWrapperName: "casadi_floor__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_floor__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_floor"
// call: "floor(x0_)"
extern "C"
casadi::IMatrix*
    casadi_floor__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_floor__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = floor(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_floor" ===============
// cppName: "casadi::casadi_floor"
// cWrapperName: "casadi_floor__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_floor__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_floor"
// call: "floor(x0_)"
extern "C"
casadi::MX*
    casadi_floor__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_floor__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = floor(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
casadi::SX*
    casadi_gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5);
casadi::SX*
    casadi_gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        casadi::SX ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3);
casadi::SX*
    casadi_gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        casadi::SX ret = gauss_quadrature(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::SX*
    casadi_gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4);
casadi::SX*
    casadi_gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);

        casadi::SX ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4, casadi::DMatrix* x5)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_gauss_quadrature__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4, casadi::DMatrix* x5)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
casadi::DMatrix*
    casadi_gauss_quadrature__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4, casadi::DMatrix* x5);
casadi::DMatrix*
    casadi_gauss_quadrature__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4, casadi::DMatrix* x5){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        casadi::DMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_gauss_quadrature__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_gauss_quadrature__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3);
casadi::DMatrix*
    casadi_gauss_quadrature__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        casadi::DMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_gauss_quadrature__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::DMatrix*
    casadi_gauss_quadrature__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4);
casadi::DMatrix*
    casadi_gauss_quadrature__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, casadi::DMatrix* x3, int x4){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);

        casadi::DMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4, casadi::IMatrix* x5)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_gauss_quadrature__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4, casadi::IMatrix* x5)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
casadi::IMatrix*
    casadi_gauss_quadrature__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4, casadi::IMatrix* x5);
casadi::IMatrix*
    casadi_gauss_quadrature__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4, casadi::IMatrix* x5){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        casadi::IMatrix& x3_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);
        casadi::IMatrix& x5_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x5);

        casadi::IMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_gauss_quadrature__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_gauss_quadrature__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3);
casadi::IMatrix*
    casadi_gauss_quadrature__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        casadi::IMatrix& x3_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x3);

        casadi::IMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gauss_quadrature" ===============
// cppName: "casadi::casadi_gauss_quadrature"
// cWrapperName: "casadi_gauss_quadrature__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_gauss_quadrature__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4)"
// friendWrap: True
// fName: "casadi_gauss_quadrature"
// call: "gauss_quadrature(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::IMatrix*
    casadi_gauss_quadrature__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4);
casadi::IMatrix*
    casadi_gauss_quadrature__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, casadi::IMatrix* x3, int x4){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        casadi::IMatrix& x3_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);

        casadi::IMatrix ret = gauss_quadrature(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ge" ===============
// cppName: "casadi::casadi_ge"
// cWrapperName: "casadi_ge__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_ge__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_ge"
// call: "x0_ >= x1_"
extern "C"
casadi::SX*
    casadi_ge__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_ge__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ >= x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ge" ===============
// cppName: "casadi::casadi_ge"
// cWrapperName: "casadi_ge__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_ge__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_ge"
// call: "x0_ >= x1_"
extern "C"
casadi::DMatrix*
    casadi_ge__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_ge__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ >= x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ge" ===============
// cppName: "casadi::casadi_ge"
// cWrapperName: "casadi_ge__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_ge__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_ge"
// call: "x0_ >= x1_"
extern "C"
casadi::IMatrix*
    casadi_ge__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_ge__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ >= x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ge" ===============
// cppName: "casadi::casadi_ge"
// cWrapperName: "casadi_ge__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_ge__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_ge"
// call: "x0_ >= x1_"
extern "C"
casadi::MX*
    casadi_ge__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_ge__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ >= x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getMinor" ===============
// cppName: "casadi::casadi_getMinor"
// cWrapperName: "casadi_getMinor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_getMinor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_getMinor"
// call: "getMinor(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_getMinor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
casadi::SX*
    casadi_getMinor__0(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = getMinor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getMinor" ===============
// cppName: "casadi::casadi_getMinor"
// cWrapperName: "casadi_getMinor__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_getMinor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_getMinor"
// call: "getMinor(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_getMinor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
casadi::DMatrix*
    casadi_getMinor__1(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = getMinor(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getMinor" ===============
// cppName: "casadi::casadi_getMinor"
// cWrapperName: "casadi_getMinor__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_getMinor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_getMinor"
// call: "getMinor(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_getMinor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
casadi::IMatrix*
    casadi_getMinor__2(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = getMinor(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getOperatorRepresentation" ===============
// cppName: "casadi::casadi_getOperatorRepresentation"
// cWrapperName: "casadi_getOperatorRepresentation__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    casadi_getOperatorRepresentation__0(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1)"
// friendWrap: True
// fName: "casadi_getOperatorRepresentation"
// call: "getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string*
    casadi_getOperatorRepresentation__0(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1);
std::string*
    casadi_getOperatorRepresentation__0(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getOperatorRepresentation" ===============
// cppName: "casadi::casadi_getOperatorRepresentation"
// cWrapperName: "casadi_getOperatorRepresentation__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    casadi_getOperatorRepresentation__1(std::string ** err_msg, casadi::DMatrix* x0, std::vector< std::string* >* x1)"
// friendWrap: True
// fName: "casadi_getOperatorRepresentation"
// call: "getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string*
    casadi_getOperatorRepresentation__1(std::string ** err_msg, casadi::DMatrix* x0, std::vector< std::string* >* x1);
std::string*
    casadi_getOperatorRepresentation__1(std::string ** err_msg, casadi::DMatrix* x0, std::vector< std::string* >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getOperatorRepresentation" ===============
// cppName: "casadi::casadi_getOperatorRepresentation"
// cWrapperName: "casadi_getOperatorRepresentation__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    casadi_getOperatorRepresentation__2(std::string ** err_msg, casadi::IMatrix* x0, std::vector< std::string* >* x1)"
// friendWrap: True
// fName: "casadi_getOperatorRepresentation"
// call: "getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string*
    casadi_getOperatorRepresentation__2(std::string ** err_msg, casadi::IMatrix* x0, std::vector< std::string* >* x1);
std::string*
    casadi_getOperatorRepresentation__2(std::string ** err_msg, casadi::IMatrix* x0, std::vector< std::string* >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_getOperatorRepresentation" ===============
// cppName: "casadi::casadi_getOperatorRepresentation"
// cWrapperName: "casadi_getOperatorRepresentation__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    casadi_getOperatorRepresentation__3(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1)"
// friendWrap: True
// fName: "casadi_getOperatorRepresentation"
// call: "getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string*
    casadi_getOperatorRepresentation__3(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1);
std::string*
    casadi_getOperatorRepresentation__3(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gradient" ===============
// cppName: "casadi::casadi_gradient"
// cWrapperName: "casadi_gradient__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_gradient__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_gradient"
// call: "gradient(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_gradient__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_gradient__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = gradient(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gradient" ===============
// cppName: "casadi::casadi_gradient"
// cWrapperName: "casadi_gradient__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_gradient__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_gradient"
// call: "gradient(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_gradient__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_gradient__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = gradient(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gradient" ===============
// cppName: "casadi::casadi_gradient"
// cWrapperName: "casadi_gradient__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_gradient__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_gradient"
// call: "gradient(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_gradient__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_gradient__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = gradient(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gradient" ===============
// cppName: "casadi::casadi_gradient"
// cWrapperName: "casadi_gradient__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_gradient__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_gradient"
// call: "gradient(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_gradient__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_gradient__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = gradient(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_graph_substitute" ===============
// cppName: "casadi::casadi_graph_substitute"
// cWrapperName: "casadi_graph_substitute__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// friendWrap: True
// fName: "casadi_graph_substitute"
// call: "graph_substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
std::vector< casadi::MX* >*
    casadi_graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        std::vector< casadi::MX > ret = graph_substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_graph_substitute" ===============
// cppName: "casadi::casadi_graph_substitute"
// cWrapperName: "casadi_graph_substitute__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// friendWrap: True
// fName: "casadi_graph_substitute"
// call: "graph_substitute(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
casadi::MX*
    casadi_graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        casadi::MX ret = graph_substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gt" ===============
// cppName: "casadi::casadi_gt"
// cWrapperName: "casadi_gt__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_gt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_gt"
// call: "x0_ > x1_"
extern "C"
casadi::SX*
    casadi_gt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_gt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ > x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gt" ===============
// cppName: "casadi::casadi_gt"
// cWrapperName: "casadi_gt__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_gt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_gt"
// call: "x0_ > x1_"
extern "C"
casadi::DMatrix*
    casadi_gt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_gt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ > x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gt" ===============
// cppName: "casadi::casadi_gt"
// cWrapperName: "casadi_gt__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_gt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_gt"
// call: "x0_ > x1_"
extern "C"
casadi::IMatrix*
    casadi_gt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_gt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ > x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_gt" ===============
// cppName: "casadi::casadi_gt"
// cWrapperName: "casadi_gt__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_gt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_gt"
// call: "x0_ > x1_"
extern "C"
casadi::MX*
    casadi_gt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_gt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ > x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_heaviside" ===============
// cppName: "casadi::casadi_heaviside"
// cWrapperName: "casadi_heaviside__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_heaviside__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_heaviside"
// call: "heaviside(x0_)"
extern "C"
casadi::SX*
    casadi_heaviside__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_heaviside__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = heaviside(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_heaviside" ===============
// cppName: "casadi::casadi_heaviside"
// cWrapperName: "casadi_heaviside__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_heaviside__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_heaviside"
// call: "heaviside(x0_)"
extern "C"
casadi::DMatrix*
    casadi_heaviside__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_heaviside__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = heaviside(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_heaviside" ===============
// cppName: "casadi::casadi_heaviside"
// cWrapperName: "casadi_heaviside__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_heaviside__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_heaviside"
// call: "heaviside(x0_)"
extern "C"
casadi::IMatrix*
    casadi_heaviside__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_heaviside__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = heaviside(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_hessian" ===============
// cppName: "casadi::casadi_hessian"
// cWrapperName: "casadi_hessian__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_hessian"
// call: "hessian(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = hessian(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_hessian" ===============
// cppName: "casadi::casadi_hessian"
// cWrapperName: "casadi_hessian__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "DMatrix"))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_hessian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_hessian"
// call: "hessian(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_hessian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_hessian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = hessian(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_hessian" ===============
// cppName: "casadi::casadi_hessian"
// cWrapperName: "casadi_hessian__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "IMatrix"))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_hessian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_hessian"
// call: "hessian(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_hessian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_hessian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = hessian(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_hessian" ===============
// cppName: "casadi::casadi_hessian"
// cWrapperName: "casadi_hessian__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (UserType (Namespace ["casadi"]) (Name "MX"))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_hessian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// friendWrap: True
// fName: "casadi_hessian"
// call: "hessian(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_hessian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX*
    casadi_hessian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);

        casadi::MX ret = hessian(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzcat" ===============
// cppName: "casadi::casadi_horzcat"
// cWrapperName: "casadi_horzcat__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_horzcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_horzcat"
// call: "horzcat(x0_)"
extern "C"
casadi::SX*
    casadi_horzcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
casadi::SX*
    casadi_horzcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        casadi::SX ret = horzcat(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzcat" ===============
// cppName: "casadi::casadi_horzcat"
// cWrapperName: "casadi_horzcat__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_horzcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_horzcat"
// call: "horzcat(x0_)"
extern "C"
casadi::DMatrix*
    casadi_horzcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
casadi::DMatrix*
    casadi_horzcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        casadi::DMatrix ret = horzcat(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzcat" ===============
// cppName: "casadi::casadi_horzcat"
// cWrapperName: "casadi_horzcat__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_horzcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_horzcat"
// call: "horzcat(x0_)"
extern "C"
casadi::IMatrix*
    casadi_horzcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
casadi::IMatrix*
    casadi_horzcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        casadi::IMatrix ret = horzcat(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzcat" ===============
// cppName: "casadi::casadi_horzcat"
// cWrapperName: "casadi_horzcat__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_horzcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_horzcat"
// call: "horzcat(x0_)"
extern "C"
casadi::MX*
    casadi_horzcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX*
    casadi_horzcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = horzcat(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzcat" ===============
// cppName: "casadi::casadi_horzcat"
// cWrapperName: "casadi_horzcat__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_horzcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_horzcat"
// call: "horzcat(x0_)"
extern "C"
casadi::Sparsity*
    casadi_horzcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
casadi::Sparsity*
    casadi_horzcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        casadi::Sparsity ret = horzcat(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_horzsplit__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_horzsplit__0(std::string ** err_msg, casadi::SX* x0);
std::vector< casadi::SX* >*
    casadi_horzsplit__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        std::vector< casadi::SX > ret = horzsplit(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_horzsplit__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_horzsplit__1(std::string ** err_msg, casadi::SX* x0, int x1);
std::vector< casadi::SX* >*
    casadi_horzsplit__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::SX > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_horzsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_horzsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1);
std::vector< casadi::SX* >*
    casadi_horzsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::SX > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_horzsplit__3(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__3(std::string ** err_msg, casadi::DMatrix* x0);
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__3(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = horzsplit(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_horzsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1);
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::DMatrix > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_horzsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1);
std::vector< casadi::DMatrix* >*
    casadi_horzsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_horzsplit__6(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__6(std::string ** err_msg, casadi::IMatrix* x0);
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__6(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        std::vector< casadi::IMatrix > ret = horzsplit(x0_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_horzsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1);
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::IMatrix > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_horzsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1);
std::vector< casadi::IMatrix* >*
    casadi_horzsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::IMatrix > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_horzsplit__9(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_horzsplit__9(std::string ** err_msg, casadi::MX* x0);
std::vector< casadi::MX* >*
    casadi_horzsplit__9(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        std::vector< casadi::MX > ret = horzsplit(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_horzsplit__10(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_horzsplit__10(std::string ** err_msg, casadi::MX* x0, int x1);
std::vector< casadi::MX* >*
    casadi_horzsplit__10(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::MX > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_horzsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_horzsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1);
std::vector< casadi::MX* >*
    casadi_horzsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::MX > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__12"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_horzsplit__12(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__12(std::string ** err_msg, casadi::Sparsity* x0);
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__12(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = horzsplit(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__13"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_horzsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1);
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::Sparsity > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_horzsplit" ===============
// cppName: "casadi::casadi_horzsplit"
// cWrapperName: "casadi_horzsplit__14"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_horzsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_horzsplit"
// call: "horzsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1);
std::vector< casadi::Sparsity* >*
    casadi_horzsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = horzsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_if_else__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_if_else__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_if_else__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX*
    casadi_if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::SX ret = if_else(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_if_else__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_if_else__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_if_else__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_if_else__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_if_else__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3);
casadi::DMatrix*
    casadi_if_else__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::DMatrix ret = if_else(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_if_else__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_if_else__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_if_else__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_if_else__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_if_else__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3);
casadi::IMatrix*
    casadi_if_else__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::IMatrix ret = if_else(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_if_else__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_if_else__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX*
    casadi_if_else__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);

        casadi::MX ret = if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_if_else" ===============
// cppName: "casadi::casadi_if_else"
// cWrapperName: "casadi_if_else__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_if_else__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, int x3)"
// friendWrap: True
// fName: "casadi_if_else"
// call: "if_else(x0_, x1_, x2_, x3_)"
extern "C"
casadi::MX*
    casadi_if_else__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, int x3);
casadi::MX*
    casadi_if_else__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2, int x3){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::MX ret = if_else(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inner_prod" ===============
// cppName: "casadi::casadi_inner_prod"
// cWrapperName: "casadi_inner_prod__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_inner_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_inner_prod"
// call: "inner_prod(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_inner_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_inner_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = inner_prod(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inner_prod" ===============
// cppName: "casadi::casadi_inner_prod"
// cWrapperName: "casadi_inner_prod__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_inner_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_inner_prod"
// call: "inner_prod(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_inner_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_inner_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = inner_prod(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inner_prod" ===============
// cppName: "casadi::casadi_inner_prod"
// cWrapperName: "casadi_inner_prod__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_inner_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_inner_prod"
// call: "inner_prod(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_inner_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_inner_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = inner_prod(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inner_prod" ===============
// cppName: "casadi::casadi_inner_prod"
// cWrapperName: "casadi_inner_prod__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_inner_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_inner_prod"
// call: "inner_prod(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_inner_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_inner_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = inner_prod(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inv" ===============
// cppName: "casadi::casadi_inv"
// cWrapperName: "casadi_inv__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_inv__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_inv"
// call: "inv(x0_)"
extern "C"
casadi::SX*
    casadi_inv__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_inv__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = inv(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inv" ===============
// cppName: "casadi::casadi_inv"
// cWrapperName: "casadi_inv__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_inv__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_inv"
// call: "inv(x0_)"
extern "C"
casadi::DMatrix*
    casadi_inv__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_inv__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = inv(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inv" ===============
// cppName: "casadi::casadi_inv"
// cWrapperName: "casadi_inv__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_inv__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_inv"
// call: "inv(x0_)"
extern "C"
casadi::IMatrix*
    casadi_inv__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_inv__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = inv(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_inv" ===============
// cppName: "casadi::casadi_inv"
// cWrapperName: "casadi_inv__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_inv__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_inv"
// call: "inv(x0_)"
extern "C"
casadi::MX*
    casadi_inv__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_inv__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = inv(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_)"
extern "C"
int
    casadi_isEqual__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
int
    casadi_isEqual__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        bool ret = isEqual(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: CBool
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_, x2_)"
extern "C"
int
    casadi_isEqual__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2);
int
    casadi_isEqual__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        bool ret = isEqual(x0_, x1_, x2_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_)"
extern "C"
int
    casadi_isEqual__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
int
    casadi_isEqual__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        bool ret = isEqual(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: CBool
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_, x2_)"
extern "C"
int
    casadi_isEqual__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2);
int
    casadi_isEqual__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        bool ret = isEqual(x0_, x1_, x2_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_)"
extern "C"
int
    casadi_isEqual__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
int
    casadi_isEqual__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        bool ret = isEqual(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: CBool
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_, x2_)"
extern "C"
int
    casadi_isEqual__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2);
int
    casadi_isEqual__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        bool ret = isEqual(x0_, x1_, x2_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_)"
extern "C"
int
    casadi_isEqual__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
int
    casadi_isEqual__6(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        bool ret = isEqual(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_isEqual" ===============
// cppName: "casadi::casadi_isEqual"
// cWrapperName: "casadi_isEqual__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: CBool
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_isEqual__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// friendWrap: True
// fName: "casadi_isEqual"
// call: "isEqual(x0_, x1_, x2_)"
extern "C"
int
    casadi_isEqual__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2);
int
    casadi_isEqual__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        bool ret = isEqual(x0_, x1_, x2_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_iszero" ===============
// cppName: "casadi::casadi_iszero"
// cWrapperName: "casadi_iszero__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_iszero__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_iszero"
// call: "iszero(x0_)"
extern "C"
int
    casadi_iszero__0(std::string ** err_msg, casadi::SX* x0);
int
    casadi_iszero__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        bool ret = iszero(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_iszero" ===============
// cppName: "casadi::casadi_iszero"
// cWrapperName: "casadi_iszero__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_iszero__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_iszero"
// call: "iszero(x0_)"
extern "C"
int
    casadi_iszero__1(std::string ** err_msg, casadi::DMatrix* x0);
int
    casadi_iszero__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        bool ret = iszero(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_iszero" ===============
// cppName: "casadi::casadi_iszero"
// cWrapperName: "casadi_iszero__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_iszero__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_iszero"
// call: "iszero(x0_)"
extern "C"
int
    casadi_iszero__2(std::string ** err_msg, casadi::IMatrix* x0);
int
    casadi_iszero__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        bool ret = iszero(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_iszero" ===============
// cppName: "casadi::casadi_iszero"
// cWrapperName: "casadi_iszero__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_iszero__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_iszero"
// call: "iszero(x0_)"
extern "C"
int
    casadi_iszero__3(std::string ** err_msg, casadi::MX* x0);
int
    casadi_iszero__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        bool ret = iszero(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobian" ===============
// cppName: "casadi::casadi_jacobian"
// cWrapperName: "casadi_jacobian__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_jacobian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_jacobian"
// call: "jacobian(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_jacobian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_jacobian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = jacobian(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobian" ===============
// cppName: "casadi::casadi_jacobian"
// cWrapperName: "casadi_jacobian__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_jacobian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_jacobian"
// call: "jacobian(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_jacobian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_jacobian__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = jacobian(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobian" ===============
// cppName: "casadi::casadi_jacobian"
// cWrapperName: "casadi_jacobian__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_jacobian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_jacobian"
// call: "jacobian(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_jacobian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_jacobian__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = jacobian(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobian" ===============
// cppName: "casadi::casadi_jacobian"
// cWrapperName: "casadi_jacobian__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_jacobian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_jacobian"
// call: "jacobian(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_jacobian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_jacobian__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = jacobian(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = jacobianTimesVector(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX*
    casadi_jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::SX ret = jacobianTimesVector(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_jacobianTimesVector__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_jacobianTimesVector__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_jacobianTimesVector__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = jacobianTimesVector(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_jacobianTimesVector__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_jacobianTimesVector__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3);
casadi::DMatrix*
    casadi_jacobianTimesVector__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::DMatrix ret = jacobianTimesVector(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_jacobianTimesVector__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_jacobianTimesVector__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_jacobianTimesVector__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = jacobianTimesVector(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_jacobianTimesVector" ===============
// cppName: "casadi::casadi_jacobianTimesVector"
// cWrapperName: "casadi_jacobianTimesVector__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_jacobianTimesVector__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_jacobianTimesVector"
// call: "jacobianTimesVector(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_jacobianTimesVector__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3);
casadi::IMatrix*
    casadi_jacobianTimesVector__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::IMatrix ret = jacobianTimesVector(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_kron" ===============
// cppName: "casadi::casadi_kron"
// cWrapperName: "casadi_kron__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_kron__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_kron"
// call: "kron(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_kron__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_kron__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = kron(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_kron" ===============
// cppName: "casadi::casadi_kron"
// cWrapperName: "casadi_kron__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_kron__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_kron"
// call: "kron(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_kron__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_kron__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = kron(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_kron" ===============
// cppName: "casadi::casadi_kron"
// cWrapperName: "casadi_kron__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_kron__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_kron"
// call: "kron(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_kron__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_kron__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = kron(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_kron" ===============
// cppName: "casadi::casadi_kron"
// cWrapperName: "casadi_kron__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_kron__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_kron"
// call: "kron(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_kron__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_kron__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = kron(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_kron" ===============
// cppName: "casadi::casadi_kron"
// cWrapperName: "casadi_kron__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_kron__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_kron"
// call: "kron(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_kron__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1);
casadi::Sparsity*
    casadi_kron__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::Sparsity ret = kron(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ldivide" ===============
// cppName: "casadi::casadi_ldivide"
// cWrapperName: "casadi_ldivide__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_ldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_ldivide"
// call: "x0_ / x1_"
extern "C"
casadi::SX*
    casadi_ldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_ldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ / x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ldivide" ===============
// cppName: "casadi::casadi_ldivide"
// cWrapperName: "casadi_ldivide__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_ldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_ldivide"
// call: "x0_ / x1_"
extern "C"
casadi::DMatrix*
    casadi_ldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_ldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ / x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ldivide" ===============
// cppName: "casadi::casadi_ldivide"
// cWrapperName: "casadi_ldivide__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_ldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_ldivide"
// call: "x0_ / x1_"
extern "C"
casadi::IMatrix*
    casadi_ldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_ldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ / x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ldivide" ===============
// cppName: "casadi::casadi_ldivide"
// cWrapperName: "casadi_ldivide__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_ldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_ldivide"
// call: "x0_ / x1_"
extern "C"
casadi::MX*
    casadi_ldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_ldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ / x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_le" ===============
// cppName: "casadi::casadi_le"
// cWrapperName: "casadi_le__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_le__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_le"
// call: "x0_ <= x1_"
extern "C"
casadi::SX*
    casadi_le__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_le__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ <= x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_le" ===============
// cppName: "casadi::casadi_le"
// cWrapperName: "casadi_le__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_le__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_le"
// call: "x0_ <= x1_"
extern "C"
casadi::DMatrix*
    casadi_le__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_le__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ <= x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_le" ===============
// cppName: "casadi::casadi_le"
// cWrapperName: "casadi_le__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_le__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_le"
// call: "x0_ <= x1_"
extern "C"
casadi::IMatrix*
    casadi_le__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_le__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ <= x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_le" ===============
// cppName: "casadi::casadi_le"
// cWrapperName: "casadi_le__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_le__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_le"
// call: "x0_ <= x1_"
extern "C"
casadi::MX*
    casadi_le__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_le__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ <= x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_linspace" ===============
// cppName: "casadi::casadi_linspace"
// cWrapperName: "casadi_linspace__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_linspace__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// friendWrap: True
// fName: "casadi_linspace"
// call: "linspace(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_linspace__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2);
casadi::SX*
    casadi_linspace__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = linspace(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_linspace" ===============
// cppName: "casadi::casadi_linspace"
// cWrapperName: "casadi_linspace__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_linspace__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_linspace"
// call: "linspace(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_linspace__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2);
casadi::DMatrix*
    casadi_linspace__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = linspace(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_linspace" ===============
// cppName: "casadi::casadi_linspace"
// cWrapperName: "casadi_linspace__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_linspace__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2)"
// friendWrap: True
// fName: "casadi_linspace"
// call: "linspace(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_linspace__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2);
casadi::IMatrix*
    casadi_linspace__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = linspace(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_linspace" ===============
// cppName: "casadi::casadi_linspace"
// cWrapperName: "casadi_linspace__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_linspace__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2)"
// friendWrap: True
// fName: "casadi_linspace"
// call: "linspace(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_linspace__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2);
casadi::MX*
    casadi_linspace__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MX ret = linspace(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log" ===============
// cppName: "casadi::casadi_log"
// cWrapperName: "casadi_log__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_log__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_log"
// call: "log(x0_)"
extern "C"
casadi::SX*
    casadi_log__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_log__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = log(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log" ===============
// cppName: "casadi::casadi_log"
// cWrapperName: "casadi_log__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_log__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_log"
// call: "log(x0_)"
extern "C"
casadi::DMatrix*
    casadi_log__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_log__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = log(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log" ===============
// cppName: "casadi::casadi_log"
// cWrapperName: "casadi_log__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_log__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_log"
// call: "log(x0_)"
extern "C"
casadi::IMatrix*
    casadi_log__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_log__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = log(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log" ===============
// cppName: "casadi::casadi_log"
// cWrapperName: "casadi_log__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_log__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_log"
// call: "log(x0_)"
extern "C"
casadi::MX*
    casadi_log__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_log__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = log(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log10" ===============
// cppName: "casadi::casadi_log10"
// cWrapperName: "casadi_log10__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_log10__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_log10"
// call: "log10(x0_)"
extern "C"
casadi::SX*
    casadi_log10__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_log10__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = log10(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log10" ===============
// cppName: "casadi::casadi_log10"
// cWrapperName: "casadi_log10__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_log10__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_log10"
// call: "log10(x0_)"
extern "C"
casadi::DMatrix*
    casadi_log10__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_log10__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = log10(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log10" ===============
// cppName: "casadi::casadi_log10"
// cWrapperName: "casadi_log10__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_log10__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_log10"
// call: "log10(x0_)"
extern "C"
casadi::IMatrix*
    casadi_log10__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_log10__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = log10(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_log10" ===============
// cppName: "casadi::casadi_log10"
// cWrapperName: "casadi_log10__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_log10__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_log10"
// call: "log10(x0_)"
extern "C"
casadi::MX*
    casadi_log10__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_log10__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = log10(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_lt" ===============
// cppName: "casadi::casadi_lt"
// cWrapperName: "casadi_lt__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_lt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_lt"
// call: "x0_ < x1_"
extern "C"
casadi::SX*
    casadi_lt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_lt__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ < x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_lt" ===============
// cppName: "casadi::casadi_lt"
// cWrapperName: "casadi_lt__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_lt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_lt"
// call: "x0_ < x1_"
extern "C"
casadi::DMatrix*
    casadi_lt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_lt__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ < x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_lt" ===============
// cppName: "casadi::casadi_lt"
// cWrapperName: "casadi_lt__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_lt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_lt"
// call: "x0_ < x1_"
extern "C"
casadi::IMatrix*
    casadi_lt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_lt__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ < x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_lt" ===============
// cppName: "casadi::casadi_lt"
// cWrapperName: "casadi_lt__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_lt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_lt"
// call: "x0_ < x1_"
extern "C"
casadi::MX*
    casadi_lt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_lt__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ < x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mac" ===============
// cppName: "casadi::casadi_mac"
// cWrapperName: "casadi_mac__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mac__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_mac"
// call: "mac(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_mac__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_mac__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = mac(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mac" ===============
// cppName: "casadi::casadi_mac"
// cWrapperName: "casadi_mac__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mac__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_mac"
// call: "mac(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_mac__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_mac__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = mac(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mac" ===============
// cppName: "casadi::casadi_mac"
// cWrapperName: "casadi_mac__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mac__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_mac"
// call: "mac(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_mac__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_mac__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = mac(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mac" ===============
// cppName: "casadi::casadi_mac"
// cWrapperName: "casadi_mac__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mac__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// friendWrap: True
// fName: "casadi_mac"
// call: "mac(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_mac__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX*
    casadi_mac__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);

        casadi::MX ret = mac(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mac" ===============
// cppName: "casadi::casadi_mac"
// cWrapperName: "casadi_mac__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_mac__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2)"
// friendWrap: True
// fName: "casadi_mac"
// call: "mac(x0_, x1_, x2_)"
extern "C"
casadi::Sparsity*
    casadi_mac__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2);
casadi::Sparsity*
    casadi_mac__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1, casadi::Sparsity* x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        casadi::Sparsity& x2_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x2);

        casadi::Sparsity ret = mac(x0_, x1_, x2_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_matrix_expand__0(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_)"
extern "C"
casadi::MX*
    casadi_matrix_expand__0(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_matrix_expand__0(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = matrix_expand(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_matrix_expand__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_matrix_expand__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1);
casadi::MX*
    casadi_matrix_expand__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        casadi::MX ret = matrix_expand(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__2"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_matrix_expand__2(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_matrix_expand__2(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::MX*
    casadi_matrix_expand__2(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::MX ret = matrix_expand(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_matrix_expand__3(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_matrix_expand__3(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >*
    casadi_matrix_expand__3(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = matrix_expand(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_matrix_expand__4(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_matrix_expand__4(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1);
std::vector< casadi::MX* >*
    casadi_matrix_expand__4(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        std::vector< casadi::MX > ret = matrix_expand(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_matrix_expand" ===============
// cppName: "casadi::casadi_matrix_expand"
// cWrapperName: "casadi_matrix_expand__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_matrix_expand__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_matrix_expand"
// call: "matrix_expand(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_matrix_expand__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2);
std::vector< casadi::MX* >*
    casadi_matrix_expand__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        std::vector< casadi::MX > ret = matrix_expand(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_max" ===============
// cppName: "casadi::casadi_max"
// cWrapperName: "casadi_max__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_max__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_max"
// call: "fmax(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_max__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_max__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = fmax(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_max" ===============
// cppName: "casadi::casadi_max"
// cWrapperName: "casadi_max__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_max__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_max"
// call: "fmax(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_max__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_max__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = fmax(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_max" ===============
// cppName: "casadi::casadi_max"
// cWrapperName: "casadi_max__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_max__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_max"
// call: "fmax(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_max__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_max__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = fmax(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_max" ===============
// cppName: "casadi::casadi_max"
// cWrapperName: "casadi_max__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_max__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_max"
// call: "fmax(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_max__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_max__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = fmax(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_min" ===============
// cppName: "casadi::casadi_min"
// cWrapperName: "casadi_min__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_min__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_min"
// call: "fmin(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_min__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_min__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = fmin(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_min" ===============
// cppName: "casadi::casadi_min"
// cWrapperName: "casadi_min__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_min__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_min"
// call: "fmin(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_min__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_min__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = fmin(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_min" ===============
// cppName: "casadi::casadi_min"
// cWrapperName: "casadi_min__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_min__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_min"
// call: "fmin(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_min__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_min__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = fmin(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_min" ===============
// cppName: "casadi::casadi_min"
// cWrapperName: "casadi_min__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_min__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_min"
// call: "fmin(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_min__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_min__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = fmin(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_minus" ===============
// cppName: "casadi::casadi_minus"
// cWrapperName: "casadi_minus__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_minus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_minus"
// call: "x0_ - x1_"
extern "C"
casadi::SX*
    casadi_minus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_minus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ - x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_minus" ===============
// cppName: "casadi::casadi_minus"
// cWrapperName: "casadi_minus__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_minus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_minus"
// call: "x0_ - x1_"
extern "C"
casadi::DMatrix*
    casadi_minus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_minus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ - x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_minus" ===============
// cppName: "casadi::casadi_minus"
// cWrapperName: "casadi_minus__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_minus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_minus"
// call: "x0_ - x1_"
extern "C"
casadi::IMatrix*
    casadi_minus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_minus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ - x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_minus" ===============
// cppName: "casadi::casadi_minus"
// cWrapperName: "casadi_minus__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_minus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_minus"
// call: "x0_ - x1_"
extern "C"
casadi::MX*
    casadi_minus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_minus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ - x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mldivide" ===============
// cppName: "casadi::casadi_mldivide"
// cWrapperName: "casadi_mldivide__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_mldivide"
// call: "mldivide(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_mldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_mldivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = mldivide(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mldivide" ===============
// cppName: "casadi::casadi_mldivide"
// cWrapperName: "casadi_mldivide__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_mldivide"
// call: "mldivide(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_mldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_mldivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = mldivide(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mldivide" ===============
// cppName: "casadi::casadi_mldivide"
// cWrapperName: "casadi_mldivide__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_mldivide"
// call: "mldivide(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_mldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_mldivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = mldivide(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mldivide" ===============
// cppName: "casadi::casadi_mldivide"
// cWrapperName: "casadi_mldivide__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_mldivide"
// call: "mldivide(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_mldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_mldivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = mldivide(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mod" ===============
// cppName: "casadi::casadi_mod"
// cWrapperName: "casadi_mod__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_mod"
// call: "fmod(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_mod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_mod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = fmod(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mod" ===============
// cppName: "casadi::casadi_mod"
// cWrapperName: "casadi_mod__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_mod"
// call: "fmod(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_mod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_mod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = fmod(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mod" ===============
// cppName: "casadi::casadi_mod"
// cWrapperName: "casadi_mod__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_mod"
// call: "fmod(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_mod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_mod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = fmod(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mod" ===============
// cppName: "casadi::casadi_mod"
// cWrapperName: "casadi_mod__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_mod"
// call: "fmod(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_mod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_mod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = fmod(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mpower" ===============
// cppName: "casadi::casadi_mpower"
// cWrapperName: "casadi_mpower__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mpower__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_mpower"
// call: "mpower(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_mpower__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_mpower__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = mpower(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mpower" ===============
// cppName: "casadi::casadi_mpower"
// cWrapperName: "casadi_mpower__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mpower__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_mpower"
// call: "mpower(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_mpower__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_mpower__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = mpower(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mpower" ===============
// cppName: "casadi::casadi_mpower"
// cWrapperName: "casadi_mpower__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mpower__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_mpower"
// call: "mpower(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_mpower__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_mpower__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = mpower(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mpower" ===============
// cppName: "casadi::casadi_mpower"
// cWrapperName: "casadi_mpower__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mpower__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_mpower"
// call: "mpower(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_mpower__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_mpower__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = mpower(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mrdivide" ===============
// cppName: "casadi::casadi_mrdivide"
// cWrapperName: "casadi_mrdivide__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mrdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_mrdivide"
// call: "mrdivide(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_mrdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_mrdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = mrdivide(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mrdivide" ===============
// cppName: "casadi::casadi_mrdivide"
// cWrapperName: "casadi_mrdivide__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mrdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_mrdivide"
// call: "mrdivide(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_mrdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_mrdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = mrdivide(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mrdivide" ===============
// cppName: "casadi::casadi_mrdivide"
// cWrapperName: "casadi_mrdivide__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mrdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_mrdivide"
// call: "mrdivide(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_mrdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_mrdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = mrdivide(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mrdivide" ===============
// cppName: "casadi::casadi_mrdivide"
// cWrapperName: "casadi_mrdivide__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mrdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_mrdivide"
// call: "mrdivide(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_mrdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_mrdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = mrdivide(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,Ref (Const (StdVec CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::SX*
    casadi_mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4);
casadi::SX*
    casadi_mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);
        std::vector< int > x4_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x4);

        casadi::SX ret = mtaylor(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = mtaylor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX*
    casadi_mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::SX ret = mtaylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3, std::vector< int >* x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,Ref (Const (StdVec CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mtaylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3, std::vector< int >* x4)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::DMatrix*
    casadi_mtaylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3, std::vector< int >* x4);
casadi::DMatrix*
    casadi_mtaylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3, std::vector< int >* x4){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);
        std::vector< int > x4_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x4);

        casadi::DMatrix ret = mtaylor(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mtaylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_mtaylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_mtaylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = mtaylor(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mtaylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_mtaylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3);
casadi::DMatrix*
    casadi_mtaylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::DMatrix ret = mtaylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3, std::vector< int >* x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,Ref (Const (StdVec CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mtaylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3, std::vector< int >* x4)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::IMatrix*
    casadi_mtaylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3, std::vector< int >* x4);
casadi::IMatrix*
    casadi_mtaylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3, std::vector< int >* x4){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);
        std::vector< int > x4_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x4);

        casadi::IMatrix ret = mtaylor(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mtaylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_mtaylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_mtaylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = mtaylor(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mtaylor" ===============
// cppName: "casadi::casadi_mtaylor"
// cWrapperName: "casadi_mtaylor__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mtaylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_mtaylor"
// call: "mtaylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_mtaylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3);
casadi::IMatrix*
    casadi_mtaylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::IMatrix ret = mtaylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mul__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_)"
extern "C"
casadi::SX*
    casadi_mul__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
casadi::SX*
    casadi_mul__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        casadi::SX ret = mul(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_mul__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_mul__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_mul__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = mul(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mul__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_)"
extern "C"
casadi::DMatrix*
    casadi_mul__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
casadi::DMatrix*
    casadi_mul__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        casadi::DMatrix ret = mul(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_mul__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_mul__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_mul__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = mul(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mul__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_)"
extern "C"
casadi::IMatrix*
    casadi_mul__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
casadi::IMatrix*
    casadi_mul__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        casadi::IMatrix ret = mul(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_mul__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_mul__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_mul__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = mul(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mul__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_)"
extern "C"
casadi::MX*
    casadi_mul__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX*
    casadi_mul__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = mul(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_mul__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_mul__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_mul__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = mul(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_mul__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_)"
extern "C"
casadi::Sparsity*
    casadi_mul__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
casadi::Sparsity*
    casadi_mul__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        casadi::Sparsity ret = mul(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_mul" ===============
// cppName: "casadi::casadi_mul"
// cWrapperName: "casadi_mul__9"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_mul__9(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_mul"
// call: "mul(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_mul__9(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1);
casadi::Sparsity*
    casadi_mul__9(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::Sparsity ret = mul(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ne" ===============
// cppName: "casadi::casadi_ne"
// cWrapperName: "casadi_ne__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_ne__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_ne"
// call: "x0_ != x1_"
extern "C"
casadi::SX*
    casadi_ne__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_ne__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ != x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ne" ===============
// cppName: "casadi::casadi_ne"
// cWrapperName: "casadi_ne__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_ne__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_ne"
// call: "x0_ != x1_"
extern "C"
casadi::DMatrix*
    casadi_ne__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_ne__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ != x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ne" ===============
// cppName: "casadi::casadi_ne"
// cWrapperName: "casadi_ne__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_ne__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_ne"
// call: "x0_ != x1_"
extern "C"
casadi::IMatrix*
    casadi_ne__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_ne__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ != x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ne" ===============
// cppName: "casadi::casadi_ne"
// cWrapperName: "casadi_ne__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_ne__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_ne"
// call: "x0_ != x1_"
extern "C"
casadi::MX*
    casadi_ne__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_ne__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ != x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_0_mul" ===============
// cppName: "casadi::casadi_norm_0_mul"
// cWrapperName: "casadi_norm_0_mul__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_norm_0_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_norm_0_mul"
// call: "norm_0_mul(x0_, x1_)"
extern "C"
int
    casadi_norm_0_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
int
    casadi_norm_0_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        int ret = norm_0_mul(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_0_mul" ===============
// cppName: "casadi::casadi_norm_0_mul"
// cWrapperName: "casadi_norm_0_mul__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_norm_0_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_norm_0_mul"
// call: "norm_0_mul(x0_, x1_)"
extern "C"
int
    casadi_norm_0_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
int
    casadi_norm_0_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        int ret = norm_0_mul(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_0_mul" ===============
// cppName: "casadi::casadi_norm_0_mul"
// cWrapperName: "casadi_norm_0_mul__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_norm_0_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_norm_0_mul"
// call: "norm_0_mul(x0_, x1_)"
extern "C"
int
    casadi_norm_0_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
int
    casadi_norm_0_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        int ret = norm_0_mul(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_0_mul" ===============
// cppName: "casadi::casadi_norm_0_mul"
// cWrapperName: "casadi_norm_0_mul__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_norm_0_mul__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_norm_0_mul"
// call: "norm_0_mul(x0_, x1_)"
extern "C"
int
    casadi_norm_0_mul__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
int
    casadi_norm_0_mul__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        int ret = norm_0_mul(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_0_mul" ===============
// cppName: "casadi::casadi_norm_0_mul"
// cWrapperName: "casadi_norm_0_mul__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_norm_0_mul__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_norm_0_mul"
// call: "norm_0_mul(x0_, x1_)"
extern "C"
int
    casadi_norm_0_mul__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1);
int
    casadi_norm_0_mul__4(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        int ret = norm_0_mul(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_1" ===============
// cppName: "casadi::casadi_norm_1"
// cWrapperName: "casadi_norm_1__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_norm_1__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_norm_1"
// call: "norm_1(x0_)"
extern "C"
casadi::SX*
    casadi_norm_1__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_norm_1__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = norm_1(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_1" ===============
// cppName: "casadi::casadi_norm_1"
// cWrapperName: "casadi_norm_1__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_norm_1__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_1"
// call: "norm_1(x0_)"
extern "C"
casadi::DMatrix*
    casadi_norm_1__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_norm_1__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = norm_1(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_1" ===============
// cppName: "casadi::casadi_norm_1"
// cWrapperName: "casadi_norm_1__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_norm_1__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_1"
// call: "norm_1(x0_)"
extern "C"
casadi::IMatrix*
    casadi_norm_1__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_norm_1__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = norm_1(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_1" ===============
// cppName: "casadi::casadi_norm_1"
// cWrapperName: "casadi_norm_1__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_norm_1__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_norm_1"
// call: "norm_1(x0_)"
extern "C"
casadi::MX*
    casadi_norm_1__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_norm_1__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = norm_1(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_2" ===============
// cppName: "casadi::casadi_norm_2"
// cWrapperName: "casadi_norm_2__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_norm_2__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_norm_2"
// call: "norm_2(x0_)"
extern "C"
casadi::SX*
    casadi_norm_2__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_norm_2__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = norm_2(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_2" ===============
// cppName: "casadi::casadi_norm_2"
// cWrapperName: "casadi_norm_2__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_norm_2__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_2"
// call: "norm_2(x0_)"
extern "C"
casadi::DMatrix*
    casadi_norm_2__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_norm_2__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = norm_2(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_2" ===============
// cppName: "casadi::casadi_norm_2"
// cWrapperName: "casadi_norm_2__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_norm_2__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_2"
// call: "norm_2(x0_)"
extern "C"
casadi::IMatrix*
    casadi_norm_2__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_norm_2__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = norm_2(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_2" ===============
// cppName: "casadi::casadi_norm_2"
// cWrapperName: "casadi_norm_2__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_norm_2__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_norm_2"
// call: "norm_2(x0_)"
extern "C"
casadi::MX*
    casadi_norm_2__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_norm_2__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = norm_2(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_F" ===============
// cppName: "casadi::casadi_norm_F"
// cWrapperName: "casadi_norm_F__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_norm_F__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_norm_F"
// call: "norm_F(x0_)"
extern "C"
casadi::SX*
    casadi_norm_F__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_norm_F__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = norm_F(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_F" ===============
// cppName: "casadi::casadi_norm_F"
// cWrapperName: "casadi_norm_F__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_norm_F__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_F"
// call: "norm_F(x0_)"
extern "C"
casadi::DMatrix*
    casadi_norm_F__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_norm_F__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = norm_F(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_F" ===============
// cppName: "casadi::casadi_norm_F"
// cWrapperName: "casadi_norm_F__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_norm_F__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_F"
// call: "norm_F(x0_)"
extern "C"
casadi::IMatrix*
    casadi_norm_F__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_norm_F__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = norm_F(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_F" ===============
// cppName: "casadi::casadi_norm_F"
// cWrapperName: "casadi_norm_F__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_norm_F__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_norm_F"
// call: "norm_F(x0_)"
extern "C"
casadi::MX*
    casadi_norm_F__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_norm_F__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = norm_F(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf" ===============
// cppName: "casadi::casadi_norm_inf"
// cWrapperName: "casadi_norm_inf__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_norm_inf__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_norm_inf"
// call: "norm_inf(x0_)"
extern "C"
casadi::SX*
    casadi_norm_inf__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_norm_inf__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = norm_inf(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf" ===============
// cppName: "casadi::casadi_norm_inf"
// cWrapperName: "casadi_norm_inf__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_norm_inf__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_inf"
// call: "norm_inf(x0_)"
extern "C"
casadi::DMatrix*
    casadi_norm_inf__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_norm_inf__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = norm_inf(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf" ===============
// cppName: "casadi::casadi_norm_inf"
// cWrapperName: "casadi_norm_inf__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_norm_inf__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_norm_inf"
// call: "norm_inf(x0_)"
extern "C"
casadi::IMatrix*
    casadi_norm_inf__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_norm_inf__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = norm_inf(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf" ===============
// cppName: "casadi::casadi_norm_inf"
// cWrapperName: "casadi_norm_inf__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_norm_inf__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_norm_inf"
// call: "norm_inf(x0_)"
extern "C"
casadi::MX*
    casadi_norm_inf__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_norm_inf__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = norm_inf(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf_mul" ===============
// cppName: "casadi::casadi_norm_inf_mul"
// cWrapperName: "casadi_norm_inf_mul__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_norm_inf_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_norm_inf_mul"
// call: "norm_inf_mul(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_norm_inf_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_norm_inf_mul__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = norm_inf_mul(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf_mul" ===============
// cppName: "casadi::casadi_norm_inf_mul"
// cWrapperName: "casadi_norm_inf_mul__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_norm_inf_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_norm_inf_mul"
// call: "norm_inf_mul(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_norm_inf_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_norm_inf_mul__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = norm_inf_mul(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_norm_inf_mul" ===============
// cppName: "casadi::casadi_norm_inf_mul"
// cWrapperName: "casadi_norm_inf_mul__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_norm_inf_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_norm_inf_mul"
// call: "norm_inf_mul(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_norm_inf_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_norm_inf_mul__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = norm_inf_mul(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_not" ===============
// cppName: "casadi::casadi_not"
// cWrapperName: "casadi_not__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_not__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_not"
// call: "!x0_"
extern "C"
casadi::SX*
    casadi_not__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_not__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = !x0_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_not" ===============
// cppName: "casadi::casadi_not"
// cWrapperName: "casadi_not__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_not__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_not"
// call: "!x0_"
extern "C"
casadi::DMatrix*
    casadi_not__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_not__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = !x0_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_not" ===============
// cppName: "casadi::casadi_not"
// cWrapperName: "casadi_not__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_not__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_not"
// call: "!x0_"
extern "C"
casadi::IMatrix*
    casadi_not__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_not__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = !x0_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_not" ===============
// cppName: "casadi::casadi_not"
// cWrapperName: "casadi_not__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_not__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_not"
// call: "!x0_"
extern "C"
casadi::MX*
    casadi_not__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_not__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = !x0_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_nullspace" ===============
// cppName: "casadi::casadi_nullspace"
// cWrapperName: "casadi_nullspace__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_nullspace__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_nullspace"
// call: "nullspace(x0_)"
extern "C"
casadi::SX*
    casadi_nullspace__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_nullspace__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = nullspace(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_nullspace" ===============
// cppName: "casadi::casadi_nullspace"
// cWrapperName: "casadi_nullspace__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_nullspace__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_nullspace"
// call: "nullspace(x0_)"
extern "C"
casadi::DMatrix*
    casadi_nullspace__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_nullspace__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = nullspace(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_nullspace" ===============
// cppName: "casadi::casadi_nullspace"
// cWrapperName: "casadi_nullspace__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_nullspace__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_nullspace"
// call: "nullspace(x0_)"
extern "C"
casadi::IMatrix*
    casadi_nullspace__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_nullspace__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = nullspace(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_nullspace" ===============
// cppName: "casadi::casadi_nullspace"
// cWrapperName: "casadi_nullspace__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_nullspace__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_nullspace"
// call: "nullspace(x0_)"
extern "C"
casadi::MX*
    casadi_nullspace__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_nullspace__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = nullspace(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec CInt
// args: "(x0_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_)"
extern "C"
std::vector< int >*
    casadi_offset__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< int >*
    casadi_offset__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< int > ret = offset(x0_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, int x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),CBool]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, int x1)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_, x1_)"
extern "C"
std::vector< int >*
    casadi_offset__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, int x1);
std::vector< int >*
    casadi_offset__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, int x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        std::vector< int > ret = offset(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec CInt
// args: "(x0_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_)"
extern "C"
std::vector< int >*
    casadi_offset__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< int >*
    casadi_offset__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< int > ret = offset(x0_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, int x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),CBool]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, int x1)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_, x1_)"
extern "C"
std::vector< int >*
    casadi_offset__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, int x1);
std::vector< int >*
    casadi_offset__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, int x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        std::vector< int > ret = offset(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: StdVec CInt
// args: "(x0_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_)"
extern "C"
std::vector< int >*
    casadi_offset__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
std::vector< int >*
    casadi_offset__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        std::vector< int > ret = offset(x0_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, int x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),CBool]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, int x1)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_, x1_)"
extern "C"
std::vector< int >*
    casadi_offset__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, int x1);
std::vector< int >*
    casadi_offset__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, int x1){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        std::vector< int > ret = offset(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec CInt
// args: "(x0_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_)"
extern "C"
std::vector< int >*
    casadi_offset__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< int >*
    casadi_offset__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< int > ret = offset(x0_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, int x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),CBool]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, int x1)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_, x1_)"
extern "C"
std::vector< int >*
    casadi_offset__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, int x1);
std::vector< int >*
    casadi_offset__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, int x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        std::vector< int > ret = offset(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec CInt
// args: "(x0_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_)"
extern "C"
std::vector< int >*
    casadi_offset__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< int >*
    casadi_offset__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< int > ret = offset(x0_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_offset" ===============
// cppName: "casadi::casadi_offset"
// cWrapperName: "casadi_offset__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, int x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),CBool]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    casadi_offset__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, int x1)"
// friendWrap: True
// fName: "casadi_offset"
// call: "offset(x0_, x1_)"
extern "C"
std::vector< int >*
    casadi_offset__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, int x1);
std::vector< int >*
    casadi_offset__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, int x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        std::vector< int > ret = offset(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_or" ===============
// cppName: "casadi::casadi_or"
// cWrapperName: "casadi_or__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_or__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_or"
// call: "x0_ || x1_"
extern "C"
casadi::SX*
    casadi_or__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_or__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ || x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_or" ===============
// cppName: "casadi::casadi_or"
// cWrapperName: "casadi_or__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_or__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_or"
// call: "x0_ || x1_"
extern "C"
casadi::DMatrix*
    casadi_or__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_or__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ || x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_or" ===============
// cppName: "casadi::casadi_or"
// cWrapperName: "casadi_or__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_or__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_or"
// call: "x0_ || x1_"
extern "C"
casadi::IMatrix*
    casadi_or__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_or__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ || x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_or" ===============
// cppName: "casadi::casadi_or"
// cWrapperName: "casadi_or__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_or__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_or"
// call: "x0_ || x1_"
extern "C"
casadi::MX*
    casadi_or__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_or__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ || x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_outer_prod" ===============
// cppName: "casadi::casadi_outer_prod"
// cWrapperName: "casadi_outer_prod__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_outer_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_outer_prod"
// call: "outer_prod(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_outer_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_outer_prod__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = outer_prod(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_outer_prod" ===============
// cppName: "casadi::casadi_outer_prod"
// cWrapperName: "casadi_outer_prod__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_outer_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_outer_prod"
// call: "outer_prod(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_outer_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_outer_prod__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = outer_prod(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_outer_prod" ===============
// cppName: "casadi::casadi_outer_prod"
// cWrapperName: "casadi_outer_prod__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_outer_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_outer_prod"
// call: "outer_prod(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_outer_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_outer_prod__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = outer_prod(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_outer_prod" ===============
// cppName: "casadi::casadi_outer_prod"
// cWrapperName: "casadi_outer_prod__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_outer_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_outer_prod"
// call: "outer_prod(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_outer_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_outer_prod__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = outer_prod(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_pinv__0(std::string ** err_msg, casadi::SX* x0, std::string* x1)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_pinv__0(std::string ** err_msg, casadi::SX* x0, std::string* x1);
casadi::SX*
    casadi_pinv__0(std::string ** err_msg, casadi::SX* x0, std::string* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        casadi::SX ret = pinv(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_pinv__1(std::string ** err_msg, casadi::SX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_pinv__1(std::string ** err_msg, casadi::SX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::SX*
    casadi_pinv__1(std::string ** err_msg, casadi::SX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::SX ret = pinv(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_pinv__2(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_)"
extern "C"
casadi::SX*
    casadi_pinv__2(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_pinv__2(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = pinv(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_pinv__3(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_pinv__3(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1);
casadi::DMatrix*
    casadi_pinv__3(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        casadi::DMatrix ret = pinv(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::DMatrix*
    casadi_pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::DMatrix ret = pinv(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_pinv__5(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_)"
extern "C"
casadi::DMatrix*
    casadi_pinv__5(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_pinv__5(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = pinv(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_pinv__6(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_pinv__6(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1);
casadi::IMatrix*
    casadi_pinv__6(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        casadi::IMatrix ret = pinv(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_pinv__7(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_pinv__7(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::IMatrix*
    casadi_pinv__7(std::string ** err_msg, casadi::IMatrix* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::IMatrix ret = pinv(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_pinv__8(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_)"
extern "C"
casadi::IMatrix*
    casadi_pinv__8(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_pinv__8(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = pinv(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_pinv__9(std::string ** err_msg, casadi::MX* x0, std::string* x1)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_pinv__9(std::string ** err_msg, casadi::MX* x0, std::string* x1);
casadi::MX*
    casadi_pinv__9(std::string ** err_msg, casadi::MX* x0, std::string* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        casadi::MX ret = pinv(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_pinv__10(std::string ** err_msg, casadi::MX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_pinv__10(std::string ** err_msg, casadi::MX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::MX*
    casadi_pinv__10(std::string ** err_msg, casadi::MX* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::MX ret = pinv(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pinv" ===============
// cppName: "casadi::casadi_pinv"
// cWrapperName: "casadi_pinv__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_pinv__11(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_pinv"
// call: "pinv(x0_)"
extern "C"
casadi::MX*
    casadi_pinv__11(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_pinv__11(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = pinv(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_plus" ===============
// cppName: "casadi::casadi_plus"
// cWrapperName: "casadi_plus__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_plus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_plus"
// call: "x0_ + x1_"
extern "C"
casadi::SX*
    casadi_plus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_plus__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ + x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_plus" ===============
// cppName: "casadi::casadi_plus"
// cWrapperName: "casadi_plus__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_plus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_plus"
// call: "x0_ + x1_"
extern "C"
casadi::DMatrix*
    casadi_plus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_plus__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ + x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_plus" ===============
// cppName: "casadi::casadi_plus"
// cWrapperName: "casadi_plus__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_plus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_plus"
// call: "x0_ + x1_"
extern "C"
casadi::IMatrix*
    casadi_plus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_plus__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ + x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_plus" ===============
// cppName: "casadi::casadi_plus"
// cWrapperName: "casadi_plus__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_plus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_plus"
// call: "x0_ + x1_"
extern "C"
casadi::MX*
    casadi_plus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_plus__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ + x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_coeff" ===============
// cppName: "casadi::casadi_poly_coeff"
// cWrapperName: "casadi_poly_coeff__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_poly_coeff__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_poly_coeff"
// call: "poly_coeff(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_poly_coeff__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_poly_coeff__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = poly_coeff(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_coeff" ===============
// cppName: "casadi::casadi_poly_coeff"
// cWrapperName: "casadi_poly_coeff__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_poly_coeff__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_poly_coeff"
// call: "poly_coeff(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_poly_coeff__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_poly_coeff__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = poly_coeff(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_coeff" ===============
// cppName: "casadi::casadi_poly_coeff"
// cWrapperName: "casadi_poly_coeff__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_poly_coeff__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_poly_coeff"
// call: "poly_coeff(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_poly_coeff__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_poly_coeff__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = poly_coeff(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_roots" ===============
// cppName: "casadi::casadi_poly_roots"
// cWrapperName: "casadi_poly_roots__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_poly_roots__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_poly_roots"
// call: "poly_roots(x0_)"
extern "C"
casadi::SX*
    casadi_poly_roots__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_poly_roots__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = poly_roots(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_roots" ===============
// cppName: "casadi::casadi_poly_roots"
// cWrapperName: "casadi_poly_roots__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_poly_roots__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_poly_roots"
// call: "poly_roots(x0_)"
extern "C"
casadi::DMatrix*
    casadi_poly_roots__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_poly_roots__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = poly_roots(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_poly_roots" ===============
// cppName: "casadi::casadi_poly_roots"
// cWrapperName: "casadi_poly_roots__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_poly_roots__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_poly_roots"
// call: "poly_roots(x0_)"
extern "C"
casadi::IMatrix*
    casadi_poly_roots__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_poly_roots__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = poly_roots(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_polyval" ===============
// cppName: "casadi::casadi_polyval"
// cWrapperName: "casadi_polyval__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_polyval__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_polyval"
// call: "polyval(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_polyval__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_polyval__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = polyval(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_polyval" ===============
// cppName: "casadi::casadi_polyval"
// cWrapperName: "casadi_polyval__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_polyval__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_polyval"
// call: "polyval(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_polyval__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_polyval__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = polyval(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_polyval" ===============
// cppName: "casadi::casadi_polyval"
// cWrapperName: "casadi_polyval__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_polyval__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_polyval"
// call: "polyval(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_polyval__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_polyval__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = polyval(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_polyval" ===============
// cppName: "casadi::casadi_polyval"
// cWrapperName: "casadi_polyval__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_polyval__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_polyval"
// call: "polyval(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_polyval__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_polyval__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = polyval(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_power" ===============
// cppName: "casadi::casadi_power"
// cWrapperName: "casadi_power__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_power__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_power"
// call: "pow(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_power__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_power__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = pow(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_power" ===============
// cppName: "casadi::casadi_power"
// cWrapperName: "casadi_power__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_power__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_power"
// call: "pow(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_power__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_power__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = pow(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_power" ===============
// cppName: "casadi::casadi_power"
// cWrapperName: "casadi_power__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_power__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_power"
// call: "pow(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_power__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_power__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = pow(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_power" ===============
// cppName: "casadi::casadi_power"
// cWrapperName: "casadi_power__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_power__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_power"
// call: "pow(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_power__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_power__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = pow(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_project__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_project__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1);
casadi::SX*
    casadi_project__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::SX ret = project(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_project__1(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1, int x2)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_project__1(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1, int x2);
casadi::SX*
    casadi_project__1(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::SX ret = project(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_project__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_project__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1);
casadi::DMatrix*
    casadi_project__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::DMatrix ret = project(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_project__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1, int x2)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_project__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1, int x2);
casadi::DMatrix*
    casadi_project__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::DMatrix ret = project(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_project__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_project__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1);
casadi::IMatrix*
    casadi_project__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::IMatrix ret = project(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_project__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1, int x2)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_project__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1, int x2);
casadi::IMatrix*
    casadi_project__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::IMatrix ret = project(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_project__6(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_project__6(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1);
casadi::MX*
    casadi_project__6(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::MX ret = project(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_project" ===============
// cppName: "casadi::casadi_project"
// cWrapperName: "casadi_project__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_project__7(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1, int x2)"
// friendWrap: True
// fName: "casadi_project"
// call: "project(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_project__7(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1, int x2);
casadi::MX*
    casadi_project__7(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::MX ret = project(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_const" ===============
// cppName: "casadi::casadi_pw_const"
// cWrapperName: "casadi_pw_const__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_pw_const__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_pw_const"
// call: "pw_const(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_pw_const__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_pw_const__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = pw_const(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_const" ===============
// cppName: "casadi::casadi_pw_const"
// cWrapperName: "casadi_pw_const__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_pw_const__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_pw_const"
// call: "pw_const(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_pw_const__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_pw_const__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = pw_const(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_const" ===============
// cppName: "casadi::casadi_pw_const"
// cWrapperName: "casadi_pw_const__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_pw_const__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_pw_const"
// call: "pw_const(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_pw_const__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_pw_const__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = pw_const(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_lin" ===============
// cppName: "casadi::casadi_pw_lin"
// cWrapperName: "casadi_pw_lin__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_pw_lin__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_pw_lin"
// call: "pw_lin(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_pw_lin__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_pw_lin__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = pw_lin(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_lin" ===============
// cppName: "casadi::casadi_pw_lin"
// cWrapperName: "casadi_pw_lin__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_pw_lin__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_pw_lin"
// call: "pw_lin(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_pw_lin__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_pw_lin__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = pw_lin(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_pw_lin" ===============
// cppName: "casadi::casadi_pw_lin"
// cWrapperName: "casadi_pw_lin__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_pw_lin__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_pw_lin"
// call: "pw_lin(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_pw_lin__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_pw_lin__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = pw_lin(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_qr" ===============
// cppName: "casadi::casadi_qr"
// cWrapperName: "casadi_qr__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_qr__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_qr"
// call: "qr(x0_, x1_, x2_)"
extern "C"
void
    casadi_qr__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
void
    casadi_qr__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        qr(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_qr" ===============
// cppName: "casadi::casadi_qr"
// cWrapperName: "casadi_qr__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "DMatrix")),Ref (UserType (Namespace ["casadi"]) (Name "DMatrix"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_qr__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_qr"
// call: "qr(x0_, x1_, x2_)"
extern "C"
void
    casadi_qr__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
void
    casadi_qr__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        qr(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_qr" ===============
// cppName: "casadi::casadi_qr"
// cWrapperName: "casadi_qr__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (UserType (Namespace ["casadi"]) (Name "IMatrix")),Ref (UserType (Namespace ["casadi"]) (Name "IMatrix"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_qr__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_qr"
// call: "qr(x0_, x1_, x2_)"
extern "C"
void
    casadi_qr__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
void
    casadi_qr__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        qr(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_quad_form__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_)"
extern "C"
casadi::SX*
    casadi_quad_form__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_quad_form__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = quad_form(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_quad_form__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_quad_form__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_quad_form__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = quad_form(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_quad_form__2(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_)"
extern "C"
casadi::DMatrix*
    casadi_quad_form__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_quad_form__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = quad_form(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_quad_form__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_quad_form__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_quad_form__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = quad_form(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_quad_form__4(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_)"
extern "C"
casadi::IMatrix*
    casadi_quad_form__4(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_quad_form__4(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = quad_form(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_quad_form__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_quad_form__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_quad_form__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = quad_form(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_quad_form__6(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_)"
extern "C"
casadi::MX*
    casadi_quad_form__6(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_quad_form__6(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = quad_form(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_quad_form" ===============
// cppName: "casadi::casadi_quad_form"
// cWrapperName: "casadi_quad_form__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_quad_form__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_quad_form"
// call: "quad_form(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_quad_form__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_quad_form__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = quad_form(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ramp" ===============
// cppName: "casadi::casadi_ramp"
// cWrapperName: "casadi_ramp__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_ramp__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_ramp"
// call: "ramp(x0_)"
extern "C"
casadi::SX*
    casadi_ramp__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_ramp__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = ramp(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ramp" ===============
// cppName: "casadi::casadi_ramp"
// cWrapperName: "casadi_ramp__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_ramp__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_ramp"
// call: "ramp(x0_)"
extern "C"
casadi::DMatrix*
    casadi_ramp__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_ramp__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = ramp(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_ramp" ===============
// cppName: "casadi::casadi_ramp"
// cWrapperName: "casadi_ramp__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_ramp__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_ramp"
// call: "ramp(x0_)"
extern "C"
casadi::IMatrix*
    casadi_ramp__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_ramp__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = ramp(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rdivide" ===============
// cppName: "casadi::casadi_rdivide"
// cWrapperName: "casadi_rdivide__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_rdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_rdivide"
// call: "x0_ / x1_"
extern "C"
casadi::SX*
    casadi_rdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_rdivide__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ / x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rdivide" ===============
// cppName: "casadi::casadi_rdivide"
// cWrapperName: "casadi_rdivide__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_rdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_rdivide"
// call: "x0_ / x1_"
extern "C"
casadi::DMatrix*
    casadi_rdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_rdivide__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ / x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rdivide" ===============
// cppName: "casadi::casadi_rdivide"
// cWrapperName: "casadi_rdivide__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_rdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_rdivide"
// call: "x0_ / x1_"
extern "C"
casadi::IMatrix*
    casadi_rdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_rdivide__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ / x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rdivide" ===============
// cppName: "casadi::casadi_rdivide"
// cWrapperName: "casadi_rdivide__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_rdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_rdivide"
// call: "x0_ / x1_"
extern "C"
casadi::MX*
    casadi_rdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_rdivide__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ / x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rectangle" ===============
// cppName: "casadi::casadi_rectangle"
// cWrapperName: "casadi_rectangle__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_rectangle__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_rectangle"
// call: "rectangle(x0_)"
extern "C"
casadi::SX*
    casadi_rectangle__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_rectangle__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = rectangle(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rectangle" ===============
// cppName: "casadi::casadi_rectangle"
// cWrapperName: "casadi_rectangle__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_rectangle__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_rectangle"
// call: "rectangle(x0_)"
extern "C"
casadi::DMatrix*
    casadi_rectangle__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_rectangle__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = rectangle(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_rectangle" ===============
// cppName: "casadi::casadi_rectangle"
// cWrapperName: "casadi_rectangle__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_rectangle__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_rectangle"
// call: "rectangle(x0_)"
extern "C"
casadi::IMatrix*
    casadi_rectangle__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_rectangle__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = rectangle(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdPair CInt CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_repmat__0(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_repmat__0(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1);
casadi::SX*
    casadi_repmat__0(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::SX ret = repmat(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_repmat__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_repmat__1(std::string ** err_msg, casadi::SX* x0, int x1);
casadi::SX*
    casadi_repmat__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::SX ret = repmat(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_repmat__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_repmat__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
casadi::SX*
    casadi_repmat__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = repmat(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdPair CInt CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_repmat__3(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_repmat__3(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1);
casadi::DMatrix*
    casadi_repmat__3(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::DMatrix ret = repmat(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_repmat__4(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_repmat__4(std::string ** err_msg, casadi::DMatrix* x0, int x1);
casadi::DMatrix*
    casadi_repmat__4(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::DMatrix ret = repmat(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_repmat__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_repmat__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
casadi::DMatrix*
    casadi_repmat__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = repmat(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdPair CInt CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_repmat__6(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_repmat__6(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1);
casadi::IMatrix*
    casadi_repmat__6(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::IMatrix ret = repmat(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_repmat__7(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_repmat__7(std::string ** err_msg, casadi::IMatrix* x0, int x1);
casadi::IMatrix*
    casadi_repmat__7(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::IMatrix ret = repmat(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_repmat__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_repmat__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
casadi::IMatrix*
    casadi_repmat__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = repmat(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdPair CInt CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_repmat__9(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_repmat__9(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1);
casadi::MX*
    casadi_repmat__9(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::MX ret = repmat(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_repmat__10(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_repmat__10(std::string ** err_msg, casadi::MX* x0, int x1);
casadi::MX*
    casadi_repmat__10(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::MX ret = repmat(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_repmat__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_repmat__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2);
casadi::MX*
    casadi_repmat__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MX ret = repmat(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__12"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdPair CInt CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_repmat__12(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_repmat__12(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1);
casadi::Sparsity*
    casadi_repmat__12(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::Sparsity ret = repmat(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__13"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_repmat__13(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_repmat__13(std::string ** err_msg, casadi::Sparsity* x0, int x1);
casadi::Sparsity*
    casadi_repmat__13(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::Sparsity ret = repmat(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repmat" ===============
// cppName: "casadi::casadi_repmat"
// cWrapperName: "casadi_repmat__14"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_repmat__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repmat"
// call: "repmat(x0_, x1_, x2_)"
extern "C"
casadi::Sparsity*
    casadi_repmat__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2);
casadi::Sparsity*
    casadi_repmat__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::Sparsity ret = repmat(x0_, x1_, x2_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_repsum__0(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_repsum__0(std::string ** err_msg, casadi::SX* x0, int x1);
casadi::SX*
    casadi_repsum__0(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::SX ret = repsum(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_repsum__1(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_repsum__1(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
casadi::SX*
    casadi_repsum__1(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = repsum(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_repsum__2(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_repsum__2(std::string ** err_msg, casadi::DMatrix* x0, int x1);
casadi::DMatrix*
    casadi_repsum__2(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::DMatrix ret = repsum(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_repsum__3(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_repsum__3(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
casadi::DMatrix*
    casadi_repsum__3(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = repsum(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_repsum__4(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_repsum__4(std::string ** err_msg, casadi::IMatrix* x0, int x1);
casadi::IMatrix*
    casadi_repsum__4(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::IMatrix ret = repsum(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_repsum__5(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_repsum__5(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
casadi::IMatrix*
    casadi_repsum__5(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = repsum(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_repsum__6(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_repsum__6(std::string ** err_msg, casadi::MX* x0, int x1);
casadi::MX*
    casadi_repsum__6(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::MX ret = repsum(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_repsum" ===============
// cppName: "casadi::casadi_repsum"
// cWrapperName: "casadi_repsum__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_repsum__7(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_repsum"
// call: "repsum(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_repsum__7(std::string ** err_msg, casadi::MX* x0, int x1, int x2);
casadi::MX*
    casadi_repsum__7(std::string ** err_msg, casadi::MX* x0, int x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MX ret = repsum(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_reshape__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_reshape__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1);
casadi::SX*
    casadi_reshape__0(std::string ** err_msg, casadi::SX* x0, casadi::Sparsity* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::SX ret = reshape(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),StdPair CInt CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_reshape__1(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_reshape__1(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1);
casadi::SX*
    casadi_reshape__1(std::string ** err_msg, casadi::SX* x0, std::pair< int, int >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::SX ret = reshape(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_reshape__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_reshape__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2);
casadi::SX*
    casadi_reshape__2(std::string ** err_msg, casadi::SX* x0, int x1, int x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::SX ret = reshape(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_reshape__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_reshape__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1);
casadi::DMatrix*
    casadi_reshape__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::Sparsity* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::DMatrix ret = reshape(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),StdPair CInt CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_reshape__4(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_reshape__4(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1);
casadi::DMatrix*
    casadi_reshape__4(std::string ** err_msg, casadi::DMatrix* x0, std::pair< int, int >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::DMatrix ret = reshape(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_reshape__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_reshape__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2);
casadi::DMatrix*
    casadi_reshape__5(std::string ** err_msg, casadi::DMatrix* x0, int x1, int x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::DMatrix ret = reshape(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_reshape__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_reshape__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1);
casadi::IMatrix*
    casadi_reshape__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::Sparsity* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::IMatrix ret = reshape(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),StdPair CInt CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_reshape__7(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_reshape__7(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1);
casadi::IMatrix*
    casadi_reshape__7(std::string ** err_msg, casadi::IMatrix* x0, std::pair< int, int >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::IMatrix ret = reshape(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_reshape__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_reshape__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2);
casadi::IMatrix*
    casadi_reshape__8(std::string ** err_msg, casadi::IMatrix* x0, int x1, int x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::IMatrix ret = reshape(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_reshape__9(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_reshape__9(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1);
casadi::MX*
    casadi_reshape__9(std::string ** err_msg, casadi::MX* x0, casadi::Sparsity* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::MX ret = reshape(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),StdPair CInt CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_reshape__10(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_reshape__10(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1);
casadi::MX*
    casadi_reshape__10(std::string ** err_msg, casadi::MX* x0, std::pair< int, int >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::MX ret = reshape(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_reshape__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_reshape__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2);
casadi::MX*
    casadi_reshape__11(std::string ** err_msg, casadi::MX* x0, int x1, int x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MX ret = reshape(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__12"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_reshape__12(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_reshape__12(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1);
casadi::Sparsity*
    casadi_reshape__12(std::string ** err_msg, casadi::Sparsity* x0, casadi::Sparsity* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        casadi::Sparsity ret = reshape(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__13"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),StdPair CInt CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_reshape__13(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_reshape__13(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1);
casadi::Sparsity*
    casadi_reshape__13(std::string ** err_msg, casadi::Sparsity* x0, std::pair< int, int >* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::pair< int, int > x1_ = Marshaling<std::pair< int, int >,std::pair< int, int >*>::marshal(x1);

        casadi::Sparsity ret = reshape(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_reshape" ===============
// cppName: "casadi::casadi_reshape"
// cWrapperName: "casadi_reshape__14"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_reshape__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2)"
// friendWrap: True
// fName: "casadi_reshape"
// call: "reshape(x0_, x1_, x2_)"
extern "C"
casadi::Sparsity*
    casadi_reshape__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2);
casadi::Sparsity*
    casadi_reshape__14(std::string ** err_msg, casadi::Sparsity* x0, int x1, int x2){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::Sparsity ret = reshape(x0_, x1_, x2_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sign" ===============
// cppName: "casadi::casadi_sign"
// cWrapperName: "casadi_sign__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sign__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sign"
// call: "sign(x0_)"
extern "C"
casadi::SX*
    casadi_sign__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sign__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sign(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sign" ===============
// cppName: "casadi::casadi_sign"
// cWrapperName: "casadi_sign__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sign__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sign"
// call: "sign(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sign__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sign__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sign(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sign" ===============
// cppName: "casadi::casadi_sign"
// cWrapperName: "casadi_sign__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sign__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sign"
// call: "sign(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sign__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sign__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sign(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sign" ===============
// cppName: "casadi::casadi_sign"
// cWrapperName: "casadi_sign__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sign__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sign"
// call: "sign(x0_)"
extern "C"
casadi::MX*
    casadi_sign__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sign__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sign(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_simplify" ===============
// cppName: "casadi::casadi_simplify"
// cWrapperName: "casadi_simplify__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_simplify__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_simplify"
// call: "simplify(x0_)"
extern "C"
casadi::SX*
    casadi_simplify__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_simplify__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = simplify(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_simplify" ===============
// cppName: "casadi::casadi_simplify"
// cWrapperName: "casadi_simplify__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_simplify__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_simplify"
// call: "simplify(x0_)"
extern "C"
casadi::DMatrix*
    casadi_simplify__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_simplify__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = simplify(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_simplify" ===============
// cppName: "casadi::casadi_simplify"
// cWrapperName: "casadi_simplify__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_simplify__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_simplify"
// call: "simplify(x0_)"
extern "C"
casadi::IMatrix*
    casadi_simplify__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_simplify__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = simplify(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_simplify" ===============
// cppName: "casadi::casadi_simplify"
// cWrapperName: "casadi_simplify__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_simplify__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_simplify"
// call: "simplify(x0_)"
extern "C"
casadi::MX*
    casadi_simplify__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_simplify__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = simplify(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sin" ===============
// cppName: "casadi::casadi_sin"
// cWrapperName: "casadi_sin__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sin__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sin"
// call: "sin(x0_)"
extern "C"
casadi::SX*
    casadi_sin__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sin__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sin(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sin" ===============
// cppName: "casadi::casadi_sin"
// cWrapperName: "casadi_sin__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sin__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sin"
// call: "sin(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sin__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sin__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sin(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sin" ===============
// cppName: "casadi::casadi_sin"
// cWrapperName: "casadi_sin__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sin__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sin"
// call: "sin(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sin__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sin__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sin(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sin" ===============
// cppName: "casadi::casadi_sin"
// cWrapperName: "casadi_sin__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sin__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sin"
// call: "sin(x0_)"
extern "C"
casadi::MX*
    casadi_sin__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sin__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sin(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sinh" ===============
// cppName: "casadi::casadi_sinh"
// cWrapperName: "casadi_sinh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sinh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sinh"
// call: "sinh(x0_)"
extern "C"
casadi::SX*
    casadi_sinh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sinh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sinh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sinh" ===============
// cppName: "casadi::casadi_sinh"
// cWrapperName: "casadi_sinh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sinh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sinh"
// call: "sinh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sinh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sinh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sinh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sinh" ===============
// cppName: "casadi::casadi_sinh"
// cWrapperName: "casadi_sinh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sinh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sinh"
// call: "sinh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sinh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sinh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sinh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sinh" ===============
// cppName: "casadi::casadi_sinh"
// cWrapperName: "casadi_sinh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sinh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sinh"
// call: "sinh(x0_)"
extern "C"
casadi::MX*
    casadi_sinh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sinh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sinh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_solve__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_solve__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2);
casadi::SX*
    casadi_solve__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        casadi::SX ret = solve(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_solve__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_solve__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3);
casadi::SX*
    casadi_solve__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::map< std::string, casadi::GenericType > x3_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x3);

        casadi::SX ret = solve(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = solve(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2);
casadi::DMatrix*
    casadi_solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        casadi::DMatrix ret = solve(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_solve__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_solve__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3);
casadi::DMatrix*
    casadi_solve__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::map< std::string, casadi::GenericType > x3_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x3);

        casadi::DMatrix ret = solve(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = solve(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_solve__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_solve__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2);
casadi::IMatrix*
    casadi_solve__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        casadi::IMatrix ret = solve(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_solve__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_solve__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3);
casadi::IMatrix*
    casadi_solve__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::map< std::string, casadi::GenericType > x3_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x3);

        casadi::IMatrix ret = solve(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_solve__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_solve__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_solve__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = solve(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_solve__9(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_solve__9(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2);
casadi::MX*
    casadi_solve__9(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        casadi::MX ret = solve(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_solve__10(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_, x2_, x3_)"
extern "C"
casadi::MX*
    casadi_solve__10(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3);
casadi::MX*
    casadi_solve__10(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2, std::map< std::string, casadi::GenericType* >* x3){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        std::map< std::string, casadi::GenericType > x3_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x3);

        casadi::MX ret = solve(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_solve" ===============
// cppName: "casadi::casadi_solve"
// cWrapperName: "casadi_solve__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_solve__11(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_solve"
// call: "solve(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_solve__11(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_solve__11(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = solve(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sparsify__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_)"
extern "C"
casadi::SX*
    casadi_sparsify__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sparsify__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sparsify(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, double x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CDouble]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sparsify__1(std::string ** err_msg, casadi::SX* x0, double x1)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_sparsify__1(std::string ** err_msg, casadi::SX* x0, double x1);
casadi::SX*
    casadi_sparsify__1(std::string ** err_msg, casadi::SX* x0, double x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        double x1_ = Marshaling<double,double>::marshal(x1);

        casadi::SX ret = sparsify(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sparsify__2(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sparsify__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sparsify__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sparsify(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, double x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CDouble]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sparsify__3(std::string ** err_msg, casadi::DMatrix* x0, double x1)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_sparsify__3(std::string ** err_msg, casadi::DMatrix* x0, double x1);
casadi::DMatrix*
    casadi_sparsify__3(std::string ** err_msg, casadi::DMatrix* x0, double x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        double x1_ = Marshaling<double,double>::marshal(x1);

        casadi::DMatrix ret = sparsify(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sparsify__4(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sparsify__4(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sparsify__4(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sparsify(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sparsify" ===============
// cppName: "casadi::casadi_sparsify"
// cWrapperName: "casadi_sparsify__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, double x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CDouble]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sparsify__5(std::string ** err_msg, casadi::IMatrix* x0, double x1)"
// friendWrap: True
// fName: "casadi_sparsify"
// call: "sparsify(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_sparsify__5(std::string ** err_msg, casadi::IMatrix* x0, double x1);
casadi::IMatrix*
    casadi_sparsify__5(std::string ** err_msg, casadi::IMatrix* x0, double x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        double x1_ = Marshaling<double,double>::marshal(x1);

        casadi::IMatrix ret = sparsify(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sprank" ===============
// cppName: "casadi::casadi_sprank"
// cWrapperName: "casadi_sprank__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_sprank__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sprank"
// call: "sprank(x0_)"
extern "C"
int
    casadi_sprank__0(std::string ** err_msg, casadi::SX* x0);
int
    casadi_sprank__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        int ret = sprank(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sprank" ===============
// cppName: "casadi::casadi_sprank"
// cWrapperName: "casadi_sprank__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_sprank__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sprank"
// call: "sprank(x0_)"
extern "C"
int
    casadi_sprank__1(std::string ** err_msg, casadi::DMatrix* x0);
int
    casadi_sprank__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        int ret = sprank(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sprank" ===============
// cppName: "casadi::casadi_sprank"
// cWrapperName: "casadi_sprank__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_sprank__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sprank"
// call: "sprank(x0_)"
extern "C"
int
    casadi_sprank__2(std::string ** err_msg, casadi::IMatrix* x0);
int
    casadi_sprank__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        int ret = sprank(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sprank" ===============
// cppName: "casadi::casadi_sprank"
// cWrapperName: "casadi_sprank__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_sprank__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sprank"
// call: "sprank(x0_)"
extern "C"
int
    casadi_sprank__3(std::string ** err_msg, casadi::MX* x0);
int
    casadi_sprank__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        int ret = sprank(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sprank" ===============
// cppName: "casadi::casadi_sprank"
// cWrapperName: "casadi_sprank__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    casadi_sprank__4(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_sprank"
// call: "sprank(x0_)"
extern "C"
int
    casadi_sprank__4(std::string ** err_msg, casadi::Sparsity* x0);
int
    casadi_sprank__4(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        int ret = sprank(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sqrt" ===============
// cppName: "casadi::casadi_sqrt"
// cWrapperName: "casadi_sqrt__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sqrt__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sqrt"
// call: "sqrt(x0_)"
extern "C"
casadi::SX*
    casadi_sqrt__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sqrt__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sqrt(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sqrt" ===============
// cppName: "casadi::casadi_sqrt"
// cWrapperName: "casadi_sqrt__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sqrt__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sqrt"
// call: "sqrt(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sqrt__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sqrt__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sqrt(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sqrt" ===============
// cppName: "casadi::casadi_sqrt"
// cWrapperName: "casadi_sqrt__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sqrt__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sqrt"
// call: "sqrt(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sqrt__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sqrt__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sqrt(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sqrt" ===============
// cppName: "casadi::casadi_sqrt"
// cWrapperName: "casadi_sqrt__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sqrt__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sqrt"
// call: "sqrt(x0_)"
extern "C"
casadi::MX*
    casadi_sqrt__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sqrt__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sqrt(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_substitute__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_substitute__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2);
std::vector< casadi::SX* >*
    casadi_substitute__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        std::vector< casadi::SX > ret = substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_substitute__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_substitute__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_substitute__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_substitute__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_substitute__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2);
std::vector< casadi::DMatrix* >*
    casadi_substitute__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_substitute__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_substitute__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_substitute__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_substitute__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_substitute__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2);
std::vector< casadi::IMatrix* >*
    casadi_substitute__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);

        std::vector< casadi::IMatrix > ret = substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_substitute__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_substitute__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_substitute__5(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_substitute__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_substitute__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
std::vector< casadi::MX* >*
    casadi_substitute__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        std::vector< casadi::MX > ret = substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substitute" ===============
// cppName: "casadi::casadi_substitute"
// cWrapperName: "casadi_substitute__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_substitute__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// friendWrap: True
// fName: "casadi_substitute"
// call: "substitute(x0_, x1_, x2_)"
extern "C"
casadi::MX*
    casadi_substitute__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX*
    casadi_substitute__7(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        casadi::MX& x2_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x2);

        casadi::MX ret = substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_)"
extern "C"
void
    casadi_substituteInPlace__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2);
void
    casadi_substituteInPlace__0(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_substituteInPlace__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3);
void
    casadi_substituteInPlace__1(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_)"
extern "C"
void
    casadi_substituteInPlace__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2);
void
    casadi_substituteInPlace__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);

        substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, int x3)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_substituteInPlace__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, int x3);
void
    casadi_substituteInPlace__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::vector< casadi::DMatrix* >* x1, std::vector< casadi::DMatrix* >* x2, int x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::vector< casadi::DMatrix > x1_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x1);
        std::vector< casadi::DMatrix > x2_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_)"
extern "C"
void
    casadi_substituteInPlace__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2);
void
    casadi_substituteInPlace__4(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);

        substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, int x3)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_substituteInPlace__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, int x3);
void
    casadi_substituteInPlace__5(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0, std::vector< casadi::IMatrix* >* x1, std::vector< casadi::IMatrix* >* x2, int x3){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);
        std::vector< casadi::IMatrix > x1_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x1);
        std::vector< casadi::IMatrix > x2_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_)"
extern "C"
void
    casadi_substituteInPlace__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
void
    casadi_substituteInPlace__6(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_substituteInPlace" ===============
// cppName: "casadi::casadi_substituteInPlace"
// cWrapperName: "casadi_substituteInPlace__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void\n    casadi_substituteInPlace__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3)"
// friendWrap: True
// fName: "casadi_substituteInPlace"
// call: "substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void
    casadi_substituteInPlace__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3);
void
    casadi_substituteInPlace__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::casadi_sumCols" ===============
// cppName: "casadi::casadi_sumCols"
// cWrapperName: "casadi_sumCols__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sumCols__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sumCols"
// call: "sumCols(x0_)"
extern "C"
casadi::SX*
    casadi_sumCols__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sumCols__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sumCols(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumCols" ===============
// cppName: "casadi::casadi_sumCols"
// cWrapperName: "casadi_sumCols__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sumCols__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sumCols"
// call: "sumCols(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sumCols__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sumCols__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sumCols(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumCols" ===============
// cppName: "casadi::casadi_sumCols"
// cWrapperName: "casadi_sumCols__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sumCols__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sumCols"
// call: "sumCols(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sumCols__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sumCols__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sumCols(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumCols" ===============
// cppName: "casadi::casadi_sumCols"
// cWrapperName: "casadi_sumCols__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sumCols__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sumCols"
// call: "sumCols(x0_)"
extern "C"
casadi::MX*
    casadi_sumCols__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sumCols__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sumCols(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumRows" ===============
// cppName: "casadi::casadi_sumRows"
// cWrapperName: "casadi_sumRows__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sumRows__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sumRows"
// call: "sumRows(x0_)"
extern "C"
casadi::SX*
    casadi_sumRows__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sumRows__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sumRows(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumRows" ===============
// cppName: "casadi::casadi_sumRows"
// cWrapperName: "casadi_sumRows__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sumRows__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sumRows"
// call: "sumRows(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sumRows__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sumRows__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sumRows(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumRows" ===============
// cppName: "casadi::casadi_sumRows"
// cWrapperName: "casadi_sumRows__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sumRows__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sumRows"
// call: "sumRows(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sumRows__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sumRows__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sumRows(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sumRows" ===============
// cppName: "casadi::casadi_sumRows"
// cWrapperName: "casadi_sumRows__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sumRows__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sumRows"
// call: "sumRows(x0_)"
extern "C"
casadi::MX*
    casadi_sumRows__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sumRows__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sumRows(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sum_square" ===============
// cppName: "casadi::casadi_sum_square"
// cWrapperName: "casadi_sum_square__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_sum_square__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_sum_square"
// call: "sum_square(x0_)"
extern "C"
casadi::SX*
    casadi_sum_square__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_sum_square__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = sum_square(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sum_square" ===============
// cppName: "casadi::casadi_sum_square"
// cWrapperName: "casadi_sum_square__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_sum_square__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_sum_square"
// call: "sum_square(x0_)"
extern "C"
casadi::DMatrix*
    casadi_sum_square__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_sum_square__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = sum_square(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sum_square" ===============
// cppName: "casadi::casadi_sum_square"
// cWrapperName: "casadi_sum_square__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_sum_square__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_sum_square"
// call: "sum_square(x0_)"
extern "C"
casadi::IMatrix*
    casadi_sum_square__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_sum_square__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = sum_square(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_sum_square" ===============
// cppName: "casadi::casadi_sum_square"
// cWrapperName: "casadi_sum_square__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_sum_square__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_sum_square"
// call: "sum_square(x0_)"
extern "C"
casadi::MX*
    casadi_sum_square__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_sum_square__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = sum_square(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_symvar" ===============
// cppName: "casadi::casadi_symvar"
// cWrapperName: "casadi_symvar__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_symvar__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_symvar"
// call: "symvar(x0_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_symvar__0(std::string ** err_msg, casadi::SX* x0);
std::vector< casadi::SX* >*
    casadi_symvar__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        std::vector< casadi::SX > ret = symvar(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_symvar" ===============
// cppName: "casadi::casadi_symvar"
// cWrapperName: "casadi_symvar__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_symvar__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_symvar"
// call: "symvar(x0_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_symvar__1(std::string ** err_msg, casadi::DMatrix* x0);
std::vector< casadi::DMatrix* >*
    casadi_symvar__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = symvar(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_symvar" ===============
// cppName: "casadi::casadi_symvar"
// cWrapperName: "casadi_symvar__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_symvar__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_symvar"
// call: "symvar(x0_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_symvar__2(std::string ** err_msg, casadi::IMatrix* x0);
std::vector< casadi::IMatrix* >*
    casadi_symvar__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        std::vector< casadi::IMatrix > ret = symvar(x0_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_symvar" ===============
// cppName: "casadi::casadi_symvar"
// cWrapperName: "casadi_symvar__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_symvar__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_symvar"
// call: "symvar(x0_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_symvar__3(std::string ** err_msg, casadi::MX* x0);
std::vector< casadi::MX* >*
    casadi_symvar__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        std::vector< casadi::MX > ret = symvar(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tan" ===============
// cppName: "casadi::casadi_tan"
// cWrapperName: "casadi_tan__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tan__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_tan"
// call: "tan(x0_)"
extern "C"
casadi::SX*
    casadi_tan__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_tan__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = tan(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tan" ===============
// cppName: "casadi::casadi_tan"
// cWrapperName: "casadi_tan__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tan__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_tan"
// call: "tan(x0_)"
extern "C"
casadi::DMatrix*
    casadi_tan__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_tan__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = tan(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tan" ===============
// cppName: "casadi::casadi_tan"
// cWrapperName: "casadi_tan__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tan__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_tan"
// call: "tan(x0_)"
extern "C"
casadi::IMatrix*
    casadi_tan__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_tan__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = tan(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tan" ===============
// cppName: "casadi::casadi_tan"
// cWrapperName: "casadi_tan__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tan__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_tan"
// call: "tan(x0_)"
extern "C"
casadi::MX*
    casadi_tan__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_tan__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = tan(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tangent" ===============
// cppName: "casadi::casadi_tangent"
// cWrapperName: "casadi_tangent__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tangent__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_tangent"
// call: "tangent(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_tangent__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_tangent__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = tangent(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tangent" ===============
// cppName: "casadi::casadi_tangent"
// cWrapperName: "casadi_tangent__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tangent__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_tangent"
// call: "tangent(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_tangent__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_tangent__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = tangent(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tangent" ===============
// cppName: "casadi::casadi_tangent"
// cWrapperName: "casadi_tangent__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tangent__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_tangent"
// call: "tangent(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_tangent__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_tangent__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = tangent(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tangent" ===============
// cppName: "casadi::casadi_tangent"
// cWrapperName: "casadi_tangent__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tangent__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_tangent"
// call: "tangent(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_tangent__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_tangent__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = tangent(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tanh" ===============
// cppName: "casadi::casadi_tanh"
// cWrapperName: "casadi_tanh__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tanh__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_tanh"
// call: "tanh(x0_)"
extern "C"
casadi::SX*
    casadi_tanh__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_tanh__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = tanh(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tanh" ===============
// cppName: "casadi::casadi_tanh"
// cWrapperName: "casadi_tanh__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tanh__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_tanh"
// call: "tanh(x0_)"
extern "C"
casadi::DMatrix*
    casadi_tanh__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_tanh__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = tanh(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tanh" ===============
// cppName: "casadi::casadi_tanh"
// cWrapperName: "casadi_tanh__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tanh__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_tanh"
// call: "tanh(x0_)"
extern "C"
casadi::IMatrix*
    casadi_tanh__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_tanh__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = tanh(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tanh" ===============
// cppName: "casadi::casadi_tanh"
// cWrapperName: "casadi_tanh__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tanh__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_tanh"
// call: "tanh(x0_)"
extern "C"
casadi::MX*
    casadi_tanh__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_tanh__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = tanh(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = taylor(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_)"
extern "C"
casadi::SX*
    casadi_taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX*
    casadi_taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);

        casadi::SX ret = taylor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX*
    casadi_taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX*
    casadi_taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        casadi::SX& x2_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::SX ret = taylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_taylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_taylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_taylor__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = taylor(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_taylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix*
    casadi_taylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2);
casadi::DMatrix*
    casadi_taylor__4(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = taylor(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_taylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::DMatrix*
    casadi_taylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3);
casadi::DMatrix*
    casadi_taylor__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, casadi::DMatrix* x2, int x3){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        casadi::DMatrix& x2_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::DMatrix ret = taylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_taylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_taylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_taylor__6(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = taylor(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_taylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_)"
extern "C"
casadi::IMatrix*
    casadi_taylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2);
casadi::IMatrix*
    casadi_taylor__7(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);

        casadi::IMatrix ret = taylor(x0_, x1_, x2_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_taylor" ===============
// cppName: "casadi::casadi_taylor"
// cWrapperName: "casadi_taylor__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_taylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3)"
// friendWrap: True
// fName: "casadi_taylor"
// call: "taylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::IMatrix*
    casadi_taylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3);
casadi::IMatrix*
    casadi_taylor__8(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1, casadi::IMatrix* x2, int x3){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);
        casadi::IMatrix& x2_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::IMatrix ret = taylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_times" ===============
// cppName: "casadi::casadi_times"
// cWrapperName: "casadi_times__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_times__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_times"
// call: "x0_ * x1_"
extern "C"
casadi::SX*
    casadi_times__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_times__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = x0_ * x1_;
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_times" ===============
// cppName: "casadi::casadi_times"
// cWrapperName: "casadi_times__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_times__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_times"
// call: "x0_ * x1_"
extern "C"
casadi::DMatrix*
    casadi_times__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_times__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = x0_ * x1_;
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_times" ===============
// cppName: "casadi::casadi_times"
// cWrapperName: "casadi_times__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_times__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_times"
// call: "x0_ * x1_"
extern "C"
casadi::IMatrix*
    casadi_times__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_times__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = x0_ * x1_;
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_times" ===============
// cppName: "casadi::casadi_times"
// cWrapperName: "casadi_times__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_times__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_times"
// call: "x0_ * x1_"
extern "C"
casadi::MX*
    casadi_times__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_times__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = x0_ * x1_;
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_trace" ===============
// cppName: "casadi::casadi_trace"
// cWrapperName: "casadi_trace__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_trace__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_trace"
// call: "trace(x0_)"
extern "C"
casadi::SX*
    casadi_trace__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_trace__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = trace(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_trace" ===============
// cppName: "casadi::casadi_trace"
// cWrapperName: "casadi_trace__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_trace__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_trace"
// call: "trace(x0_)"
extern "C"
casadi::DMatrix*
    casadi_trace__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_trace__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = trace(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_trace" ===============
// cppName: "casadi::casadi_trace"
// cWrapperName: "casadi_trace__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_trace__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_trace"
// call: "trace(x0_)"
extern "C"
casadi::IMatrix*
    casadi_trace__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_trace__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = trace(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_trace" ===============
// cppName: "casadi::casadi_trace"
// cWrapperName: "casadi_trace__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_trace__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_trace"
// call: "trace(x0_)"
extern "C"
casadi::MX*
    casadi_trace__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_trace__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = trace(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_transpose" ===============
// cppName: "casadi::casadi_transpose"
// cWrapperName: "casadi_transpose__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_transpose__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_transpose"
// call: "transpose(x0_)"
extern "C"
casadi::SX*
    casadi_transpose__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_transpose__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = transpose(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_transpose" ===============
// cppName: "casadi::casadi_transpose"
// cWrapperName: "casadi_transpose__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_transpose__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_transpose"
// call: "transpose(x0_)"
extern "C"
casadi::DMatrix*
    casadi_transpose__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_transpose__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = transpose(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_transpose" ===============
// cppName: "casadi::casadi_transpose"
// cWrapperName: "casadi_transpose__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_transpose__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_transpose"
// call: "transpose(x0_)"
extern "C"
casadi::IMatrix*
    casadi_transpose__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_transpose__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = transpose(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_transpose" ===============
// cppName: "casadi::casadi_transpose"
// cWrapperName: "casadi_transpose__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_transpose__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_transpose"
// call: "transpose(x0_)"
extern "C"
casadi::MX*
    casadi_transpose__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_transpose__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = transpose(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_transpose" ===============
// cppName: "casadi::casadi_transpose"
// cWrapperName: "casadi_transpose__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_transpose__4(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_transpose"
// call: "transpose(x0_)"
extern "C"
casadi::Sparsity*
    casadi_transpose__4(std::string ** err_msg, casadi::Sparsity* x0);
casadi::Sparsity*
    casadi_transpose__4(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        casadi::Sparsity ret = transpose(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triangle" ===============
// cppName: "casadi::casadi_triangle"
// cWrapperName: "casadi_triangle__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_triangle__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_triangle"
// call: "triangle(x0_)"
extern "C"
casadi::SX*
    casadi_triangle__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_triangle__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = triangle(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triangle" ===============
// cppName: "casadi::casadi_triangle"
// cWrapperName: "casadi_triangle__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_triangle__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_triangle"
// call: "triangle(x0_)"
extern "C"
casadi::DMatrix*
    casadi_triangle__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_triangle__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = triangle(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triangle" ===============
// cppName: "casadi::casadi_triangle"
// cWrapperName: "casadi_triangle__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_triangle__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_triangle"
// call: "triangle(x0_)"
extern "C"
casadi::IMatrix*
    casadi_triangle__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_triangle__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = triangle(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tril__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_)"
extern "C"
casadi::SX*
    casadi_tril__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_tril__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = tril(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tril__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_tril__1(std::string ** err_msg, casadi::SX* x0, int x1);
casadi::SX*
    casadi_tril__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::SX ret = tril(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tril__2(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_)"
extern "C"
casadi::DMatrix*
    casadi_tril__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_tril__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = tril(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tril__3(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_tril__3(std::string ** err_msg, casadi::DMatrix* x0, int x1);
casadi::DMatrix*
    casadi_tril__3(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::DMatrix ret = tril(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tril__4(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_)"
extern "C"
casadi::IMatrix*
    casadi_tril__4(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_tril__4(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = tril(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tril__5(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_tril__5(std::string ** err_msg, casadi::IMatrix* x0, int x1);
casadi::IMatrix*
    casadi_tril__5(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::IMatrix ret = tril(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tril__6(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_)"
extern "C"
casadi::MX*
    casadi_tril__6(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_tril__6(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = tril(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tril__7(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_tril__7(std::string ** err_msg, casadi::MX* x0, int x1);
casadi::MX*
    casadi_tril__7(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::MX ret = tril(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__8"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_tril__8(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_)"
extern "C"
casadi::Sparsity*
    casadi_tril__8(std::string ** err_msg, casadi::Sparsity* x0);
casadi::Sparsity*
    casadi_tril__8(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        casadi::Sparsity ret = tril(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril" ===============
// cppName: "casadi::casadi_tril"
// cWrapperName: "casadi_tril__9"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_tril__9(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_tril"
// call: "tril(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_tril__9(std::string ** err_msg, casadi::Sparsity* x0, int x1);
casadi::Sparsity*
    casadi_tril__9(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::Sparsity ret = tril(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril2symm" ===============
// cppName: "casadi::casadi_tril2symm"
// cWrapperName: "casadi_tril2symm__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_tril2symm__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_tril2symm"
// call: "tril2symm(x0_)"
extern "C"
casadi::SX*
    casadi_tril2symm__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_tril2symm__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = tril2symm(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril2symm" ===============
// cppName: "casadi::casadi_tril2symm"
// cWrapperName: "casadi_tril2symm__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_tril2symm__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_tril2symm"
// call: "tril2symm(x0_)"
extern "C"
casadi::DMatrix*
    casadi_tril2symm__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_tril2symm__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = tril2symm(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril2symm" ===============
// cppName: "casadi::casadi_tril2symm"
// cWrapperName: "casadi_tril2symm__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_tril2symm__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_tril2symm"
// call: "tril2symm(x0_)"
extern "C"
casadi::IMatrix*
    casadi_tril2symm__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_tril2symm__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = tril2symm(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_tril2symm" ===============
// cppName: "casadi::casadi_tril2symm"
// cWrapperName: "casadi_tril2symm__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_tril2symm__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_tril2symm"
// call: "tril2symm(x0_)"
extern "C"
casadi::MX*
    casadi_tril2symm__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_tril2symm__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = tril2symm(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_triu__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_)"
extern "C"
casadi::SX*
    casadi_triu__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_triu__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = triu(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_triu__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_triu__1(std::string ** err_msg, casadi::SX* x0, int x1);
casadi::SX*
    casadi_triu__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::SX ret = triu(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_triu__2(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_)"
extern "C"
casadi::DMatrix*
    casadi_triu__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_triu__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = triu(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_triu__3(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_triu__3(std::string ** err_msg, casadi::DMatrix* x0, int x1);
casadi::DMatrix*
    casadi_triu__3(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::DMatrix ret = triu(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_triu__4(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_)"
extern "C"
casadi::IMatrix*
    casadi_triu__4(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_triu__4(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = triu(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__5"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_triu__5(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_triu__5(std::string ** err_msg, casadi::IMatrix* x0, int x1);
casadi::IMatrix*
    casadi_triu__5(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::IMatrix ret = triu(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__6"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_triu__6(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_)"
extern "C"
casadi::MX*
    casadi_triu__6(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_triu__6(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = triu(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__7"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_triu__7(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_triu__7(std::string ** err_msg, casadi::MX* x0, int x1);
casadi::MX*
    casadi_triu__7(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::MX ret = triu(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__8"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_triu__8(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_)"
extern "C"
casadi::Sparsity*
    casadi_triu__8(std::string ** err_msg, casadi::Sparsity* x0);
casadi::Sparsity*
    casadi_triu__8(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        casadi::Sparsity ret = triu(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu" ===============
// cppName: "casadi::casadi_triu"
// cWrapperName: "casadi_triu__9"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_triu__9(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_triu"
// call: "triu(x0_, x1_)"
extern "C"
casadi::Sparsity*
    casadi_triu__9(std::string ** err_msg, casadi::Sparsity* x0, int x1);
casadi::Sparsity*
    casadi_triu__9(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        bool x1_ = Marshaling<bool,int>::marshal(x1);

        casadi::Sparsity ret = triu(x0_, x1_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu2symm" ===============
// cppName: "casadi::casadi_triu2symm"
// cWrapperName: "casadi_triu2symm__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_triu2symm__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_triu2symm"
// call: "triu2symm(x0_)"
extern "C"
casadi::SX*
    casadi_triu2symm__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_triu2symm__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = triu2symm(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu2symm" ===============
// cppName: "casadi::casadi_triu2symm"
// cWrapperName: "casadi_triu2symm__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_triu2symm__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_triu2symm"
// call: "triu2symm(x0_)"
extern "C"
casadi::DMatrix*
    casadi_triu2symm__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_triu2symm__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = triu2symm(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu2symm" ===============
// cppName: "casadi::casadi_triu2symm"
// cWrapperName: "casadi_triu2symm__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_triu2symm__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_triu2symm"
// call: "triu2symm(x0_)"
extern "C"
casadi::IMatrix*
    casadi_triu2symm__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_triu2symm__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = triu2symm(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_triu2symm" ===============
// cppName: "casadi::casadi_triu2symm"
// cWrapperName: "casadi_triu2symm__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_triu2symm__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_triu2symm"
// call: "triu2symm(x0_)"
extern "C"
casadi::MX*
    casadi_triu2symm__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_triu2symm__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = triu2symm(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_unite" ===============
// cppName: "casadi::casadi_unite"
// cWrapperName: "casadi_unite__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_unite__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// friendWrap: True
// fName: "casadi_unite"
// call: "unite(x0_, x1_)"
extern "C"
casadi::SX*
    casadi_unite__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX*
    casadi_unite__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        casadi::SX ret = unite(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_unite" ===============
// cppName: "casadi::casadi_unite"
// cWrapperName: "casadi_unite__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_unite__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// friendWrap: True
// fName: "casadi_unite"
// call: "unite(x0_, x1_)"
extern "C"
casadi::DMatrix*
    casadi_unite__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix*
    casadi_unite__1(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = unite(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_unite" ===============
// cppName: "casadi::casadi_unite"
// cWrapperName: "casadi_unite__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_unite__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// friendWrap: True
// fName: "casadi_unite"
// call: "unite(x0_, x1_)"
extern "C"
casadi::IMatrix*
    casadi_unite__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix*
    casadi_unite__2(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix& x1_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = unite(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_unite" ===============
// cppName: "casadi::casadi_unite"
// cWrapperName: "casadi_unite__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_unite__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// friendWrap: True
// fName: "casadi_unite"
// call: "unite(x0_, x1_)"
extern "C"
casadi::MX*
    casadi_unite__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX*
    casadi_unite__3(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        casadi::MX ret = unite(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vec" ===============
// cppName: "casadi::casadi_vec"
// cWrapperName: "casadi_vec__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_vec__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_vec"
// call: "vec(x0_)"
extern "C"
casadi::SX*
    casadi_vec__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_vec__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = vec(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vec" ===============
// cppName: "casadi::casadi_vec"
// cWrapperName: "casadi_vec__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_vec__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_vec"
// call: "vec(x0_)"
extern "C"
casadi::DMatrix*
    casadi_vec__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_vec__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = vec(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vec" ===============
// cppName: "casadi::casadi_vec"
// cWrapperName: "casadi_vec__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_vec__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_vec"
// call: "vec(x0_)"
extern "C"
casadi::IMatrix*
    casadi_vec__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_vec__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = vec(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vec" ===============
// cppName: "casadi::casadi_vec"
// cWrapperName: "casadi_vec__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_vec__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_vec"
// call: "vec(x0_)"
extern "C"
casadi::MX*
    casadi_vec__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_vec__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = vec(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vec" ===============
// cppName: "casadi::casadi_vec"
// cWrapperName: "casadi_vec__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_vec__4(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_vec"
// call: "vec(x0_)"
extern "C"
casadi::Sparsity*
    casadi_vec__4(std::string ** err_msg, casadi::Sparsity* x0);
casadi::Sparsity*
    casadi_vec__4(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        casadi::Sparsity ret = vec(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vecNZ" ===============
// cppName: "casadi::casadi_vecNZ"
// cWrapperName: "casadi_vecNZ__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_vecNZ__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_vecNZ"
// call: "vecNZ(x0_)"
extern "C"
casadi::SX*
    casadi_vecNZ__0(std::string ** err_msg, casadi::SX* x0);
casadi::SX*
    casadi_vecNZ__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        casadi::SX ret = vecNZ(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vecNZ" ===============
// cppName: "casadi::casadi_vecNZ"
// cWrapperName: "casadi_vecNZ__1"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_vecNZ__1(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_vecNZ"
// call: "vecNZ(x0_)"
extern "C"
casadi::DMatrix*
    casadi_vecNZ__1(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix*
    casadi_vecNZ__1(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = vecNZ(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vecNZ" ===============
// cppName: "casadi::casadi_vecNZ"
// cWrapperName: "casadi_vecNZ__2"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_vecNZ__2(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_vecNZ"
// call: "vecNZ(x0_)"
extern "C"
casadi::IMatrix*
    casadi_vecNZ__2(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix*
    casadi_vecNZ__2(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = vecNZ(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vecNZ" ===============
// cppName: "casadi::casadi_vecNZ"
// cWrapperName: "casadi_vecNZ__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_vecNZ__3(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_vecNZ"
// call: "vecNZ(x0_)"
extern "C"
casadi::MX*
    casadi_vecNZ__3(std::string ** err_msg, casadi::MX* x0);
casadi::MX*
    casadi_vecNZ__3(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        casadi::MX ret = vecNZ(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vecNZ" ===============
// cppName: "casadi::casadi_vecNZ"
// cWrapperName: "casadi_vecNZ__4"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_vecNZ__4(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_vecNZ"
// call: "vecNZ(x0_)"
extern "C"
casadi::Sparsity*
    casadi_vecNZ__4(std::string ** err_msg, casadi::Sparsity* x0);
casadi::Sparsity*
    casadi_vecNZ__4(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        casadi::Sparsity ret = vecNZ(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_veccat" ===============
// cppName: "casadi::casadi_veccat"
// cWrapperName: "casadi_veccat__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_veccat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_veccat"
// call: "veccat(x0_)"
extern "C"
casadi::SX*
    casadi_veccat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
casadi::SX*
    casadi_veccat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        casadi::SX ret = veccat(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_veccat" ===============
// cppName: "casadi::casadi_veccat"
// cWrapperName: "casadi_veccat__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_veccat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_veccat"
// call: "veccat(x0_)"
extern "C"
casadi::DMatrix*
    casadi_veccat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
casadi::DMatrix*
    casadi_veccat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        casadi::DMatrix ret = veccat(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_veccat" ===============
// cppName: "casadi::casadi_veccat"
// cWrapperName: "casadi_veccat__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_veccat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_veccat"
// call: "veccat(x0_)"
extern "C"
casadi::IMatrix*
    casadi_veccat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
casadi::IMatrix*
    casadi_veccat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        casadi::IMatrix ret = veccat(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_veccat" ===============
// cppName: "casadi::casadi_veccat"
// cWrapperName: "casadi_veccat__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_veccat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_veccat"
// call: "veccat(x0_)"
extern "C"
casadi::MX*
    casadi_veccat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX*
    casadi_veccat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = veccat(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_veccat" ===============
// cppName: "casadi::casadi_veccat"
// cWrapperName: "casadi_veccat__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_veccat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_veccat"
// call: "veccat(x0_)"
extern "C"
casadi::Sparsity*
    casadi_veccat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
casadi::Sparsity*
    casadi_veccat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        casadi::Sparsity ret = veccat(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertcat" ===============
// cppName: "casadi::casadi_vertcat"
// cWrapperName: "casadi_vertcat__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX*\n    casadi_vertcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// friendWrap: True
// fName: "casadi_vertcat"
// call: "vertcat(x0_)"
extern "C"
casadi::SX*
    casadi_vertcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0);
casadi::SX*
    casadi_vertcat__0(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        casadi::SX ret = vertcat(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertcat" ===============
// cppName: "casadi::casadi_vertcat"
// cWrapperName: "casadi_vertcat__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix*\n    casadi_vertcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_vertcat"
// call: "vertcat(x0_)"
extern "C"
casadi::DMatrix*
    casadi_vertcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
casadi::DMatrix*
    casadi_vertcat__1(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        casadi::DMatrix ret = vertcat(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertcat" ===============
// cppName: "casadi::casadi_vertcat"
// cWrapperName: "casadi_vertcat__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix*\n    casadi_vertcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0)"
// friendWrap: True
// fName: "casadi_vertcat"
// call: "vertcat(x0_)"
extern "C"
casadi::IMatrix*
    casadi_vertcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0);
casadi::IMatrix*
    casadi_vertcat__2(std::string ** err_msg, std::vector< casadi::IMatrix* >* x0){
    try {
        std::vector< casadi::IMatrix > x0_ = Marshaling<std::vector< casadi::IMatrix >,std::vector< casadi::IMatrix* >*>::marshal(x0);

        casadi::IMatrix ret = vertcat(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertcat" ===============
// cppName: "casadi::casadi_vertcat"
// cWrapperName: "casadi_vertcat__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX*\n    casadi_vertcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// friendWrap: True
// fName: "casadi_vertcat"
// call: "vertcat(x0_)"
extern "C"
casadi::MX*
    casadi_vertcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX*
    casadi_vertcat__3(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = vertcat(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertcat" ===============
// cppName: "casadi::casadi_vertcat"
// cWrapperName: "casadi_vertcat__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: UserType (Namespace ["casadi"]) (Name "Sparsity")
// args: "(x0_)"
// cWrapperRetType: "casadi::Sparsity*"
// proto: "casadi::Sparsity*\n    casadi_vertcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// friendWrap: True
// fName: "casadi_vertcat"
// call: "vertcat(x0_)"
extern "C"
casadi::Sparsity*
    casadi_vertcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
casadi::Sparsity*
    casadi_vertcat__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        casadi::Sparsity ret = vertcat(x0_);
        return WrapReturn< casadi::Sparsity*, casadi::Sparsity >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_vertsplit__0(std::string ** err_msg, casadi::SX* x0)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_vertsplit__0(std::string ** err_msg, casadi::SX* x0);
std::vector< casadi::SX* >*
    casadi_vertsplit__0(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);

        std::vector< casadi::SX > ret = vertsplit(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_vertsplit__1(std::string ** err_msg, casadi::SX* x0, int x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_vertsplit__1(std::string ** err_msg, casadi::SX* x0, int x1);
std::vector< casadi::SX* >*
    casadi_vertsplit__1(std::string ** err_msg, casadi::SX* x0, int x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::SX > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >*\n    casadi_vertsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >*
    casadi_vertsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1);
std::vector< casadi::SX* >*
    casadi_vertsplit__2(std::string ** err_msg, casadi::SX* x0, std::vector< int >* x1){
    try {
        casadi::SX& x0_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::SX > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_vertsplit__3(std::string ** err_msg, casadi::DMatrix* x0)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__3(std::string ** err_msg, casadi::DMatrix* x0);
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__3(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = vertsplit(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_vertsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1);
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__4(std::string ** err_msg, casadi::DMatrix* x0, int x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::DMatrix > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >*\n    casadi_vertsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1);
std::vector< casadi::DMatrix* >*
    casadi_vertsplit__5(std::string ** err_msg, casadi::DMatrix* x0, std::vector< int >* x1){
    try {
        casadi::DMatrix& x0_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__6"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_vertsplit__6(std::string ** err_msg, casadi::IMatrix* x0)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__6(std::string ** err_msg, casadi::IMatrix* x0);
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__6(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);

        std::vector< casadi::IMatrix > ret = vertsplit(x0_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__7"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_vertsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1);
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__7(std::string ** err_msg, casadi::IMatrix* x0, int x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::IMatrix > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__8"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "IMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::IMatrix* >*"
// proto: "std::vector< casadi::IMatrix* >*\n    casadi_vertsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1);
std::vector< casadi::IMatrix* >*
    casadi_vertsplit__8(std::string ** err_msg, casadi::IMatrix* x0, std::vector< int >* x1){
    try {
        casadi::IMatrix& x0_ = Marshaling<casadi::IMatrix&,casadi::IMatrix*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::IMatrix > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::IMatrix* >*, std::vector< casadi::IMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__9"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_vertsplit__9(std::string ** err_msg, casadi::MX* x0)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_vertsplit__9(std::string ** err_msg, casadi::MX* x0);
std::vector< casadi::MX* >*
    casadi_vertsplit__9(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);

        std::vector< casadi::MX > ret = vertsplit(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__10"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_vertsplit__10(std::string ** err_msg, casadi::MX* x0, int x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_vertsplit__10(std::string ** err_msg, casadi::MX* x0, int x1);
std::vector< casadi::MX* >*
    casadi_vertsplit__10(std::string ** err_msg, casadi::MX* x0, int x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::MX > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__11"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >*\n    casadi_vertsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >*
    casadi_vertsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1);
std::vector< casadi::MX* >*
    casadi_vertsplit__11(std::string ** err_msg, casadi::MX* x0, std::vector< int >* x1){
    try {
        casadi::MX& x0_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::MX > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__12"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_vertsplit__12(std::string ** err_msg, casadi::Sparsity* x0)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__12(std::string ** err_msg, casadi::Sparsity* x0);
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__12(std::string ** err_msg, casadi::Sparsity* x0){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = vertsplit(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__13"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),CInt]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_vertsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1);
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__13(std::string ** err_msg, casadi::Sparsity* x0, int x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< casadi::Sparsity > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::casadi_vertsplit" ===============
// cppName: "casadi::casadi_vertsplit"
// cWrapperName: "casadi_vertsplit__14"
// protoArgs: "(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const (StdVec CInt))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >*\n    casadi_vertsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1)"
// friendWrap: True
// fName: "casadi_vertsplit"
// call: "vertsplit(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1);
std::vector< casadi::Sparsity* >*
    casadi_vertsplit__14(std::string ** err_msg, casadi::Sparsity* x0, std::vector< int >* x1){
    try {
        casadi::Sparsity& x0_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x0);
        std::vector< int > x1_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = vertsplit(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    cleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    cleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    cleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    cleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    cleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    cleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    cleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    cleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    cleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    cleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    cleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    cleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "cleIn"
// call: "casadi::cleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::cleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    cleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "cleOut"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    cleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    cleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "cleOut"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    cleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    cleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "cleOut"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    cleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    cleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "cleOut"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    cleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::collocationInterpolators" ===============
// cppName: "casadi::collocationInterpolators"
// cWrapperName: "collocationInterpolators"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0, std::vector< std::vector< double >* >* x1, std::vector< double >* x2)"
// params: [Ref (Const (StdVec CDouble)),Ref (StdVec (StdVec CDouble)),Ref (StdVec CDouble)]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void\n    collocationInterpolators(std::string ** err_msg, std::vector< double >* x0, std::vector< std::vector< double >* >* x1, std::vector< double >* x2)"
// friendWrap: False
// fName: "collocationInterpolators"
// call: "casadi::collocationInterpolators(x0_, x1_, x2_)"
extern "C"
void
    collocationInterpolators(std::string ** err_msg, std::vector< double >* x0, std::vector< std::vector< double >* >* x1, std::vector< double >* x2);
void
    collocationInterpolators(std::string ** err_msg, std::vector< double >* x0, std::vector< std::vector< double >* >* x1, std::vector< double >* x2){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);
        std::vector< std::vector< double > > x1_ = Marshaling<std::vector< std::vector< double > >,std::vector< std::vector< double >* >*>::marshal(x1);
        std::vector< double > x2_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x2);

        casadi::collocationInterpolators(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::collocationPoints" ===============
// cppName: "casadi::collocationPoints"
// cWrapperName: "collocationPoints__0"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CInt]
// retType: StdVec CDouble
// args: "(x0_)"
// cWrapperRetType: "std::vector< double >*"
// proto: "std::vector< double >*\n    collocationPoints__0(std::string ** err_msg, int x0)"
// friendWrap: False
// fName: "collocationPoints"
// call: "casadi::collocationPoints(x0_)"
extern "C"
std::vector< double >*
    collocationPoints__0(std::string ** err_msg, int x0);
std::vector< double >*
    collocationPoints__0(std::string ** err_msg, int x0){
    try {
        int x0_ = Marshaling<int,int>::marshal(x0);

        std::vector< double > ret = casadi::collocationPoints(x0_);
        return WrapReturn< std::vector< double >*, std::vector< double > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::collocationPoints" ===============
// cppName: "casadi::collocationPoints"
// cWrapperName: "collocationPoints__1"
// protoArgs: "(std::string ** err_msg, int x0, std::string* x1)"
// params: [CInt,Ref (Const StdString)]
// retType: StdVec CDouble
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< double >*"
// proto: "std::vector< double >*\n    collocationPoints__1(std::string ** err_msg, int x0, std::string* x1)"
// friendWrap: False
// fName: "collocationPoints"
// call: "casadi::collocationPoints(x0_, x1_)"
extern "C"
std::vector< double >*
    collocationPoints__1(std::string ** err_msg, int x0, std::string* x1);
std::vector< double >*
    collocationPoints__1(std::string ** err_msg, int x0, std::string* x1){
    try {
        int x0_ = Marshaling<int,int>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        std::vector< double > ret = casadi::collocationPoints(x0_, x1_);
        return WrapReturn< std::vector< double >*, std::vector< double > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::complement" ===============
// cppName: "casadi::complement"
// cWrapperName: "complement"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0, int x1)"
// params: [Ref (Const (StdVec CInt)),CInt]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    complement(std::string ** err_msg, std::vector< int >* x0, int x1)"
// friendWrap: False
// fName: "complement"
// call: "casadi::complement(x0_, x1_)"
extern "C"
std::vector< int >*
    complement(std::string ** err_msg, std::vector< int >* x0, int x1);
std::vector< int >*
    complement(std::string ** err_msg, std::vector< int >* x0, int x1){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< int > ret = casadi::complement(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controldaeIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controldaeIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controldaeIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controldaeIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controldaeIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controldaeIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__69"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controldaeIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "controldaeIn"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controldaeIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    controlsimulatorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    controlsimulatorIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    controlsimulatorIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "controlsimulatorIn"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    controlsimulatorIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "daeIn"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    daeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    daeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    daeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    daeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    daeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    daeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    daeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "daeOut"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    daeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::daeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "dleIn"
// call: "casadi::dleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "dleOut"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "dleOut"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "dleOut"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "dleOut"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dpleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dpleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dpleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dpleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dpleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dpleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dpleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dpleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dpleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "dpleIn"
// call: "casadi::dpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    dpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "dpleOut"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    dpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    dpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "dpleOut"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    dpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    dpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "dpleOut"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    dpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    dpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "dpleOut"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    dpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryDoc" ===============
// cppName: "casadi::getSchemeEntryDoc"
// cWrapperName: "getSchemeEntryDoc"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    getSchemeEntryDoc(std::string ** err_msg, int x0, int x1)"
// friendWrap: False
// fName: "getSchemeEntryDoc"
// call: "casadi::getSchemeEntryDoc(x0_, x1_)"
extern "C"
std::string*
    getSchemeEntryDoc(std::string ** err_msg, int x0, int x1);
std::string*
    getSchemeEntryDoc(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryDoc(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryEnum" ===============
// cppName: "casadi::getSchemeEntryEnum"
// cWrapperName: "getSchemeEntryEnum"
// protoArgs: "(std::string ** err_msg, int x0, std::string* x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),Ref (Const StdString)]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int\n    getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1)"
// friendWrap: False
// fName: "getSchemeEntryEnum"
// call: "casadi::getSchemeEntryEnum(x0_, x1_)"
extern "C"
int
    getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1);
int
    getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        int ret = casadi::getSchemeEntryEnum(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryEnumName" ===============
// cppName: "casadi::getSchemeEntryEnumName"
// cWrapperName: "getSchemeEntryEnumName"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1)"
// friendWrap: False
// fName: "getSchemeEntryEnumName"
// call: "casadi::getSchemeEntryEnumName(x0_, x1_)"
extern "C"
std::string*
    getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1);
std::string*
    getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryEnumName(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryName" ===============
// cppName: "casadi::getSchemeEntryName"
// cWrapperName: "getSchemeEntryName"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    getSchemeEntryName(std::string ** err_msg, int x0, int x1)"
// friendWrap: False
// fName: "getSchemeEntryName"
// call: "casadi::getSchemeEntryName(x0_, x1_)"
extern "C"
std::string*
    getSchemeEntryName(std::string ** err_msg, int x0, int x1);
std::string*
    getSchemeEntryName(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryName(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryNames" ===============
// cppName: "casadi::getSchemeEntryNames"
// cWrapperName: "getSchemeEntryNames"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: StdString
// args: "(x0_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    getSchemeEntryNames(std::string ** err_msg, int x0)"
// friendWrap: False
// fName: "getSchemeEntryNames"
// call: "casadi::getSchemeEntryNames(x0_)"
extern "C"
std::string*
    getSchemeEntryNames(std::string ** err_msg, int x0);
std::string*
    getSchemeEntryNames(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        std::string ret = casadi::getSchemeEntryNames(x0_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeName" ===============
// cppName: "casadi::getSchemeName"
// cWrapperName: "getSchemeName"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: StdString
// args: "(x0_)"
// cWrapperRetType: "std::string*"
// proto: "std::string*\n    getSchemeName(std::string ** err_msg, int x0)"
// friendWrap: False
// fName: "getSchemeName"
// call: "casadi::getSchemeName(x0_)"
extern "C"
std::string*
    getSchemeName(std::string ** err_msg, int x0);
std::string*
    getSchemeName(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        std::string ret = casadi::getSchemeName(x0_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeSize" ===============
// cppName: "casadi::getSchemeSize"
// cWrapperName: "getSchemeSize"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int\n    getSchemeSize(std::string ** err_msg, int x0)"
// friendWrap: False
// fName: "getSchemeSize"
// call: "casadi::getSchemeSize(x0_)"
extern "C"
int
    getSchemeSize(std::string ** err_msg, int x0);
int
    getSchemeSize(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        int ret = casadi::getSchemeSize(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "gradFIn"
// call: "casadi::gradFIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    gradFOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    gradFOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    gradFOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    gradFOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    gradFOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    gradFOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    gradFOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "gradFOut"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    gradFOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::gradFOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "hessLagIn"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hessLagOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hessLagOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hessLagOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hessLagOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__21(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__21(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__21(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hessLagOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hessLagOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__30(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__30(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__30(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__31(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__31(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__31(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__32(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__32(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__32(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__33(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__33(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__33(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__34(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__34(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__34(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hessLagOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "hessLagOut"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hessLagOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hnlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hnlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hnlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hnlpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    hnlpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    hnlpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hnlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hnlpIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hnlpIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hnlpIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    hnlpIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    hnlpIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hnlpIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hnlpIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hnlpIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hnlpIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    hnlpIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    hnlpIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hnlpIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hnlpIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hnlpIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hnlpIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    hnlpIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "hnlpIn"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    hnlpIn__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "integratorIn"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    integratorOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    integratorOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    integratorOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    integratorOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    integratorOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    integratorOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    integratorOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "integratorOut"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    integratorOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "jacGIn"
// call: "casadi::jacGIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    jacGOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    jacGOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    jacGOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    jacGOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    jacGOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    jacGOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    jacGOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "jacGOut"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    jacGOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::jacGOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    linsolIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    linsolIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    linsolIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    linsolIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    linsolIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    linsolIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    linsolIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    linsolIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    linsolIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    linsolIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    linsolIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    linsolIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "linsolIn"
// call: "casadi::linsolIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::linsolIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    linsolOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "linsolOut"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    linsolOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    linsolOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "linsolOut"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    linsolOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    linsolOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "linsolOut"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    linsolOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    linsolOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "linsolOut"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    linsolOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lookupvector" ===============
// cppName: "casadi::lookupvector"
// cWrapperName: "lookupvector"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0, int x1)"
// params: [Ref (Const (StdVec CInt)),CInt]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >*\n    lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1)"
// friendWrap: False
// fName: "lookupvector"
// call: "casadi::lookupvector(x0_, x1_)"
extern "C"
std::vector< int >*
    lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1);
std::vector< int >*
    lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< int > ret = casadi::lookupvector(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__22(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__35(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "lpIn"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "lpOut"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "lrdleIn"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lrdleOut"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lrdleOut"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lrdleOut"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lrdleOut"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleIn__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "lrdpleIn"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleIn__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    lrdpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "lrdpleOut"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    lrdpleOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    lrdpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "lrdpleOut"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    lrdpleOut__1(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    lrdpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "lrdpleOut"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    lrdpleOut__2(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    lrdpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "lrdpleOut"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    lrdpleOut__5(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpIn__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpIn__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "nlpIn"
// call: "casadi::nlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpIn__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpOut__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__3(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpOut__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__4(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpOut__6(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__6(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__6(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpOut__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__7(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpOut__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpOut__8(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpOut__11(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__11(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__11(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpOut__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__12(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpOut__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "nlpOut"
// call: "casadi::nlpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpOut__13(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "nlpSolverIn"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    nlpSolverOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    nlpSolverOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    nlpSolverOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    nlpSolverOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    nlpSolverOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    nlpSolverOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "nlpSolverOut"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    nlpSolverOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::Sparsity& x23_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x23);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::DMatrix& x23_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x23);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::MX& x23_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x23);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__71"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__72"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__73"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__74"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__75"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__76"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__77"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__78"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__79"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__80"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__81"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__82"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__83"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__84"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__85"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__86"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__87"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__88"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__89"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__90"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__91"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__92"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__93"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23)"
// friendWrap: False
// fName: "qcqpIn"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::SX& x23_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x23);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qcqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qcqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qcqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qcqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qcqpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qcqpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qcqpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "qcqpOut"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qcqpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__69"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "qpIn"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    qpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    qpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__10(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    qpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    qpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__15(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__16(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__17(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__18(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__19(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    qpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    qpOut__20(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__23(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__24(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__25(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__26(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__27(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__28(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    qpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "qpOut"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    qpOut__29(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__26(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__41(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "rdaeIn"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    rdaeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    rdaeOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__5(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__6(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__7(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__8(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    rdaeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    rdaeOut__9(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__10(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__11(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__12(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__13(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    rdaeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    rdaeOut__14(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__17(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__18(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__19(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__20(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    rdaeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "rdaeOut"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    rdaeOut__21(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__30(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__47(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "sdpIn"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "sdpOut"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__34(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__53(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__54(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__55(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__56(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__57(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__58(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__69"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "sdqpIn"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    sdqpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    sdqpOut__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    sdqpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    sdqpOut__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__33(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__34(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__35(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__36(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__37(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    sdqpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    sdqpOut__38(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__46(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__47(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__48(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__49(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__50(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__51(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__52(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    sdqpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "sdqpOut"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    sdqpOut__53(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__0"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0)"
// params: [UserType (Namespace ["casadi"]) (Name "Function")]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__0(std::string ** err_msg, casadi::Function* x0)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_)"
extern "C"
casadi::MXFunction*
    simpleIRK__0(std::string ** err_msg, casadi::Function* x0);
casadi::MXFunction*
    simpleIRK__0(std::string ** err_msg, casadi::Function* x0){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);

        casadi::MXFunction ret = casadi::simpleIRK(x0_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__1"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__1(std::string ** err_msg, casadi::Function* x0, int x1)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_, x1_)"
extern "C"
casadi::MXFunction*
    simpleIRK__1(std::string ** err_msg, casadi::Function* x0, int x1);
casadi::MXFunction*
    simpleIRK__1(std::string ** err_msg, casadi::Function* x0, int x1){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::MXFunction ret = casadi::simpleIRK(x0_, x1_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__2"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1, int x2)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_, x1_, x2_)"
extern "C"
casadi::MXFunction*
    simpleIRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2);
casadi::MXFunction*
    simpleIRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MXFunction ret = casadi::simpleIRK(x0_, x1_, x2_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__3"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt,CInt,Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__3(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_, x1_, x2_, x3_)"
extern "C"
casadi::MXFunction*
    simpleIRK__3(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3);
casadi::MXFunction*
    simpleIRK__3(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);

        casadi::MXFunction ret = casadi::simpleIRK(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__4"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt,CInt,Ref (Const StdString),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__4(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::MXFunction*
    simpleIRK__4(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4);
casadi::MXFunction*
    simpleIRK__4(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        casadi::MXFunction ret = casadi::simpleIRK(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIRK" ===============
// cppName: "casadi::simpleIRK"
// cWrapperName: "simpleIRK__5"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4, std::map< std::string, casadi::GenericType* >* x5)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt,CInt,Ref (Const StdString),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIRK__5(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4, std::map< std::string, casadi::GenericType* >* x5)"
// friendWrap: False
// fName: "simpleIRK"
// call: "casadi::simpleIRK(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
casadi::MXFunction*
    simpleIRK__5(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4, std::map< std::string, casadi::GenericType* >* x5);
casadi::MXFunction*
    simpleIRK__5(std::string ** err_msg, casadi::Function* x0, int x1, int x2, std::string* x3, std::string* x4, std::map< std::string, casadi::GenericType* >* x5){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);
        std::string& x3_ = Marshaling<std::string&,std::string*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        std::map< std::string, casadi::GenericType > x5_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x5);

        casadi::MXFunction ret = casadi::simpleIRK(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIntegrator" ===============
// cppName: "casadi::simpleIntegrator"
// cWrapperName: "simpleIntegrator__0"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0)"
// params: [UserType (Namespace ["casadi"]) (Name "Function")]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIntegrator__0(std::string ** err_msg, casadi::Function* x0)"
// friendWrap: False
// fName: "simpleIntegrator"
// call: "casadi::simpleIntegrator(x0_)"
extern "C"
casadi::MXFunction*
    simpleIntegrator__0(std::string ** err_msg, casadi::Function* x0);
casadi::MXFunction*
    simpleIntegrator__0(std::string ** err_msg, casadi::Function* x0){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);

        casadi::MXFunction ret = casadi::simpleIntegrator(x0_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIntegrator" ===============
// cppName: "casadi::simpleIntegrator"
// cWrapperName: "simpleIntegrator__1"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, std::string* x1)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIntegrator__1(std::string ** err_msg, casadi::Function* x0, std::string* x1)"
// friendWrap: False
// fName: "simpleIntegrator"
// call: "casadi::simpleIntegrator(x0_, x1_)"
extern "C"
casadi::MXFunction*
    simpleIntegrator__1(std::string ** err_msg, casadi::Function* x0, std::string* x1);
casadi::MXFunction*
    simpleIntegrator__1(std::string ** err_msg, casadi::Function* x0, std::string* x1){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);

        casadi::MXFunction ret = casadi::simpleIntegrator(x0_, x1_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleIntegrator" ===============
// cppName: "casadi::simpleIntegrator"
// cWrapperName: "simpleIntegrator__2"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),Ref (Const StdString),Ref (Const (StdMap StdString (UserType (Namespace ["casadi"]) (Name "GenericType"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleIntegrator__2(std::string ** err_msg, casadi::Function* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2)"
// friendWrap: False
// fName: "simpleIntegrator"
// call: "casadi::simpleIntegrator(x0_, x1_, x2_)"
extern "C"
casadi::MXFunction*
    simpleIntegrator__2(std::string ** err_msg, casadi::Function* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2);
casadi::MXFunction*
    simpleIntegrator__2(std::string ** err_msg, casadi::Function* x0, std::string* x1, std::map< std::string, casadi::GenericType* >* x2){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        std::string& x1_ = Marshaling<std::string&,std::string*>::marshal(x1);
        std::map< std::string, casadi::GenericType > x2_ = Marshaling<std::map< std::string, casadi::GenericType >,std::map< std::string, casadi::GenericType* >*>::marshal(x2);

        casadi::MXFunction ret = casadi::simpleIntegrator(x0_, x1_, x2_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleRK" ===============
// cppName: "casadi::simpleRK"
// cWrapperName: "simpleRK__0"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0)"
// params: [UserType (Namespace ["casadi"]) (Name "Function")]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleRK__0(std::string ** err_msg, casadi::Function* x0)"
// friendWrap: False
// fName: "simpleRK"
// call: "casadi::simpleRK(x0_)"
extern "C"
casadi::MXFunction*
    simpleRK__0(std::string ** err_msg, casadi::Function* x0);
casadi::MXFunction*
    simpleRK__0(std::string ** err_msg, casadi::Function* x0){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);

        casadi::MXFunction ret = casadi::simpleRK(x0_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleRK" ===============
// cppName: "casadi::simpleRK"
// cWrapperName: "simpleRK__1"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleRK__1(std::string ** err_msg, casadi::Function* x0, int x1)"
// friendWrap: False
// fName: "simpleRK"
// call: "casadi::simpleRK(x0_, x1_)"
extern "C"
casadi::MXFunction*
    simpleRK__1(std::string ** err_msg, casadi::Function* x0, int x1);
casadi::MXFunction*
    simpleRK__1(std::string ** err_msg, casadi::Function* x0, int x1){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        casadi::MXFunction ret = casadi::simpleRK(x0_, x1_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simpleRK" ===============
// cppName: "casadi::simpleRK"
// cWrapperName: "simpleRK__2"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, int x1, int x2)"
// params: [UserType (Namespace ["casadi"]) (Name "Function"),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "MXFunction")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MXFunction*"
// proto: "casadi::MXFunction*\n    simpleRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2)"
// friendWrap: False
// fName: "simpleRK"
// call: "casadi::simpleRK(x0_, x1_, x2_)"
extern "C"
casadi::MXFunction*
    simpleRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2);
casadi::MXFunction*
    simpleRK__2(std::string ** err_msg, casadi::Function* x0, int x1, int x2){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::MXFunction ret = casadi::simpleRK(x0_, x1_, x2_);
        return WrapReturn< casadi::MXFunction*, casadi::MXFunction >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__22(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__38(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__39(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__40(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__41(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__42(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__43(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__44(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__45(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__59(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__60(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__61(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__62(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__63(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__64(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__65(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__66(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__67(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__68(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__69"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__69(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__70"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__70(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__70(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__70(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__71"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__72"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__73"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__74"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__75"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__76"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__77"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// friendWrap: False
// fName: "socpIn"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpOut__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__11(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__12(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__13(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__14(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__15(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__16(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__17(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__18(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__19(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__20(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    socpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    socpOut__21(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__22(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__23(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__24(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__25(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__26(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__27(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__28(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__29(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__30(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__31(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    socpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    socpOut__32(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__35(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__36(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__37(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__38(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__39(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__40(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__41(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__42(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__43(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__44(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    socpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "socpOut"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    socpOut__45(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpStruct__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "socpStruct"
// call: "casadi::socpStruct(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpStruct(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpStruct__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "socpStruct"
// call: "casadi::socpStruct(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpStruct(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpStruct__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "socpStruct"
// call: "casadi::socpStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpStruct__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "socpStruct"
// call: "casadi::socpStruct(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpStruct(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    socpStruct__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "socpStruct"
// call: "casadi::socpStruct(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    socpStruct__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::socpStruct(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__0"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__0(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__1"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__1(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__2"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__2(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__3"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__3(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__4"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__4(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__5"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__5(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__6"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__6(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__7"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__7(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__8"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__8(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__9"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__9(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__10"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__10(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__11"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__11(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__12"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__12(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__13"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__13(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__14"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__14(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__15"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__15(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__16"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__16(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__17"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__17(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__18"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__18(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__19"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__19(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__20"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__20(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__21"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__21(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__22"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "Sparsity")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "Sparsity"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23);
std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*
    stabilizedQpIn__22(std::string ** err_msg, std::string* x0, casadi::Sparsity* x1, std::string* x2, casadi::Sparsity* x3, std::string* x4, casadi::Sparsity* x5, std::string* x6, casadi::Sparsity* x7, std::string* x8, casadi::Sparsity* x9, std::string* x10, casadi::Sparsity* x11, std::string* x12, casadi::Sparsity* x13, std::string* x14, casadi::Sparsity* x15, std::string* x16, casadi::Sparsity* x17, std::string* x18, casadi::Sparsity* x19, std::string* x20, casadi::Sparsity* x21, std::string* x22, casadi::Sparsity* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::Sparsity& x1_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::Sparsity& x3_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::Sparsity& x5_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::Sparsity& x7_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::Sparsity& x9_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::Sparsity& x11_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::Sparsity& x13_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::Sparsity& x15_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::Sparsity& x17_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::Sparsity& x19_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::Sparsity& x21_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::Sparsity& x23_ = Marshaling<casadi::Sparsity&,casadi::Sparsity*>::marshal(x23);

        std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::Sparsity* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::Sparsity >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__23"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__23(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__24"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__24(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__25"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__25(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__26"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__26(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__27"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__27(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__28"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__28(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__29"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__29(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__30"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__30(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__31"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__31(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__32"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__32(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__33"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__33(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__34"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__34(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__35"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__35(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__36"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__36(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__37"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__37(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__38"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__38(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__39"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__39(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__40"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__40(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__41"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__41(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__42"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__42(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__43"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__43(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__44"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__44(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__45"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "DMatrix"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23);
std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*
    stabilizedQpIn__45(std::string ** err_msg, std::string* x0, casadi::DMatrix* x1, std::string* x2, casadi::DMatrix* x3, std::string* x4, casadi::DMatrix* x5, std::string* x6, casadi::DMatrix* x7, std::string* x8, casadi::DMatrix* x9, std::string* x10, casadi::DMatrix* x11, std::string* x12, casadi::DMatrix* x13, std::string* x14, casadi::DMatrix* x15, std::string* x16, casadi::DMatrix* x17, std::string* x18, casadi::DMatrix* x19, std::string* x20, casadi::DMatrix* x21, std::string* x22, casadi::DMatrix* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::DMatrix& x1_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::DMatrix& x3_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::DMatrix& x5_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::DMatrix& x7_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::DMatrix& x9_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::DMatrix& x11_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::DMatrix& x13_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::DMatrix& x15_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::DMatrix& x17_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::DMatrix& x19_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::DMatrix& x21_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::DMatrix& x23_ = Marshaling<casadi::DMatrix&,casadi::DMatrix*>::marshal(x23);

        std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::DMatrix* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::DMatrix >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__46"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__46(std::string ** err_msg, std::string* x0, casadi::MX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__47"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__47(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__48"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__48(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__49"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__49(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__50"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__50(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__51"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__51(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__52"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__52(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__53"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__53(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__54"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__54(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__55"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__55(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__56"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__56(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__57"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__57(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__58"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__58(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__59"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__59(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__60"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__60(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__61"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__61(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__62"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__62(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__63"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__63(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__64"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__64(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__65"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__65(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__66"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__66(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__67"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__67(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__68"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "MX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23);
std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__68(std::string ** err_msg, std::string* x0, casadi::MX* x1, std::string* x2, casadi::MX* x3, std::string* x4, casadi::MX* x5, std::string* x6, casadi::MX* x7, std::string* x8, casadi::MX* x9, std::string* x10, casadi::MX* x11, std::string* x12, casadi::MX* x13, std::string* x14, casadi::MX* x15, std::string* x16, casadi::MX* x17, std::string* x18, casadi::MX* x19, std::string* x20, casadi::MX* x21, std::string* x22, casadi::MX* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::MX& x1_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::MX& x3_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::MX& x5_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::MX& x7_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::MX& x9_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::MX& x11_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::MX& x13_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::MX& x15_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::MX& x17_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::MX& x19_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::MX& x21_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::MX& x23_ = Marshaling<casadi::MX&,casadi::MX*>::marshal(x23);

        std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::MX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::MX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__71"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__71(std::string ** err_msg, std::string* x0, casadi::SX* x1){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__72"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__72(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__73"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__73(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__74"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__74(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__75"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__75(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__76"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__76(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__77"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__77(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__78"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__78(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__79"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__79(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__80"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__80(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__81"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__81(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__82"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__82(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__83"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__83(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__84"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__84(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__85"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__85(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__86"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__86(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__87"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__87(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__88"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__88(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__89"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__89(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__90"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__90(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__91"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__91(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__92"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__92(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__93"
// protoArgs: "(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23)"
// params: [Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: StdPair (StdMap StdString (UserType (Namespace ["casadi"]) (Name "SX"))) (StdVec StdString)
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
// cWrapperRetType: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*"
// proto: "std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*\n    stabilizedQpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23)"
// friendWrap: False
// fName: "stabilizedQpIn"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_)"
extern "C"
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23);
std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*
    stabilizedQpIn__93(std::string ** err_msg, std::string* x0, casadi::SX* x1, std::string* x2, casadi::SX* x3, std::string* x4, casadi::SX* x5, std::string* x6, casadi::SX* x7, std::string* x8, casadi::SX* x9, std::string* x10, casadi::SX* x11, std::string* x12, casadi::SX* x13, std::string* x14, casadi::SX* x15, std::string* x16, casadi::SX* x17, std::string* x18, casadi::SX* x19, std::string* x20, casadi::SX* x21, std::string* x22, casadi::SX* x23){
    try {
        std::string& x0_ = Marshaling<std::string&,std::string*>::marshal(x0);
        casadi::SX& x1_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x1);
        std::string& x2_ = Marshaling<std::string&,std::string*>::marshal(x2);
        casadi::SX& x3_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x3);
        std::string& x4_ = Marshaling<std::string&,std::string*>::marshal(x4);
        casadi::SX& x5_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x5);
        std::string& x6_ = Marshaling<std::string&,std::string*>::marshal(x6);
        casadi::SX& x7_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x7);
        std::string& x8_ = Marshaling<std::string&,std::string*>::marshal(x8);
        casadi::SX& x9_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x9);
        std::string& x10_ = Marshaling<std::string&,std::string*>::marshal(x10);
        casadi::SX& x11_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x11);
        std::string& x12_ = Marshaling<std::string&,std::string*>::marshal(x12);
        casadi::SX& x13_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x13);
        std::string& x14_ = Marshaling<std::string&,std::string*>::marshal(x14);
        casadi::SX& x15_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x15);
        std::string& x16_ = Marshaling<std::string&,std::string*>::marshal(x16);
        casadi::SX& x17_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x17);
        std::string& x18_ = Marshaling<std::string&,std::string*>::marshal(x18);
        casadi::SX& x19_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x19);
        std::string& x20_ = Marshaling<std::string&,std::string*>::marshal(x20);
        casadi::SX& x21_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x21);
        std::string& x22_ = Marshaling<std::string&,std::string*>::marshal(x22);
        casadi::SX& x23_ = Marshaling<casadi::SX&,casadi::SX*>::marshal(x23);

        std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_, x13_, x14_, x15_, x16_, x17_, x18_, x19_, x20_, x21_, x22_, x23_);
        return WrapReturn< std::pair< std::map< std::string, casadi::SX* >*, std::vector< std::string* >* >*, std::pair< std::map< std::string, casadi::SX >, std::vector< std::string > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


